Scriptname pchsBeatPlayer extends Quest

Function BeginBeating(Actor akActor, String AtckType)
	Self.Start()
	Damage = 5.0
	HitCount = 0
	AttackType = AtckType
	PlayerRef.RemoveSpell(pchsBeatingSpell)
	PlayerRef.RemoveSpell(pchsBeatingHealthSpell)
	PlayerRef.AddSpell(pchsBeatingHealRateSpell, false)
	SpanksWereAllowed = Util.GetAreSpanksAllowed(akActor)
	If SpanksWereAllowed
		Util.ToggleSpanksOnActor(akActor, AllowSpanks = false)
	EndIf
	akActor.RemoveItem(zbfWeaponCane, 999)
	akActor.RemoveItem(pchsFakeWeapon, 999)
	If AttackType == "Beat"
		(Self.GetNthAlias(1) as ReferenceAlias).ForceRefTo(akActor)
		akActor.AddItem(pchsFakeWeapon)
	ElseIf AttackType == "Whip"
		(Self.GetNthAlias(2) as ReferenceAlias).ForceRefTo(akActor)
		akActor.AddItem(zbfWeaponCane)
	EndIf
	akActor.EvaluatePackage()

;/
	String AvToMonitor = "Health"
	If Menu.DamageHealth
		AvToMonitor = "Stamina"
	EndIf
	While PlayerRef.GetAv(AvToMonitor) > Menu.MinHealth + Damage
		Utility.Wait(1.0)
	EndWhile
	Shutdown()
	/;
EndFunction

Function PlayerCower()
	Debug.SendAnimationEvent(PlayerRef, "IdleCowering")
	Game.SetPlayerAiDriven(true)
	PlayerRef.SetVehicle(pchsMotherSlaveDogSexMarker)
EndFunction

Function AddBeatingSpell()
	PlayerRef.RestoreAv("Health", 99999.9)
	pchsBeatingLevel.SetValueInt(3)
	pchsBeatingHealthSpell.SetNthEffectMagnitude(0, PlayerRef.GetAv("Health") - Menu.MinHealth)
	PlayerRef.AddSpell(pchsBeatingSpell)
	If Menu.DamageHealth
		PlayerRef.AddSpell(pchsBeatingHealthSpell)
	EndIf
EndFunction

Function DecBeatingSpell()
	PlayerRef.RemoveSpell(pchsBeatingHealthSpell)

	If Menu.DamageHealth
		Utility.Wait(1.0)
		PlayerRef.RestoreAv("Health", 99999.9)
		PlayerRef.RemoveSpell(pchsBeatingHealRateSpell)
		
		Float Value
		If pchsBeatingLevel.GetValueInt() == 2
			Value = PlayerRef.GetAv("Health") - (Menu.MinHealth + 20.0)
		Else
			Value = PlayerRef.GetAv("Health") - (Menu.MinHealth + 50.0)
		EndIf
		If Value > 0.0
			pchsBeatingHealthSpell.SetNthEffectMagnitude(0, Value)
			PlayerRef.AddSpell(pchsBeatingHealthSpell, false)
		EndIf
		Utility.Wait(1.0)
	EndIf
	Game.GetPlayer().ModAv("CarryWeight", 0.01)
	Game.GetPlayer().ModAv("CarryWeight", -0.01)
	Debug.Notification("The pain from the beating Father gave me has eased a little")
EndFunction

Function Shutdown()
	Game.FadeOutGame(true, true, 0.0, 10.0)
	Utility.Wait(5.0)
	If AttackType == "Whip"
		Debug.Messagebox("Father whipped me until I lay nearly unconscious at his feet. Satisfied with my lesson he spits on me, as if to finish his point.\n\nAll I want now is to go to bed, squeeze Twinkle tight and cry myself to sleep.")
	Else
		Debug.Messagebox("Father beat me until I lay nearly unconscious at his feet. Satisfied with my lesson he spits on me, as if to finish his point.\n\nAll I want now is to go to bed, squeeze Twinkle tight and cry myself to sleep.")
	EndIf
	PlayerRef.RestoreAv("Health", 99999.9)
	pchsBeatingLevel.SetValueInt(3)
	AddBeatingSpell()
	PlayerRef.ModAv("CarryWeight", 0.01)
	PlayerRef.ModAv("CarryWeight", -0.01)
	Actor akActor = (Self.GetNthAlias(1) as ReferenceAlias).GetReference() as Actor
	If !akActor
		akActor = (Self.GetNthAlias(2) as ReferenceAlias).GetReference() as Actor
	EndIf
	akActor.RemoveItem(zbfWeaponCane, 999)
	akActor.RemoveItem(pchsFakeWeapon, 999)
	(Self.GetNthAlias(1) as ReferenceAlias).Clear()
	(Self.GetNthAlias(2) as ReferenceAlias).Clear()
	If SpanksWereAllowed
		Util.ToggleSpanksOnActor(akActor, AllowSpanks = true)
	EndIf
	akActor.EvaluatePackage()
	Game.SetPlayerAiDriven(false)
	PlayerRef.SetVehicle(None)
	Debug.SendAnimationEvent(PlayerRef, "PAHETieUpExit")
	Self.Stop()
EndFunction

Function PlayerHit()
	HitCount += 1
	If 50.0 > Utility.RandomFloat(0.0, 100.0)
		If AttackType == "Beat"
			SendModEvent("_SLS_AddTraumaToPlayer", "DoSound", 0.0)
		EndIf
		Game.ShakeCamera(akSource = None, afStrength = Utility.RandomFloat(0.2, 0.7), afDuration = Utility.RandomFloat(1.0, 3.0))
	EndIf
	
	If Menu.DamageHealth && PlayerRef.GetAv("Health") > Menu.MinHealth
		If PlayerRef.GetAv("Health") - Damage < Menu.MinHealth
			PlayerRef.DamageAv("Health", PlayerRef.GetAv("Health") - Menu.MinHealth)
		Else
			PlayerRef.DamageAv("Health", Damage)
		EndIf
	EndIf
	PlayerRef.DamageAv("Stamina", Damage)
	PlayerRef.DamageAv("Magicka", Damage)
	Damage += 1.0
	
	String AvToMonitor = "Stamina"
	If Menu.DamageHealth
		AvToMonitor = "Health"
	EndIf
	
	;Debug.Messagebox("HitCount: " + HitCount + "\nStat: " + PlayerRef.GetAv(AvToMonitor) + "\nThreshold: " + Menu.MinHealth + Damage)
	If HitCount >= 8 && PlayerRef.GetAv(AvToMonitor) < Menu.MinHealth + Damage
		Shutdown()
	EndIf
EndFunction

Bool SpanksWereAllowed

Int HitCount

String AttackType

Float Damage = 5.0

Weapon Property pchsFakeWeapon Auto
Weapon Property zbfWeaponCane Auto

Actor Property PlayerRef Auto

ObjectReference Property pchsMotherSlaveDogSexMarker Auto

GlobalVariable Property pchsBeatingLevel Auto

Spell Property pchsBeatingSpell Auto
Spell Property pchsBeatingHealthSpell Auto
Spell Property pchsBeatingHealRateSpell Auto

pchsWtUtil Property Util Auto
pchsWartimesMCM Property Menu Auto
