Scriptname pchsCarriageUtil extends Quest  

Event OnInit()
	If Self.IsRunning()
		If Game.GetModByName("CFTO.esp") != 255 ; Patch for stupidly incompatible mod...
			(GetNthAlias(0) as ReferenceAlias).ForceRefTo(Game.GetFormFromFile(0x0BBF6D, "CFTO.esp") as Actor)
		EndIf	
	EndIf
EndEvent

Function BeginPiercingsUpgrade(Int Level)
	Self.Start()
	Int GoldGift = (Piercings.GetPiercingsCostForLevel(Level) * PiercingsDiscount) as Int
	If GoldGift > 0
		PlayerRef.AddItem(Gold001, GoldGift * StorageUtil.GetFloatValue(None, "pchsWtFashionSupplement", Missing = 1.0) as Int)
	EndIf
	pchsPiercingsQueuedLevel.SetValueInt(Level)
	pchsPiercingsCooloff.SetValue(Utility.GetCurrentGameTime() + 2.0)
	pchsPiercingsQuest.Start()
	
	; Require new piercings and restart tasks after midnight
	Float CurTime = Utility.GetCurrentGameTime()
	
	SuspendTasks()
	
	Float HoursToUpdate = (Math.Ceiling(CurTime) - CurTime) * 24.0
	RegisterForSingleUpdateGameTime(HoursToUpdate)
EndFunction

Function Shutdown()
	pchsPiercingsNeeded.SetValue(pchsPiercingsQueuedLevel.GetValueInt())
	StorageUtil.FormListRemove(None, "_SLS_TempPassSolitude", Self, AllInstances = true)
	ResumeTasks()

	;Self.SetStage(0)
	Self.Stop()
EndFunction

Event OnUpdateGameTime()
	Shutdown()
EndEvent

Function SuspendTasks()
	Int TasksSuspend = ModEvent.Create("pchsWartimesTasksSuspend")
	If (TasksSuspend)
		ModEvent.PushForm(TasksSuspend, self)
		ModEvent.Send(TasksSuspend)
	EndIf
EndFunction

Function ResumeTasks()
	Int TasksResume = ModEvent.Create("pchsWartimesTasksResume")
	If (TasksResume)
		ModEvent.PushForm(TasksResume, self)
		ModEvent.Send(TasksResume)
	EndIf
EndFunction

Function TravelToSolitude()
	Game.FadeOutGame(true, true, 0.0, 4.0)
	ToggleSolCarObjects(EnableThem = true)
	StorageUtil.FormListAdd(None, "_SLS_TempPassSolitude", Self, AllowDuplicate = false)
	Self.SetStage(20)
	Utility.WaitMenuMode(2.0)
	PlayerRef.Moveto(SolCarObjects[0])
	Game.FadeOutGame(false, true, 0.0, 4.0)
	PassHours(4.0)
	Actor Bjorlam = (Self.GetNthAlias(0) as ReferenceAlias).GetReference() as Actor
	Bjorlam.MoveTo(PlayerRef, 120.0 * Math.Sin(PlayerRef.GetAngleZ()), 120.0 * Math.Cos(PlayerRef.GetAngleZ());/, PlayerRef.GetHeight() - 35.0/;)
	Bjorlam.EvaluatePackage()
EndFunction

Function TravelToWhiterun()
	Game.FadeOutGame(true, true, 0.0, 4.0)
	Utility.WaitMenuMode(2.0)
	PlayerRef.MoveTo(Game.GetFormFromFile(0x4E4BA, "Skyrim.esm") as ObjectReference)
	Game.FadeOutGame(false, true, 0.0, 4.0)
	PassHours(4.0)
	ToggleSolCarObjects(EnableThem = false)
	StorageUtil.FormListRemove(None, "_SLS_TempPassSolitude", Self, AllInstances = true)
	Actor Bjorlam = (Self.GetNthAlias(0) as ReferenceAlias).GetReference() as Actor
	Bjorlam.MoveToMyEditorLocation()
	Shutdown()
	Bjorlam.EvaluatePackage()
EndFunction

Function PassHours(Float Hours)
	Float Time = GameHour.GetValue()
	Time += Hours
	If Time > 23.99
		Time = 23.99
	EndIf
	GameHour.SetValue(Time)
EndFunction

Function ToggleSolCarObjects(Bool EnableThem)
	Int i = 0
	While i < SolCarObjects.Length
		If EnableThem
			SolCarObjects[i].Enable()
		Else
			SolCarObjects[i].Disable()
		EndIf
		i += 1
	EndWhile
EndFunction

Float Property PiercingsDiscount = 0.9 Auto Hidden

Quest Property pchsPiercingsQuest Auto

Actor Property PlayerRef Auto

GlobalVariable Property GameHour Auto
GlobalVariable Property pchsPiercingsNeeded Auto
GlobalVariable Property pchsPiercingsCooloff Auto
GlobalVariable Property pchsPiercingsQueuedLevel Auto

ObjectReference[] Property SolCarObjects Auto

MiscObject Property Gold001 Auto

pchsTossOut Property TossOut Auto
pchsPiercings Property Piercings Auto
