Scriptname pchsCellarPrison extends Quest  

Event OnUpdateGameTime()
	If Self.GetStage() == 30
		FinishPrisonHorseCum()
	ElseIf Self.GetCurrentStageID() == 10
		Self.SetStage(20)
		SetUpdateForTomorrowAt(6.0)
	ElseIf Self.GetCurrentStageID() == 100 || Self.GetCurrentStageID() == 120
		FinishPrisonApolFail()
	EndIf
EndEvent

Function SetUpdateForTomorrowAt(Float Hour)
	Float UpdateTime = ((Math.Ceiling(Utility.GetCurrentGameTime()) + (Hour / 24.0)) - Utility.GetCurrentGameTime()) * 24.0
	;Debug.Messagebox("UpdateTime: " + UpdateTime)
	RegisterForSingleUpdateGameTime(UpdateTime)
EndFunction

Function FinishPrisonHorseCum()
	InsideCellDoor.Lock(false)
	pchsDoorUnlocked.Play(InsideCellDoor)
	InsideCellDoor.BlockActivation(false)
	Debug.Notification("The door's been unlocked")
	HorseMilk.SetNextDeadline(1, 1)
	Util.ResumeTasks()
	ReturnItems()
	Self.Stop()
EndFunction

Function HorseCumImprisonment()
	Self.Start()
	TossOut.FatherAttack(DoTossOut = false, IsPermanent = false, SimpleSlavery = false, StripPlayer = false, MoveOutside = false, BlockLicences = false, BountyWhiterun = 0, BountyAll = 0, MsgBox = "Father grabs me by my neck viciously and drags me to the cellar door. I remember falling, pain, darkness and the sound of the door being locked>")
	InsideCellDoor.BlockActivation()
	OutsideCellDoor.Enable()
	PlayerRef.MoveTo(TeleportMarker)
	InsideCellDoor.Lock(true)
	InsideCellDoor.SetLockLevel(255)
	PlayerRef.RemoveItem(pchsBucketCumFull, 1, true)
	Strip()
	pchsCellarCumBucketFullRef.Enable()
	Self.SetStage(10)
	Util.SuspendTasks()
	Utility.Wait(1.0)
	pchsDoorUnlocked.Play(InsideCellDoor)
	SetUpdateForTomorrowAt(6.0)
EndFunction

Function BucketAct(Float FillLevel)
	If FillLevel == 0.5
			DrinkHalfCumBucket()
	Else
		DrinkFullCumBucket()
	EndIf
EndFunction

Function DrinkFullCumBucket()
	Util.SendCumSwallowEvent(pchsBrutus, TopUp = true)
	pchsCellarCumBucketFullRef.Disable()
	pchsCellarCumBucketHalfRef.Enable()
EndFunction

Function DrinkHalfCumBucket()
	Self.SetStage(30)
	Util.SendCumSwallowEvent(pchsBrutus, TopUp = true)
	pchsCellarCumBucketHalfRef.Disable()
	pchsHorseMilkTaskActive.SetValueInt(0)
EndFunction

Function CellarDoorActivate(ObjectReference akActionRef)
	pchsFatherCellarTact.Activate(PlayerRef)
EndFunction

Function Strip()
	Form akForm
	Int i = PlayerRef.GetNumItems()
	While i > 0
		i -= 1
		akForm = PlayerRef.GetNthForm(i)
		If akForm.GetName() && !akForm.HasKeyword(SexlabNoStrip) && akForm.IsPlayable()
			PlayerRef.RemoveItem(akForm, 999, true, pchsPrisonStripbox)
		EndIf
	EndWhile
EndFunction

Function ReturnItems()
	pchsPrisonStripbox.RemoveAllItems(PlayerRef, abKeepOwnership = true, abRemoveQuestItems = true)
EndFunction

Function ApologyFailImprisonment()
	Self.Start()
	TossOut.FatherAttack(DoTossOut = false, IsPermanent = false, SimpleSlavery = false, StripPlayer = false, MoveOutside = false, BlockLicences = false, BountyWhiterun = 0, BountyAll = 0, MsgBox = "Father grabs me by my neck viciously and drags me to the cellar door. I remember falling, pain, darkness and the sound of the door being locked>")
	InsideCellDoor.BlockActivation()
	OutsideCellDoor.Enable()
	PlayerRef.MoveTo(TeleportMarker)
	InsideCellDoor.Lock(true)
	InsideCellDoor.SetLockLevel(255)
	Strip()
	Self.SetStage(100)
	Util.SuspendTasks()
	Utility.Wait(1.0)
	pchsDoorUnlocked.Play(InsideCellDoor)
	SetUpdateForTomorrowAt(6.0)
EndFunction

Function FinishPrisonApolFail()
	InsideCellDoor.Lock(false)
	pchsDoorUnlocked.Play(InsideCellDoor)
	InsideCellDoor.BlockActivation(false)
	Debug.Notification("The door's been unlocked")
	Util.ResumeTasks()
	ReturnItems()
	Self.Stop()
EndFunction

Sound Property pchsDoorUnlocked Auto

Actor Property PlayerRef Auto
Actor Property pchsBrutus Auto

ObjectReference Property TeleportMarker Auto
ObjectReference Property InsideCellDoor Auto
ObjectReference Property OutsideCellDoor Auto
ObjectReference Property pchsCellarDropMarker Auto
ObjectReference Property pchsCellarCumBucketFullRef Auto
ObjectReference Property pchsCellarCumBucketHalfRef Auto
ObjectReference Property pchsFatherCellarTact Auto
ObjectReference Property pchsPrisonStripbox Auto

Keyword Property SexlabNoStrip Auto

MiscObject Property pchsBucketCumFull Auto

GlobalVariable Property pchsHorseMilkTaskActive Auto

pchsWtUtil Property Util Auto
pchsWtHorseMilk Property HorseMilk Auto
pchsTossOut Property TossOut Auto
