Scriptname pchsDoorLocking extends Quest  

Event OnInit()
	If Self.IsRunning()
		OnUpdateGameTime()
	EndIf
EndEvent

Event OnUpdateGameTime()
	SetLocks()
	SetNextUpdate()
EndEvent

Function SetNextUpdate()
	Utility.Wait(3.0)
	Int NewDay = GameDaysPassed.GetValue() as Int
	If NewDay > LastGameDay
		SetNewLockTimes()
		LastGameDay = NewDay
	EndIf
	
	If GameHour.GetValue() > LockHour || GameHour.GetValue() < UnLockHour ; Next update will be to unlock door
		RegisterForSingleUpdateGameTime(((GameDaysPassed.GetValue() + (UnLockHour / 24.0)) - GameDaysPassed.GetValue()) * 24.0)
		Debug.Messagebox("Next update to UNlock door")
	Else ; Next update will be to lock door
		RegisterForSingleUpdateGameTime(((GameDaysPassed.GetValue() + (LockHour / 24.0)) - GameDaysPassed.GetValue()) * 24.0)
		Debug.Messagebox("Next update to lock door")
	EndIf
EndFunction

Float Function GetHoursToNextUpdate(Float AtHour)
	
EndFunction

Function SetNewLockTimes()
	UnLockHour = Utility.RandomFloat(6.50, 7.50)
	LockHour = Utility.RandomFloat(22.50, 23.50)
EndFunction

Function SetLocks()
	If GameHour.GetValue() < UnLockHour || GameHour.GetValue() > LockHour
		InsideDoor.Lock(abLock = true, abAsOwner = false)
		InsideDoor.SetLockLevel(255)
		Debug.Messagebox("Lock door")
	Else
		InsideDoor.Lock(abLock = false, abAsOwner = false)
		Debug.Messagebox("UNLock door")
	EndIf
EndFunction

Int LastGameDay

Float LockHour
Float UnLockHour

ObjectReference Property InsideDoor Auto

GlobalVariable Property GameHour Auto
GlobalVariable Property GameDaysPassed Auto
