Scriptname pchsForbiddenItems extends Quest  

Event OnInit()
	If Self.IsRunning()
		CheckItems(PlayerRef)
		RemoveAllForbiddenItems(pchsPlayersLockerRef)
	EndIf
EndEvent

Function Setup()
	SetupContraceptionList()
	SetupAllList()
	RemoveAllForbiddenItems(PlayerRef)
EndFunction

Function StopFG()
	Actor akActor = (Self.GetNthAlias(0) as ReferenceAlias).GetReference() as Actor
	(Self.GetNthAlias(0) as ReferenceAlias).Clear()
	akActor.EvaluatePackage()
	pchsForbiddenItemGlob.SetValue(-1.0)
EndFunction

Function ContrapceptionPossessionFG()
	; FG end topic
	StopFG()
	RemoveAllForbiddenItems(PlayerRef)
EndFunction

Function ContrapceptionEquippedFG()
	; FG end topic
	StopFG()
	RemoveAllForbiddenItems(PlayerRef)
	Util.DrunkPunish()
EndFunction

Function PickupUpForbidden(Form akForm)
	SetApproach(akForm, false)
EndFunction

Function EquippedForbidden(Form akForm)
	SetApproach(akForm, true)
EndFunction

Function CheckItems(ObjectReference akContainer)
	Int i = akContainer.GetNumItems()
	Form akForm
	While i > 0
		i -= 1
		akForm = akContainer.GetNthForm(i)
		If pchsForbiddenItemsAll.HasForm(akForm)
			SetApproach(akForm, false)
		EndIf
	EndWhile
EndFunction

Function RemoveAllForbiddenItems(ObjectReference akContainer)
	Form akForm
	Int i = 0
	While i < pchsForbiddenItemsAll.GetSize()
		akForm = pchsForbiddenItemsAll.GetAt(i)
		If akContainer.GetItemCount(akForm) > 0
			akContainer.RemoveItem(akForm, 9999, false, pchsForbidItemsChest)
		EndIf
		i += 1
	EndWhile
EndFunction

Function SetApproach(Form akForm, Bool ItemEquipped)
	Int i = GetApproach(akForm)
	If i > -1
		If (i == 0 && ItemEquipped) || pchsForbiddenItemGlob.GetValueInt() == 1 ; Contrapception was used and not just picked up. Equipping is a greater 'crime' than picking up - don't overwrite
			pchsForbiddenItemGlob.SetValueInt(1)
		Else
			pchsForbiddenItemGlob.SetValueInt(i)
		EndIf
		(Self.GetNthAlias(0) as ReferenceAlias).ForceRefTo(pchsFather)
		pchsFather.EvaluatePackage()
	Else
		Debug.Trace("pchs: Approach failed. akForm: " + akForm.GetName() + " - " + akForm)
	EndIf
EndFunction

Int Function GetApproach(Form akForm)
	Int i = 0
	Formlist FlSelect
	While i < pchsForbiddenItemsListList.GetSize()
		If (pchsForbiddenItemsListList.GetAt(i) as Formlist).HasForm(akForm)
			Return i
		EndIf
		i += 1
	EndWhile
	Return -1
EndFunction

Function SetupAllList()
	pchsForbiddenItemsAll.Revert()
	Int i = 0
	Formlist FlSelect
	While i < pchsForbiddenItemsListList.GetSize()
		FlSelect = pchsForbiddenItemsListList.GetAt(i) as Formlist
		Int j = 0
		While j < FlSelect.GetSize()
			pchsForbiddenItemsAll.AddForm(FlSelect.GetAt(j))
			j += 1
		EndWhile
		i += 1
	EndWhile
EndFunction

Function SetupContraceptionList()
	Formlist pchsContraceptionPotions = pchsForbiddenItemsListList.GetAt(0) as Formlist ; pchsContraceptionPotions
	If Game.GetModByName("Fertility Mode.esm") != 255
		pchsContraceptionPotions.AddForm(Game.GetFormFromFile(0x0058D7, "Fertility Mode.esm")) ; _JSW_BB_PotionContraception
		pchsContraceptionPotions.AddForm(Game.GetFormFromFile(0x0058D9, "Fertility Mode.esm")) ; _JSW_BB_PotionAbort
		pchsContraceptionPotions.AddForm(Game.GetFormFromFile(0x0125F5, "Fertility Mode.esm")) ; _JSW_BB_PotionWashout
	EndIf
	If Game.GetModByName("BeeingFemale.esm") != 255
		pchsContraceptionPotions.AddForm(Game.GetFormFromFile(0x0038C9, "BeeingFemale.esm")) ; _BF_ContraceptionLow
		pchsContraceptionPotions.AddForm(Game.GetFormFromFile(0x0038CB, "BeeingFemale.esm")) ; _BF_ContraceptionMedium
		pchsContraceptionPotions.AddForm(Game.GetFormFromFile(0x00B4D5, "BeeingFemale.esm")) ; _BF_WashOutFluid75
		pchsContraceptionPotions.AddForm(Game.GetFormFromFile(0x00E55B, "BeeingFemale.esm")) ; _BF_WashOutFluid100
		pchsContraceptionPotions.AddForm(Game.GetFormFromFile(0x00E55D, "BeeingFemale.esm")) ; _BF_WashOutFluid60
		
		If Game.GetModByName("BeeingFemaleBasicAddOn.esp") != 255
			pchsContraceptionPotions.AddForm(Game.GetFormFromFile(0x006E86, "BeeingFemaleBasicAddOn.esp")) ; _BF_ContraceptionHighest
		EndIf
	EndIf
	;/ Nothing to see here
	If Game.GetModByName("HentaiPregnancy.esm") != 255
		pchsContraceptionPotions.AddForm(Game.GetFormFromFile(0x, ""))
	EndIf
	/;
EndFunction

Formlist Property pchsForbiddenItemsAll Auto
Formlist Property pchsForbiddenItemsListList Auto ; Correlates with pchsForbiddenItemGlob to decide the dialog approach type should I need it for more than just contraception items

GlobalVariable Property pchsForbiddenItemGlob Auto ; 0 - Contrapception possession, 1 - Contrapception equipped

ObjectReference Property pchsForbidItemsChest Auto
ObjectReference Property pchsPlayersLockerRef Auto

Actor Property PlayerRef Auto
Actor Property pchsFather Auto

pchsWtUtil Property Util Auto
