Scriptname pchsHairColour extends Quest  

Function BeginHairDemands()
	;RegisterForKey(21)
	RegForEvents()
	DemandNewHairColour()
	RegisterForSingleUpdateGameTime(24.0)
EndFunction

Function Shutdown()
	UnRegisterForUpdateGameTime()
	UnRegisterForAllModEvents()
	GoToState("")
EndFunction
;/
Event OnKeyDown(Int KeyCode)
	Debug.Messagebox("State: " + Self.GetState() + "\nIsComplying: " + IsComplying() + "\nIsHairRightColour: " + IsHairRightColour() + "\nIsHairFaded: " + IsHairFaded())
EndEvent
/;
Function RegForEvents()
	RegisterForModEvent("yps_HairDyeColourChange", "On_yps_HairDyeColourChange")
	RegisterForModEvent("yps_CanChangeHairColourEvent", "On_yps_CanChangeHairColourEvent")
	RegisterForModEvent("yps_CanRedyeHairEvent", "On_yps_CanRedyeHairEvent")
	RegisterForModEvent("yps_ShouldRedyeHairEvent", "On_yps_ShouldRedyeHairEvent")
EndFunction

Event OnUpdateGameTime()
	If pchsHairColourDemand.GetValue() == 0.0 && Utility.GetCurrentGameTime() > LastColourChange + ColourChangeCooloff
		If NewColourRequestChance > Utility.RandomFloat(0.0, 100.0)
			pchsHairColourDemand.SetValue(1.0)
			;DemandNewHairColour()
		EndIf
	EndIf
	RegisterForSingleUpdateGameTime(24.0)
EndEvent

Function DecideState()
	If IsHairRightColour()
		GoToState("")
	ElseIf !CanChangeColour()
		GoToState("ChangeRequestedCantChange")
	EndIf
EndFunction

State ChangeRequestedCantChange ; Can't change hair colour now
	Bool Function IsComplying()
		Return true
	EndFunction

	Event On_yps_CanChangeHairColourEvent(string eventName, string strArg, float numArg, Form sender)
		;Debug.Messagebox("Can redye hair: " + numArg)
		Debug.Messagebox("I can change my hair colour now. I'd better do as Father demands and get my hair colour changed to " + CurrentFavHair + " as soon as I can")
		GoToState("ChangeRequested")
	EndEvent
EndState



Event On_yps_HairDyeColourChange(string eventName, string strArg, float numArg, Form sender)
	LastColourChange = Utility.GetCurrentGameTime()
	DecideState()
	;Debug.Messagebox("Change hair colour: " + strArg + "\n" + numArg)
EndEvent

Event On_yps_CanChangeHairColourEvent(string eventName, string strArg, float numArg, Form sender)
	;Debug.Messagebox("Can change hair colour: " + numArg)
	If GetState() != ""
		DecideState()
	EndIf
EndEvent

Event On_yps_CanRedyeHairEvent(string eventName, string strArg, float numArg, Form sender)
	;Debug.Messagebox("Can redye hair: " + numArg)
EndEvent

Event On_yps_ShouldRedyeHairEvent(string eventName, string strArg, float numArg, Form sender)
	;Debug.Messagebox("Can redye hair: " + numArg)
	If numArg == 1.0 && IsHairRightColour()
		Debug.Messagebox("My " + CurrentFavHair + " hair colour has started to fade. I'd better go back and get it touched up for Father")
	EndIf
EndEvent

Function DemandNewHairColour()
	CurrentFavHair = GetRandomFavHairColour()
	If StorageUtil.GetIntValue(None, "yps_CanChangeHairColour", Missing = 1) == 1
		Debug.Messagebox("Father wants me to colour my hair " + CurrentFavHair)
	Else
		Debug.Messagebox("Father wants me to colour my hair " + CurrentFavHair + " but it's too soon to change my colour right now. I'll have to wait a while before going to get it changed")
	EndIf
	DecideState()
	pchsHairColourDemand.SetValue(0.0)
	Game.GetPlayer().AddItem(Game.GetFormFromFile(0xf, "Skyrim.esm"), 30 * StorageUtil.GetFloatValue(None, "pchsWtFashionSupplement", Missing = 1.0) as Int)
EndFunction

String Function GetRandomFavHairColour()
	; Copy list and remove current hair from selection
	String[] TempFavs = JsonUtil.StringListToArray("Wartimes/ImmersiveFashion.json", "fathersfavourites")
	StorageUtil.StringListCopy(Self, "FavsTemp", TempFavs)
	StorageUtil.StringListRemove(Self, "FavsTemp", CurrentFavHair)
	String NewFav = StorageUtil.StringListGet(Self, "FavsTemp", Utility.RandomInt(0, StorageUtil.StringListCount(Self, "FavsTemp") - 1))
	StorageUtil.StringListClear(Self, "FavsTemp")
	Return NewFav
EndFunction

Bool Function IsComplying()
	Return IsHairRightColour() && !IsHairFaded()
EndFunction

Bool Function CanChangeColour()
	Return StorageUtil.GetIntValue(None, "yps_CanChangeHairColour", Missing = 1) == 1
EndFunction

Bool Function IsHairRightColour()
	Return StorageUtil.GetStringValue(None, "yps_HairDyeColourName") == CurrentFavHair
EndFunction

Bool Function IsHairFaded()
	;Return StorageUtil.GetIntValue(None, "yps_CanRedyeHair", Missing = 0) == 1
	Return StorageUtil.GetIntValue(None, "yps_ShouldRedyeHair", Missing = 0)
EndFunction

Float Property ColourChangeCooloff = 3.0 Auto Hidden
Float Property LastColourChange = -999.9 Auto Hidden
Float Property NewColourRequestChance = 5.0 Auto Hidden

String Property CurrentFavHair Auto Hidden

GlobalVariable Property pchsHairColourDemand Auto
