Scriptname pchsPiercings extends Quest  

Event OnInit()
	If Self.IsRunning()
		(Self.GetNthAlias(0) as ReferenceAlias).ForceRefTo(Game.GetFormFromFile(0x01DCA7, "yps-ImmersivePiercing.esp") as Actor)
		RegisterForModEvent("yps_FashionChange", "On_yps_FashionChange")
		StorageUtil.SetIntValue(Self, "pchsPiercingsFirstTimeHelp", 1)
	EndIf
EndEvent

Event On_yps_FashionChange(string eventName, string strArg, float numArg, Form sender)
	If strArg == "Piercings" && IsProperlyPierced(pchsPiercingsQueuedLevel.GetValueInt()) ; Player is now pierced as Father wants
		Self.Stop()
	EndIf
EndEvent

Function DoPiercings()
	;Debug.Messagebox("Piercings Begin")
	Int PSlot
	String Level = "Level" + pchsPiercingsQueuedLevel.GetValueInt()
	String PiercingType
	Int i = 0
	Actor Tris = (Self.GetNthAlias(0) as ReferenceAlias).GetReference() as Actor
	While i < JsonUtil.StringListCount("Wartimes/Piercings.json", Level)
		PiercingType = JsonUtil.StringListGet("Wartimes/Piercings.json", Level, i)
		If !HasPiercing(PiercingType)
			PSlot = JsonUtil.GetIntValue("Wartimes/Piercings.json", PiercingType)
			Fashion.PierceMe(PSlot, Tris, PiercingType = 1)
			Utility.Wait(2.0)
			If Menu.WeldPiercings
				Utility.Wait(2.0)
				Fashion.WeldMe(PSlot, Tris)
			EndIf
		EndIf
		i += 1
	EndWhile
	
	Debug.Messagebox("After what seems an eternity Tris is finally finished my piercings. Thank the gods that's over with.\n\nThey do look pretty I must admit.")
	
	If StorageUtil.GetIntValue(Self, "pchsPiercingsFirstTimeHelp", Missing = -1) == 1
		StorageUtil.UnSetIntValue(Self, "pchsPiercingsFirstTimeHelp")
		Utility.Wait(2.0)
		Debug.Messagebox("Make sure your piercings are correct before returning to Whiterun. If piercings were blocked by clothes etc you can speak with Tris again")
	EndIf
	;/
	If Menu.WeldPiercings
		i = 0
		Utility.Wait(6.0)
		While i < JsonUtil.StringListCount("Wartimes/Piercings.json", Level)
			PSlot = JsonUtil.GetIntValue("Wartimes/Piercings.json", PiercingType)
			Fashion.WeldMe(PSlot, Tris)
			Utility.Wait(6.0)
			i += 1
		EndWhile
	EndIf
	/;
	
	;Debug.Messagebox("Piercings Finish")
EndFunction

Bool Function IsProperlyPierced(Int Level)
	String LevelStr = "Level" + Level
	Int i = 0
	Int Index
	While i < JsonUtil.StringListCount("Wartimes/Piercings.json", LevelStr)
		Index = JsonUtil.GetIntValue("Wartimes/Piercings.json", JsonUtil.StringListGet("Wartimes/Piercings.json", LevelStr, i))
		If StorageUtil.IntListGet(None, "yps_PiercingsStatus", Index) == 0
			If (JsonUtil.StringListGet("Wartimes/Piercings.json", LevelStr, i) == "nipples" && !Devious.IsWearingNipPiercings(PlayerRef))
				Return false
			ElseIf (JsonUtil.StringListGet("Wartimes/Piercings.json", LevelStr, i) == "clitoris" && !Devious.IsWearingClitPiercing(PlayerRef))
				Return false
			EndIf
		EndIf
		i += 1
	EndWhile
	Return true
EndFunction

Bool Function HasPiercing(String Type)
	Int Index = JsonUtil.GetIntValue("Wartimes/Piercings.json", Type)
	If StorageUtil.IntListGet(None, "yps_PiercingsStatus", Index) == 1
		Return true
	EndIf
	Return false
EndFunction

Bool Function IsWearingNipPiercings()
	Return HasPiercing("nipples")
EndFunction

Bool Function IsWearingClitPiercing()
	Return HasPiercing("clitoris")
EndFunction

Int Function GetNumPiercingsForLevel(Int Level)
	Return JsonUtil.StringListCount("Wartimes/Piercings.json", "Level" + Level) - JsonUtil.StringListCount("Wartimes/Piercings.json", "Level" + (Level - 1))
EndFunction

Int Function GetPiercingsCostForLevel(Int Level)
	Return Fashion.GetPiercingCost() * GetNumPiercingsForLevel(Level)
EndFunction

Actor Property PlayerRef Auto

GlobalVariable Property pchsPiercingsNeeded Auto
GlobalVariable Property pchsPiercingsQueuedLevel Auto

pchsWtInterfaceDevious Property Devious Auto
pchsWtInterfaceFashion Property Fashion Auto
pchsWartimesMCM Property Menu Auto
