Scriptname pchsSupplyRunPlayerAlias extends ReferenceAlias  

Event OnInit()
	GoToState("")
EndEvent

Function BeginNakedTracking()
	SetIsAnonymous()
	GoToState("Active")
EndFunction

Function StopNakedTracking()
	pchsSupplyRunNpcScan.Stop()
	UnRegisterForUpdate()
	GoToState("")
EndFunction

Event OnBeginState()
	pchsSupplyRunNpcScan.Stop()
	UnRegisterForUpdate()
EndEvent

Event OnUpdate()
EndEvent

Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
EndEvent

Event OnObjectUnEquipped(Form akBaseObject, ObjectReference akReference)
EndEvent

State Active
	Event OnBeginState()
		RegisterForSingleUpdate(5.0)
	EndEvent
	
	Event OnUpdate()
		If pchsSupplyRunAnonymous.GetValue() == 1
			GetSpectators()
		EndIf
		RegisterForSingleUpdate(5.0)
	EndEvent
	
	Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
		SetIsAnonymous()
	EndEvent

	Event OnObjectUnEquipped(Form akBaseObject, ObjectReference akReference)
		SetIsAnonymous()
	EndEvent
EndState

Bool Function IsBodyCovered()
	Form akForm = PlayerRef.GetWornForm(0x00000004)
	If akForm && (akForm.HasKeyword(ClothingBody) || akForm.HasKeyword(ArmorCuirass))
		Return true
	EndIf
	Return false
EndFunction

Function SetIsAnonymous()
	If !InProc
		InProc = true
		If !IsBodyCovered() ; Naked
			If Devious.IsHooded(PlayerRef) || PlayerRef.WornHasKeyword(zbfWornHood)
				pchsSupplyRunAnonymous.SetValue(2)
				UnRegisterForUpdate()
			Else
				pchsSupplyRunAnonymous.SetValue(1)
				RegisterForSingleUpdate(0.1)
			EndIf
		Else ; Not Naked
			pchsSupplyRunAnonymous.SetValue(0)
			UnRegisterForUpdate()
		EndIf
		InProc = false
	EndIf
EndFunction

Function GetSpectators()
	pchsSupplyRunNpcScan.Stop()
	pchsSupplyRunNpcScan.Start()
	Actor Npc
	Int i = 0
	While i < pchsSupplyRunNpcScan.GetNumAliases()
		Npc = (pchsSupplyRunNpcScan.GetNthAlias(i) as ReferenceAlias).GetReference() as Actor
		If Npc
			NpcSawPlayerNaked(Npc)
		EndIf
		i += 1
	EndWhile
EndFunction

Function NpcSawPlayerNaked(Actor Npc)
	StorageUtil.FormListAdd(None, "pchsSupplyRunNakedSpectators", Npc)
	Npc.AddToFaction(pchsSawPlayerNakedFact)
	pchsSupplyRunNakedSpecCount.Mod(1)
	;Debug.Notification(Npc.GetLeveledActorBase().GetName() + " saw me naked!")
	SupplyRun.SetReputation(Npc)
	If pchsSupplyRunNakedSpecCount.GetValue() >= 15.0 ; Stop at max
		UnRegisterForUpdate()
		GoToState("")
	EndIf
EndFunction

Bool InProc = false

GlobalVariable Property pchsSupplyRunAnonymous Auto ; 0 - Not naked No Hood, 1 - Naked No hood, , 2 - Naked & hooded
GlobalVariable Property pchsSupplyRunNakedSpecCount Auto

Keyword Property zbfWornHood Auto
Keyword Property ClothingBody Auto
Keyword Property ArmorCuirass Auto

Quest Property pchsSupplyRunNpcScan Auto

Faction Property pchsSawPlayerNakedFact Auto

Actor Property PlayerRef Auto

pchsWtInterfaceDevious Property Devious Auto
pchsSupplyRun Property SupplyRun Auto

