Scriptname pchsWartimesPlayerScript extends Alias  

Event OnInit()
	If Self.GetOwningQuest().IsRunning()
		StorageUtil.SetFloatValue(None, "pchsWartimesTweakVersion", 10.3)
		StorageUtil.SetIntValue(None, "pchsWtMakeFatherSlsAsshole", 1)
		StorageUtil.SetIntValue(None, "pchsWtCumSlutIntro", 1)
		CumSlutData = new Float[7]
		;RegisterForUpdateGameTime(1.00)
		ExcludeMotherFromSlac()
		wartimesQuestStatus.SetValue(1)
		Menu.ToggleLiceneceBlocking()
		StorageUtil.SetIntValue(None, "pchsWtWartimesHomeAccess", 1)
		StorageUtil.FormListAdd(None, "_SLS_FashionRapeExclusions", FatherRef)
		StorageUtil.SetIntValue(None, "pchsWtInspectStanceHelp", 1)
		StorageUtil.SetIntValue(None, "pchsWtSensitivityHelp", 1)
		
		;StorageUtil.SetIntValue((Game.GetFormFromFile(0x5960, "pchsWartimes.esp")) as ObjectReference, "_SLS_StashExceptionContainer", 1) ; pchsPlayersLockerRef
		;StorageUtil.SetIntValue((Game.GetFormFromFile(0x456229, "pchsWartimes.esp")) as ObjectReference, "_SLS_StashExceptionContainer", 1) ; pchsFirewoodPileRef
		Utility.Wait(5.0) ; Wait for SLS API to register for events
		; Add containers to stash exceptions instead of just setting the int so they show up as exceptions in SLS MCM.
		Util.AddSlsStashException(pchsFirewoodPileRef)
		Util.AddSlsStashException(Game.GetFormFromFile(0x5960, "pchsWartimes.esp") as ObjectReference) ; pchsPlayersLockerRef
		Util.AddFoodConfiscationExceptions()
		(Game.GetFormFromFile(0x61DE6E, "pchsWartimes.esp") as pchsForbiddenItems).Setup() ; pchsForbiddenItemsQuest
		SupplyRun.SetupSpecialStock()
	EndIf
EndEvent

Function RegForEvents()
	RegisterForModEvent("pchsWartimesTasksSuspend", "On_pchsWartimesTasksSuspend")
	RegisterForModEvent("pchsWartimesTasksResume", "On_pchsWartimesTasksResume")
	RegisterForModEvent("PCSubFree", "_On_SD_PCSubFree")
	RegisterForModEvent("SDEnslavedStart", "_On_SD_SDEnslavedStart")
EndFunction

Event On_pchsWartimesTasksSuspend(Form SuspendForm)
	;/
	Suspend regular WT tasks
	Int TasksSuspend = ModEvent.Create("pchsWartimesTasksSuspend")
	If (TasksSuspend)
		ModEvent.PushForm(TasksSuspend, self)
		ModEvent.Send(TasksSuspend)
	EndIf
	/;

	Debug.Trace("pchs: pchsWartimesTasksSuspend event. Form: " + SuspendForm)
	StorageUtil.FormListAdd(None, "pchsWartimesTasksSuspendForms", SuspendForm, AllowDuplicate = false)
	If StorageUtil.GetFloatValue(None, "pchsWtTasksSuspendTime", Missing = -1.0) == -1.0 ; If suspend start time is already set do not overwrite
		StorageUtil.SetFloatValue(None, "pchsWtTasksSuspendTime", Utility.GetCurrentGameTime())
	EndIf
	StorageUtil.SetIntValue(None, "pchsWartimesTasksWereSuspended", 1)
	;Debug.Messagebox(StorageUtil.FormListToArray(None, "pchsWartimesTasksSuspendForms"))
EndEvent

Event On_pchsWartimesTasksResume(Form SuspendForm)
	;/
	Resume regular WT tasks
	Must send the same form you used to suspend tasks
	
	Int TasksResume = ModEvent.Create("On_pchsWartimesTasksResume")
	If (TasksResume)
		ModEvent.PushForm(TasksResume, self)
		ModEvent.Send(TasksResume)
	EndIf
	/;
	
	Debug.Trace("pchs: pchsWartimesTasksResume event. Form: " + SuspendForm)
	StorageUtil.FormListRemove(None, "pchsWartimesTasksSuspendForms", SuspendForm)
	If StorageUtil.FormListCount(None, "pchsWartimesTasksSuspendForms") == 0
		RestartTasks()
		OnUpdateGameTime()
	EndIf
	;Debug.Messagebox(StorageUtil.FormListToArray(None, "pchsWartimesTasksSuspendForms"))
EndEvent

Event _On_SD_SDEnslavedStart(string eventName, string strArg, float numArg, Form sender)
	Actor Sanguine = Game.GetFormFromFile(0x03F498, "sanguinesDebauchery.esp") as Actor
	StorageUtil.SetFloatValue(None, "pchsWtSdEnslaveStartTime", Utility.GetCurrentGameTime())
	On_pchsWartimesTasksSuspend(Sanguine)
EndEvent

Event _On_SD_PCSubFree(string eventName, string strArg, float numArg, Form sender)
	Utility.Wait(3.0)
	Actor Sanguine = Game.GetFormFromFile(0x03F498, "sanguinesDebauchery.esp") as Actor
	On_pchsWartimesTasksResume(Sanguine)
EndEvent

Function RestartTasks()
	Float Difference = Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(None, "pchsWtTasksSuspendTime")
	Float DifferenceInHours = Difference * 24.0
	StorageUtil.UnSetFloatValue(None, "pchsWtTasksSuspendTime")
	FatherHungerLastMeal.Mod(Difference)
	FatherThirstLastDrink.Mod(Difference)
	FatherSexTimestamp.Mod(Difference)
	pchsAldoSexTimestamp.Mod(Difference)
	dirtLastClean.Mod(Difference)
	motherHealthTimestampGlobal.Mod(Difference)
	pchsFatherMilkTimestamp.Mod(Difference)
	pchsFatherCumSlutTimestamp.Mod(Difference)
	FatherForcegreetGlobalTimestamp.Mod(Difference)
	If pchsHorseMilkDeadline.GetValue() != -1.0
		pchsHorseMilkDeadline.Mod(Difference)
	EndIf
	
	pchsFirewoodPileRef.AddItem(Firewood01, DifferenceInHours as Int) ; pchsFirewoodPileRef
	
	If (pchsSupplyRunNext.GetValue() + ((1.0 / 24.0) * 8.0)) - Utility.GetCurrentGameTime() <= 0.1667 ; Less than four hours remaining
		SupplyRun.SetupNextSupplyRun(1.0, false) ; Postpone to tomorrow
	EndIf
EndFunction

Event OnPlayerLoadGame()
	VersionCheck()
	pchsMmeInstalled.SetValueInt((Game.GetModByName("MilkModNEW.esp") != 255) as Int)
	If pchsMmeInstalled.GetValueInt()
		Keyword MME_Milk = Game.GetFormFromFile(0x06D61F, "MilkModNEW.esp") as Keyword
		Util.SetMilkdKeyword(MME_Milk)
		(Game.GetFormFromFile(0x1A54E5, "pchsWartimes.esp") as Formlist).AddForm(MME_Milk) ; pchsMilkFilterList
	Else
		Util.SetMilkdKeyword(None)
	EndIf
	
	If Game.GetModByName("SL Survival.esp") != 255
		Keyword _SLS_CumPotion = Game.GetFormFromFile(0x1179C5, "SL Survival.esp") as Keyword
		(Game.GetFormFromFile(0x1F141E, "pchsWartimes.esp") as Formlist).AddForm(_SLS_CumPotion) ; pchsCumFilterList
		pchsSlsInstalled.SetValueInt(1)
	Else
		pchsSlsInstalled.SetValueInt(0)
	EndIf
	Util.PlayerLoadsGame()
	SetBelethorsDog()
	SendModEvent("_pchs_Int_PlayerLoadsGame")
EndEvent

Function VersionCheck()
	If StorageUtil.GetFloatValue(None, "pchsWartimesTweakVersion") < 10.3
		If StorageUtil.GetFloatValue(None, "pchsWartimesTweakVersion") < 1.9
			UnRegisterForAllModEvents()
			StorageUtil.SetFloatValue(None, "pchsWartimesTweakVersion", 1.9)
			Debug.Notification("Wartimes Tweak v1.9")
		EndIf
		If StorageUtil.GetFloatValue(None, "pchsWartimesTweakVersion") < 2.6
			((Game.GetFormFromFile(0x5A17, "pchsWartimes.esp") as Quest).GetNthAlias(14) as ReferenceAlias).ForceRefTo(Game.GetFormFromFile(0x20A949, "pchsWartimes.esp") as Actor)
			StorageUtil.SetIntValue(None, "pchsWtCumSlutIntro", 1)
			CumSlutData = new Float[7]
			Menu.BaseFavourLoss = -1
			Fav.Setup()
			StorageUtil.SetFloatValue(None, "pchsWartimesTweakVersion", 2.6)
			Debug.Notification("Wartimes Tweak v2.6")
		EndIf
		If StorageUtil.GetFloatValue(None, "pchsWartimesTweakVersion") < 2.9
			Devious.RestartInterface()
			ThisQuest.UpdateCurrentInstanceGlobal(Menu.pchsSlsLicenceCost)
			ThisQuest.UpdateCurrentInstanceGlobal(Menu.pchsSlsLicenceCostClothes)
			ThisQuest.UpdateCurrentInstanceGlobal(Menu.pchsDdRemCost)
			StorageUtil.SetFloatValue(None, "pchsWartimesTweakVersion", 2.9)
			Debug.Notification("Wartimes Tweak v2.9")
		EndIf
		If StorageUtil.GetFloatValue(None, "pchsWartimesTweakVersion") < 3.8
			StorageUtil.SetIntValue(None, "pchsWtMakeFatherSlsAsshole", 1)
			Menu.pchsJobBondage = Game.GetFormFromFile(0x293598, "pchsWartimes.esp") as GlobalVariable
			Devious.RestartInterface()
			;Fav.SetupSexTags()
			Apol.Devious = Devious
			Quest akSupplyRunQuest = Game.GetFormFromFile(0x25B9C5, "pchsWartimes.esp") as Quest
			If !akSupplyRunQuest.IsRunning() && pchsSupplyRuns.GetValue() == 1.0
				akSupplyRunQuest.Start()
			EndIf
			ExcludeMotherFromSlac()
			Quest akpchsCumSlutQuest = Game.GetFormFromFile(0x1F140F, "pchsWartimes.esp") as Quest
			If akpchsCumSlutQuest.IsRunning()
				(akpchsCumSlutQuest.GetNthAlias(2) as ReferenceAlias).ForceRefTo(PlayerRef)
			EndIf
			StorageUtil.SetFloatValue(None, "pchsWartimesTweakVersion", 3.8)
			Debug.Notification("Wartimes Tweak v3.8")
		EndIf
		If StorageUtil.GetFloatValue(None, "pchsWartimesTweakVersion") < 3.9
			ExcludeMotherFromSlac()
			StorageUtil.SetFloatValue(None, "pchsWartimesTweakVersion", 3.9)
			Debug.Notification("Wartimes Tweak v3.9")
		EndIf

		If StorageUtil.GetFloatValue(None, "pchsWartimesTweakVersion") < 4.2
			StorageUtil.SetFloatValue(None, "pchsWartimesTweakVersion", 4.2)
			If ThisQuest.GetStage() <= 200
				StorageUtil.SetIntValue(None, "pchsWtWartimesHomeAccess", 1)
			EndIf
			ThisQuest.UpdateCurrentInstanceGlobal(pchsMHealCost)
			Debug.Notification("Wartimes Tweak v4.2")
		EndIf
		
		If StorageUtil.GetFloatValue(None, "pchsWartimesTweakVersion") < 5.0
			Utility.Wait(3.0)
			StorageUtil.SetFloatValue(None, "pchsWartimesTweakVersion", 5.0)
			Devious.GoToState("")
			Devious.PlayerLoadsGame()
			Menu.BuildMenuArrays()
			Util.pchsDummyNeverUsedKw = Game.GetFormFromFile(0x2CB0B5, "pchsWartimes.esp") as Keyword
			Apol.BuildArrays()
			
			; Sanitize PcGave variables (0 - x instead of -1 to x)
			GlobalVariable PcGaveVar = Game.GetFormFromFile(0x0D5A26, "pchsWartimes.esp") as GlobalVariable ; pchsPCGaveAnal
			PcGaveVar.SetValueInt(PapyrusUtil.ClampInt(PcGaveVar.GetValueInt(), 0, 99999))
			PcGaveVar = Game.GetFormFromFile(0x0A805D, "pchsWartimes.esp") as GlobalVariable ; pchsPCGaveBlowjob
			PcGaveVar.SetValueInt(PapyrusUtil.ClampInt(PcGaveVar.GetValueInt(), 0, 99999))
			PcGaveVar = Game.GetFormFromFile(0x0D5A24, "pchsWartimes.esp") as GlobalVariable ; pchsPCGaveHandjob
			PcGaveVar.SetValueInt(PapyrusUtil.ClampInt(PcGaveVar.GetValueInt(), 0, 99999))
			PcGaveVar = Game.GetFormFromFile(0x0D5A23, "pchsWartimes.esp") as GlobalVariable ; pchsPCGaveMassage
			PcGaveVar.SetValueInt(PapyrusUtil.ClampInt(PcGaveVar.GetValueInt(), 0, 99999))
			PcGaveVar = Game.GetFormFromFile(0x0D5A27, "pchsWartimes.esp") as GlobalVariable ; pchsPCGaveRough
			PcGaveVar.SetValueInt(PapyrusUtil.ClampInt(PcGaveVar.GetValueInt(), 0, 99999))
			PcGaveVar = Game.GetFormFromFile(0x0D5A25, "pchsWartimes.esp") as GlobalVariable ; pchsPCGaveVaginal
			PcGaveVar.SetValueInt(PapyrusUtil.ClampInt(PcGaveVar.GetValueInt(), 0, 99999))
			If ThisQuest.GetStage() == 200
				RegForEvents()
			EndIf
			Fav.CurMaxDisfavour = -10
			Menu.ToggleLiceneceBlocking()
			If ThisQuest.GetStage() <= 200
				StorageUtil.SetIntValue(None, "pchsWtWartimesHomeAccess", 1)
			EndIf

			If Menu.HairColour.pchsHairColourDemand.GetValue() > -1
				Menu.HairColour.RegForEvents()
				Menu.HairColour.pchsHairColourDemand.SetValue(1.0)
				Menu.HairColour.DecideState()
				Menu.HairColour.UnRegisterForAllKeys()
			EndIf
			StorageUtil.SetIntValue(None, "pchsWtRecordedHairLenght", StorageUtil.GetIntValue(None, "YpsCurrentHairLengthStage"))
			Debug.Notification("Wartimes Tweak v5.0")
		EndIf
		
		If StorageUtil.GetFloatValue(None, "pchsWartimesTweakVersion") < 5.2
			StorageUtil.SetFloatValue(None, "pchsWartimesTweakVersion", 5.2)
			ReferenceAlias HomeMarkerAlias = ThisQuest.GetAliasByName("HomeMarker") as ReferenceAlias
			HomeMarkerAlias.ForceRefTo(Game.GetFormFromFile(0x12BC65, "pchsWartimes.esp") as ObjectReference)
			(HomeMarkerAlias as pchsWtRandomHomeSex).OnInit()
			Debug.Notification("Wartimes Tweak v5.2")
		EndIf
		
		If StorageUtil.GetFloatValue(None, "pchsWartimesTweakVersion") < 5.5
			StorageUtil.SetFloatValue(None, "pchsWartimesTweakVersion", 5.5)
			Quest FashionInt = Game.GetFormFromFile(0x2EE7FC, "pchsWartimes.esp") as Quest
			FashionInt.Stop()
			FashionInt.Start()
			Utility.Wait(1.0)
			(FashionInt as pchsWtInterfaceFashion).PlayerLoadsGame()
			If pchsFashionNeeded.GetValue() >= 1.0
				(FashionInt as pchsWtInterfaceFashion).ToggleMirror(true)
			EndIf
			Menu.HomeSex.AldoMarker = Game.GetFormFromFile(0x20A947, "pchsWartimes.esp") as ObjectReference
			(ThisQuest.GetNthAlias(15) as pchsWtRandomHomeSex).OnInit()
			Debug.Notification("Wartimes Tweak v5.5")
		EndIf
		
		If StorageUtil.GetFloatValue(None, "pchsWartimesTweakVersion") < 6.3
			StorageUtil.SetFloatValue(None, "pchsWartimesTweakVersion", 6.3)
			Util.pchsUngiftedOutfitsThisLevelCount = Game.GetFormFromFile(0x42D934, "pchsWartimes.esp") as GlobalVariable
			Apol.SetBoundaryThresholdBeast()
			Apol.SetBoundaryThreshold()
			
			ObjectReference Blade = Game.GetFormFromFile(0x59C1, "pchsWartimes.esp") as ObjectReference ; Father's sword
			If Blade
				(ThisQuest.GetNthAlias(16) as ReferenceAlias).ForceRefTo(Blade)
			EndIf
			Blade = Game.GetFormFromFile(0x59E2, "pchsWartimes.esp") as ObjectReference ; Father's dagger
			If Blade
				(ThisQuest.GetNthAlias(17) as ReferenceAlias).ForceRefTo(Blade)
			EndIf
			If (Game.GetFormFromFile(0x3EBBCD, "pchsWartimes.esp") as GlobalVariable).GetValue() ; pchsBuildHarem
				HomeSlaves.ToggleSlaveBeds(true)
			EndIf
			Menu.HomeSex.BuildArrays()
			StorageUtil.FormListAdd(None, "_SLS_FashionRapeExclusions", FatherRef)
			If (Game.GetFormFromFile(0xC1599, "pchsWartimes.esp") as GlobalVariable).GetValueInt() == 1 ; pchsFatherAskedPCNaked
				Util.pchsRequiredOutfitLevel.SetValueInt(100)
			ElseIf (Game.GetFormFromFile(0xC159D, "pchsWartimes.esp") as GlobalVariable).GetValueInt() == 1 ; pchsGotMaidClothes
				Util.pchsRequiredOutfitLevel.SetValueInt(0)
			EndIf
			Util.SetUngiftedOutfitsThisLevelCount()
			Quest akpchsCumSlutQuest = Game.GetFormFromFile(0x1F140F, "pchsWartimes.esp") as Quest
			(akpchsCumSlutQuest.GetNthAlias(1) as pchsFatherCumFilter).Util = Util
			Debug.Notification("Wartimes Tweak v6.3")
		EndIf
		
		If StorageUtil.GetFloatValue(None, "pchsWartimesTweakVersion") < 6.4
			StorageUtil.SetFloatValue(None, "pchsWartimesTweakVersion", 6.4)
			If Game.GetModByName("paradise_halls.esm") == 255
				(Game.GetFormFromFile(0x3EBBCD, "pchsWartimes.esp") as GlobalVariable).SetValueInt(0) ; pchsBuildHarem
				HomeSlaves.ToggleSlaveBeds(false)
			EndIf
			Debug.Notification("Wartimes Tweak v6.4")
		EndIf
		
		If StorageUtil.GetFloatValue(None, "pchsWartimesTweakVersion") < 6.6
			StorageUtil.SetFloatValue(None, "pchsWartimesTweakVersion", 6.6)
			StorageUtil.SetIntValue(None, "pchsWtInspectStanceHelp", 1)
			Menu.BuildMenuArrays()
			Util.BuildArrays()
			Util.SetOutfitLevels()
			Debug.Notification("Wartimes Tweak v6.6")
		EndIf
		
		If StorageUtil.GetFloatValue(None, "pchsWartimesTweakVersion") < 6.9
			StorageUtil.SetFloatValue(None, "pchsWartimesTweakVersion", 6.9)
			StorageUtil.SetFloatValue(None, "pchsWtLastTaskUpdate", Utility.GetCurrentGameTime())
			Util.RemoveDuplicateFormsFromAccessories()
			;StorageUtil.SetIntValue((Game.GetFormFromFile(0x456229, "pchsWartimes.esp")) as ObjectReference, "_SLS_StashExceptionContainer", 1) ; pchsFirewoodPileRef
			;(Game.GetFormFromFile(0x59B6, "pchsWartimes.esp") as ObjectReference).Disable() ; Static firewood pile
			Debug.Notification("Wartimes Tweak v6.9")
		EndIf
		
		If StorageUtil.GetFloatValue(None, "pchsWartimesTweakVersion") < 7.3
			StorageUtil.SetFloatValue(None, "pchsWartimesTweakVersion", 7.3)
			Menu.SetFatherCockSize()
			Menu.Sos.SetSize((Game.GetFormFromFile(0xB737D, "pchsWartimes.esp") as Actor), 20) ; Jazeem
			StorageUtil.SetIntValue(None, "pchsWtSensitivityHelp", 1)
			Quest akWartimesQuest = Self.GetOwningQuest()
			akWartimesQuest.UpdateCurrentInstanceGlobal(Menu.ToffGlobs[0])
			akWartimesQuest.UpdateCurrentInstanceGlobal(Menu.ToffGlobs[1])
			akWartimesQuest.UpdateCurrentInstanceGlobal(Menu.ToffGlobs[2])
			akWartimesQuest.UpdateCurrentInstanceGlobal(Menu.ToffGlobs[3])
			pchsHomeCumMonitor CumMonitor = ((Game.GetFormFromFile(0x1F140F, "pchswartimes.esp") as Quest).GetNthAlias(2) as pchsHomeCumMonitor)
			CumMonitor.Util = Util
			CumMonitor.pchsDummyNeverUsedKw = Util.pchsDummyNeverUsedKw
			Debug.Notification("Wartimes Tweak v7.3")
		EndIf
		
		If StorageUtil.GetFloatValue(None, "pchsWartimesTweakVersion") < 8.0
			StorageUtil.SetFloatValue(None, "pchsWartimesTweakVersion", 8.0)
			Devious.RestartInterface()
			Self.GetOwningQuest().UpdateCurrentInstanceGlobal(Menu.pchsBuyOut)
			Menu.BuildMenuArrays()
			;(Game.GetFormFromFile(0xFC2C, "pchsWartimes.esp") as ObjectReference).MoveToMyEditorLocation() ; Bedroom Shackles deleted to make space for alchemy table
			(Game.GetFormFromFile(0x59B4, "pchsWartimes.esp") as ObjectReference).MoveToMyEditorLocation()
			ObjectReference pchsRecordRoomClutterRef = Game.GetFormFromFile(0x525BED, "pchsWartimes.esp") as ObjectReference
			pchsRecordRoomClutterRef.Disable()
			pchsRecordRoomClutterRef.Delete()
			Utility.Wait(5.0) ; wait for SLS to register events
			Util.AddSlsStashException(pchsFirewoodPileRef)
			Util.AddSlsStashException(Game.GetFormFromFile(0x5960, "pchsWartimes.esp") as ObjectReference)
			StorageUtil.SetIntValue(Util.UiKey, "pchsWtRecordClutterHelp", 1)
			StorageUtil.SetIntValue(Util.UiKey, "pchsWtTidyModeHelp", 1)
			
			Debug.Notification("Wartimes Tweak v8.0")
		EndIf
		
		If StorageUtil.GetFloatValue(None, "pchsWartimesTweakVersion") < 8.5
			StorageUtil.SetFloatValue(None, "pchsWartimesTweakVersion", 8.5)
			(Game.GetFormFromFile(0x117823, "pchsWartimes.esp") as ObjectReference).Disable() ; Mother's bondage bed
			(Game.GetFormFromFile(0x598A, "pchsWartimes.esp") as ObjectReference).Enable() ; Mother's normal bed
			pchsWtInterfaceFashion Fashion = Game.GetFormFromFile(0x2EE7FC, "pchsWartimes.esp") as pchsWtInterfaceFashion
			Fashion.GoToState("")
			Fashion.PlayerLoadsGame()
			If (Game.GetFormFromFile(0x3449D9, "pchsWartimes.esp") as GlobalVariable).GetValue() ; pchsHorseTethered
				pchsHorseBorrow HorBor = Game.GetFormFromFile(0x3449E1, "pchsWartimes.esp") as pchsHorseBorrow
				Util.DisableSLAC(HorBor.pchsBrutus)
			EndIf
			Debug.Notification("Wartimes Tweak v8.5")
		EndIf
		
		If StorageUtil.GetFloatValue(None, "pchsWartimesTweakVersion") < 8.7
			StorageUtil.SetFloatValue(None, "pchsWartimesTweakVersion", 8.7)
			Faction SexlabForbiddenFaction = Game.GetFormFromFile(0x049068, "Sexlab.esm") as Faction
			(Game.GetFormFromFile(0x33A7AD, "pchsWartimes.esp") as Actor).AddToFaction(SexlabForbiddenFaction)
			(Game.GetFormFromFile(0x33A7AE, "pchsWartimes.esp") as Actor).AddToFaction(SexlabForbiddenFaction)
			Debug.Notification("Wartimes Tweak v8.7")
		EndIf

		If StorageUtil.GetFloatValue(None, "pchsWartimesTweakVersion") < 9.2
			StorageUtil.SetFloatValue(None, "pchsWartimesTweakVersion", 9.2)
			Menu.pchsDdRemCost.SetValue(Menu.DdRemCostBase)
			ThisQuest.UpdateCurrentInstanceGlobal(Menu.pchsDdRemCost)
			Util.BuildArrays()
			RegForEvents()
			(Game.GetFormFromFile(0x3B430, "pchsWartimes.esp") as ObjectReference).Enable() ; Mother's bed
			(Game.GetFormFromFile(0x11781E, "pchsWartimes.esp") as ObjectReference).Disable() ; Bondage table right
			(Game.GetFormFromFile(0x11781D, "pchsWartimes.esp") as ObjectReference).Disable() ; Bondage table left
			(Game.GetFormFromFile(0x11780D, "pchsWartimes.esp") as ObjectReference).Enable() ; Bondage table left
			(GetOwningQuest().GetNthAlias(18) as ReferenceAlias).ForceRefTo(Apol.pchsBrutus)
			;/
			; Move dirt. Removed. Triggers move but dirt piles don't. 
			(Game.GetFormFromFile(0x89A0C, "pchsWartimes.esp") as ObjectReference).MoveToMyEditorLocation()
			(Game.GetFormFromFile(0x89A0A, "pchsWartimes.esp") as ObjectReference).MoveToMyEditorLocation()
			(Game.GetFormFromFile(0x89A0E, "pchsWartimes.esp") as ObjectReference).MoveToMyEditorLocation()
			(Game.GetFormFromFile(0x89A07, "pchsWartimes.esp") as ObjectReference).MoveToMyEditorLocation()
			/;
			Debug.Notification("Wartimes Tweak v9.2")
		EndIf
		
		If StorageUtil.GetFloatValue(None, "pchsWartimesTweakVersion") < 10.0
			StorageUtil.SetFloatValue(None, "pchsWartimesTweakVersion", 10.0)
			Util.AddFoodConfiscationExceptions()
			(Game.GetFormFromFile(0x61DE6E, "pchsWartimes.esp") as pchsForbiddenItems).Setup() ; pchsForbiddenItemsQuest
			If PlayerRef.GetCurrentLocation() == Util.pchsWartimesHomeLocation
				(Game.GetFormFromFile(0x61DE6E, "pchsWartimes.esp") as pchsForbiddenItems).Start() ; pchsForbiddenItemsQuest
			EndIf
			Devious.RestartInterface()
			SupplyRun.SetupSpecialStock()
			(Game.GetFormFromFile(0x09CAF9, "Skyrim.esm") as ObjectReference).Reset() ; BethethorsMerchantChestRef
			Debug.Notification("Wartimes Tweak v10.0")
		EndIf
		
		If StorageUtil.GetFloatValue(None, "pchsWartimesTweakVersion") < 10.3
			StorageUtil.SetFloatValue(None, "pchsWartimesTweakVersion", 10.3)
			Util.ToggleGagTalkFaction(akActor = FatherRef, DisableGagTalk = true)
			Util.ToggleGagTalkFaction(akActor = MotherRef, DisableGagTalk = true)
			Menu.UpdateCurrentInstanceGlobal(Menu.pchsMBackCost)
			Debug.Notification("Wartimes Tweak v10.3")
		EndIf
	EndIf
EndFunction

Function BeginServitude()
	Util.UiKey.SetKey(Util.UiKey.AioKey)
	If Game.GetModByName("yps-ImmersivePiercing.esp") != 255
		StorageUtil.SetIntValue(None, "pchsWtRecordedHairLenght", StorageUtil.GetIntValue(None, "YpsCurrentHairLengthStage"))
	EndIf
	Float currTime = Utility.GetCurrentGameTime()
	fatherHungerLastMeal.SetValue((currTime) - 0.3)
	fatherThirstLastDrink.SetValue((currTime) - 0.3)
	dirtLastClean.SetValue((currTime) - 0.3)
	FatherVoluntaryServeRel.SetValue(0)
	StorageUtil.SetFloatValue(None, "pchsWtLastTaskUpdate", Utility.GetCurrentGameTime())
	RegForEvents()
	OnUpdateGameTime()
	debug.notification("Wartimes timers fired up.")
EndFunction

Event OnUpdateGameTime()
	;/
	; Beeing Female: recognise PC as pregnant
	int varPCPregnant
	varPCPregnant = ((StorageUtil.GetIntValue(PlayerREF, "FW.CurrentState")))
	if varPCPregnant >= 4 && varPCPregnant <= 6
		PCPregnant.SetValue(1)
		if PCBreeder.GetValue() == 1
			PCBreeder.SetValue(2)
		endIf
	else
		PCPregnant.SetValue(0)
	endif

	; Beeing Female: recognise PC as given birth
	if PCBreeder.GetValue() == 3 && varPCPregnant == 7
		PCBreeder.SetValue(4)
	endIf
/;
	Preg.SetPregnancyVars()
	If ThisQuest.GetStage() == 200 && StorageUtil.FormListCount(None, "pchsWartimesTasksSuspendForms") == 0
		
		Float GameDaysPassed = Utility.GetCurrentGameTime()
		Float HoursSinceLastUpdate = ((GameDaysPassed - StorageUtil.GetFloatValue(None, "pchsWtLastTaskUpdate")) * 24.0) as Int
		StorageUtil.SetFloatValue(None, "pchsWtLastTaskUpdate", GameDaysPassed)
		Float TheHour = GameHour.GetValue()
		If GameDaysPassed as Int > StorageUtil.GetFloatValue(None, "pchsWtSkoomaRefreshDay", Missing = -1.0)
			StorageUtil.SetFloatValue(None, "pchsWtSkoomaRefreshDay", GameDaysPassed as Int)
			Fav.pchsSkoomaAvailToday.SetValue(2.0)
			Fav.pchsRapeTatAvailToday.SetValue(1.0)
		EndIf
		
		float currTime = GameDaysPassed * 24.0
		Float HoursTilTasksBegin
		Bool IsTooLate = false
		If TheHour < Menu.TasksBeginHour ; After midnight -> TasksBegin
			IsTooLate = true
			HoursTilTasksBegin = Menu.TasksBeginHour - TheHour
		
		ElseIf TheHour > Menu.TasksEndHour ; TasksEnd -> Midnight
			IsTooLate = true
			HoursTilTasksBegin = (24.0 - TheHour) + Menu.TasksBeginHour
		EndIf 
		
		; Firewood
		If Menu.pchsJobFirewood.GetValue() && pchsTaskFirewood.GetValue()
			If StorageUtil.GetIntValue(None, "pchsWartimesTasksWereSuspended", Missing = 0) == 0 ; If tasks were not suspended then deplete wood otherwise don't deplete wood
				pchsFirewoodPileRef.RemoveItem(Firewood01, HoursSinceLastUpdate as Int)
			EndIf
			Actor Slave = HomeSlaves.GetSlaveAssignedToTask("Firewood")
			If Slave
				SlaveFatherFirewood(Slave)
			EndIf
			If pchsFirewoodPileRef.GetItemCount(Firewood01) <= 0
				pchsFirewoodPileRef.AddItem(Firewood01, 12)
				Fav.ModStat(Msg = "Father is pissed he had to get firewood himself", Favour = Menu.BaseFavourLoss,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
			Else
				If !Slave && pchsFirewoodPileRef.GetItemCount(Firewood01) <= 6
					Debug.Notification("More wood is needed for the fire")
				EndIf
				If GameDaysPassed - StorageUtil.GetFloatValue(FatherRef, "pchsLikesWoodTimeStamp", Missing = -1.0) > 1.0
					StorageUtil.SetFloatValue(FatherRef, "pchsLikesWoodTimeStamp", GameDaysPassed)
					Fav.ModStat(Msg = "Father is pleased the fire is well stocked", Favour = 1.0,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
				EndIf
			EndIf
		EndIf

		; father hunger timer	
		float fatherHungerTimer = Math.Ceiling(currTime - (fatherHungerLastMeal.GetValue() * 24))
		if fatherHungerTimer >= 8 && fatherHungerTimer < 16
			If IsTooLate && fatherHunger.GetValue() != 0 ; Is not too late to assign task and task has not yet been assigned
				fatherHungerLastMeal.Mod(((1.0 / 24.0) * HoursTilTasksBegin) + 0.04) ; Postpone task until Menu.TasksBeginHour + 0.04 (about 1 hour after tasks begin)
			Else
				Actor Slave = HomeSlaves.GetSlaveAssignedToTask("FatherFood")
				If Slave && Slave.IsInFaction(HomeSlaves.pchsHomeSlaveTaskImmediateFact) ; Slave should perform task immediately
					SlaveFatherFood(Slave, currTime)
				Else
					fatherHunger.SetValue(0)
					debug.notification("Father looks hungry..")
				EndIf
			EndIf
		
		elseif fatherHungerTimer >= 16
			Actor Slave = HomeSlaves.GetSlaveAssignedToTask("FatherFood")
			If Slave
				SlaveFatherFood(Slave, currTime)
			Else
				fatherHungerLastMeal.SetValue(currTime / 24.0)
				Fav.ModStat(Msg = "Father is hungry for too long and is angry with me", Favour = Menu.BaseFavourLoss,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
			EndIf
		endIf

		; father thirst timer
		float fatherThirstTimer = Math.Ceiling(currTime - (fatherThirstLastDrink.GetValue() * 24))
		if fatherThirstTimer >= 8 && fatherThirstTimer < 16
			If IsTooLate && fatherThirst.GetValue() != 0
				fatherThirstLastDrink.Mod(((1.0 / 24.0) * HoursTilTasksBegin) + 0.04)
			Else
				Actor Slave = HomeSlaves.GetSlaveAssignedToTask("FatherFood")
				If Slave && Slave.IsInFaction(HomeSlaves.pchsHomeSlaveTaskImmediateFact) ; Slave should perform task immediately
					SlaveFatherDrink(Slave, currTime)
				Else
					fatherThirst.SetValue(0)
					debug.notification("Father looks thirsty..")
				EndIf
			EndIf
		elseif fatherThirstTimer >= 16
			Actor Slave = HomeSlaves.GetSlaveAssignedToTask("FatherFood")
			If Slave
				SlaveFatherDrink(Slave, currTime)
			Else
				fatherThirstLastDrink.SetValue(currTime / 24.0)
				Fav.ModStat(Msg = "Father is thirsty for too long and is angry with me", Favour = Menu.BaseFavourLoss,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
			EndIf
		endIf

		; father sex/fuck timer
		If pchsFatherIntimacyApproach.GetValue() == 2
			If Apol.pchsBoundarySex.GetValueInt() >= Apol.pchsRegSexBeginsAt.GetValueInt()
				float fatherSexTimer = Math.Ceiling(currTime - (fatherSexTimestamp.GetValue() * 24))
				if fatherSexTimer >= 8 && fatherSexTimer < 16
					If IsTooLate && fatherSex.GetValue() != 0
						fatherSexTimestamp.Mod(((1.0 / 24.0) * HoursTilTasksBegin) + 0.04)
					Else
						Actor Slave = HomeSlaves.GetSlaveAssignedToTask("FatherSex")
						;Debug.MessageBox("Sex slave: " + Slave + "\n\n" + StorageUtil.FormListToArray(None, "pchsWtHomeSlaves_FatherSex"))
						If Slave && Slave.IsInFaction(HomeSlaves.pchsHomeSlaveTaskImmediateFact) ; Slave should perform task immediately
							SlaveFatherSex(Slave, currTime)
						Else
							fatherSex.SetValue(0)
							debug.notification("Father looks tense..")
						EndIf
					EndIf
				Elseif fatherSexTimer >= 16 && PCDepravity.GetValue() > 0
					Actor Slave = HomeSlaves.GetSlaveAssignedToTask("FatherSex")
					If Slave
						SlaveFatherSex(Slave, currTime)
					Else
						fatherSexTimestamp.SetValue(currTime / 24.0)
						fatherSex.SetValue(-1)
						Fav.ModStat(Msg = "Father is aroused for too long and is angry with me", Favour = Menu.BaseFavourLoss,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
					EndIf
				EndIf
			EndIf
		EndIf
		
		; Aldo sex timer
		If pchsAldoSex.GetValue() != -1 && pchsBeastiality.GetValue()
			float AldoSexTimer = Math.Ceiling(currTime - (pchsAldoSexTimestamp.GetValue() * 24))
			if AldoSexTimer >= 18 && AldoSexTimer < 24
				If IsTooLate && pchsAldoSex.GetValue() != 1
					pchsAldoSexTimestamp.Mod(((1.0 / 24.0) * HoursTilTasksBegin) + 0.04)
				Else
					Actor Slave = HomeSlaves.GetSlaveAssignedToTask("AldoSex")
					If Slave && Slave.IsInFaction(HomeSlaves.pchsHomeSlaveTaskImmediateFact) ; Slave should perform task immediately
						SlaveAldoSex(Slave, currTime)
					Else
						pchsAldoSex.SetValue(1)
						AldoRef.EvaluatePackage()
						debug.notification("Aldo looks aroused...")
					EndIf
				EndIf
			elseif AldoSexTimer >= 24
				Actor Slave = HomeSlaves.GetSlaveAssignedToTask("AldoSex")
				If Slave
					SlaveAldoSex(Slave, currTime)
				Else
					pchsAldoSexTimestamp.SetValue(currTime / 24.0)
					pchsAldoSex.SetValue(0)
					Fav.ModStat(Msg = "Aldo is aroused for too long and Father is angry with me", Favour = Menu.BaseFavourLoss,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
				EndIf
			endIf
		EndIf
		
		; Brutus Milking
		If pchsHorseMilkDeadline.GetValue() > -1.0 && pchsBeastiality.GetValue() && Menu.pchsJobCumSlut.GetValue()
			Float HoursToDeadline = (pchsHorseMilkDeadline.GetValue() - GameDaysPassed) * 24.0
			If HoursToDeadline < 0.0 ; Task failed
				Actor Slave = HomeSlaves.GetSlaveAssignedToTask("Brutus")
				If Slave
					SlaveBrutusSex(Slave)
				Else
					Fav.ModStat(Msg = "I've taken too long to 'milk' Brutus", Favour = Menu.BaseFavourLoss,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
					pchsHorseMilkDeadline.SetValue(GameDaysPassed + 1.0)
					pchsHorseMilkTaskActive.SetValueInt(0)
				EndIf
			ElseIf HoursToDeadline <= 12.0
				If IsTooLate && pchsHorseMilkTaskActive.GetValue() != 1 ; Is too late and task not yet started
					pchsHorseMilkDeadline.Mod(((1.0 / 24.0) * HoursTilTasksBegin) + 0.04)
				Else
					Actor Slave = HomeSlaves.GetSlaveAssignedToTask("Brutus")
					If Slave && Slave.IsInFaction(HomeSlaves.pchsHomeSlaveTaskImmediateFact)
						SlaveBrutusSex(Slave)
					Else
						pchsHorseMilkTaskActive.SetValueInt(1)
						(Game.GetFormFromFile(0x3449E3, "pchsWartimes.esp") as ObjectReference).Enable() ; pchsEmptyBucketRef
						Debug.Notification("Father is expecting a bucket full of Brutus' cum")
					EndIf
				EndIf
			EndIf
		EndIf
		
		; Supply run
		If pchsSupplyRuns.GetValue() >= 0.0 ; Supply runs enabled.
			If ;/pchsSupplyRuns.GetValue() == 1 &&/; SupplyRun.GetSupplyQuest().IsRunning() ;GetQuestStage() == 0 ; Supply run in progress and not started. Check if expired.
				If (currTime /  24.0) > pchsSupplyRunNext.GetValue() + ((1.0 / 24.0) * 8.0) ; Failed to get supplies after 8 hours
					Actor Slave = HomeSlaves.GetSlaveAssignedToTask("SupplyRun")
					If Slave
						SlaveSupplyRun(Slave)
					Else
						SupplyRun.FailSupplyRun()
					EndIf
				EndIf
				
			Else;If pchsSupplyRuns.GetValue() == 0 ; Supply run not in progress. Check to start one
				If (currTime / 24.0) > pchsSupplyRunNext.GetValue() ; Start run
					Actor Slave = HomeSlaves.GetSlaveAssignedToTask("SupplyRun")
					If Slave && Slave.IsInFaction(HomeSlaves.pchsHomeSlaveTaskImmediateFact)
						SlaveSupplyRun(Slave)
					Else
						pchsSupplyRuns.SetValue(1.0)
						SupplyRun.StartSupplyRun()
						Debug.Notification("We're low on supplies again. I need to do a run into town")
					EndIf
				EndIf	
			EndIf
		EndIf

		; task horse timer
		float taskHorseTimer = Math.Ceiling(currTime - (taskHorseTimestamp.GetValue() * 24))
		if taskHorseTimer >= 16 && taskHorse.GetValue() == -1
			taskHorse.SetValue(0)
			if taskHorseCount.GetValue() > 0
				debug.notification("Skulvar needs help with his horse again.")
			endIf
		endIf

		; task oldman timer
		float taskOldmanTimer = Math.Ceiling(currTime - (taskOldmanTimestamp.GetValue() * 24))
		if taskOldmanTimer >= 16 && taskOldman.GetValue() == -1
			taskOldman.SetValue(0)
			if taskOldmanCount.GetValue() > 0
				debug.notification("Jazeem needs to be taken care of again.")
			endIf
		endIf

		; task soldiers timer
		float taskSoldiersTimer = Math.Ceiling(currTime - (taskSoldiersTimestamp.GetValue() * 24))
		if taskSoldiersTimer >= 16 && taskSoldiers.GetValue() == -1
			taskSoldiers.SetValue(0)
			if taskSoldiersCount.GetValue() > 0
				debug.notification("Gerald needs a cook for the soldiers again.")
			endIf
		endIf

		; task dogs timer
		float taskDogsTimer = Math.Ceiling(currTime - (taskDogsTimestamp.GetValue() * 24))
		;if taskDogsTimer >= 16 && taskDogs.GetValue() == -16
		if taskDogsTimer >= 16 && taskDogs.GetValue() == -1
			taskDogs.SetValue(0)
			if taskDogsCount.GetValue() > 0
				debug.notification("Brumbar's dogs are restless again.")
			endIf
		endIf

		; task party timer
		float taskPartyTimer = Math.Ceiling(currTime - (taskPartyTimestamp.GetValue() * 24))
		if taskPartyTimer >= 24 && taskParty.GetValue() == -1
			taskParty.SetValue(0)
		endIf

		; dirt in house timer
		float dirtTimer = Math.Ceiling(currTime - (dirtLastClean.GetValue() * 24))
		if dirtTimer >= 12 && dirtTimer < 24
			If IsTooLate && (!dirtObjects[0].IsEnabled() && !dirtObjects[0].IsEnabled())
				dirtLastClean.Mod(((1.0 / 24.0) * HoursTilTasksBegin) + 0.04)
			Else
				Actor Slave = HomeSlaves.GetSlaveAssignedToTask("Clean")
				If Slave && Slave.IsInFaction(HomeSlaves.pchsHomeSlaveTaskImmediateFact)
					SlaveCleanHouse(Slave, currTime)
				Else
					Int iReferenceD = dirtObjects.Length
					While (iReferenceD)
						iReferenceD -= 1
						dirtObjects[iReferenceD].Enable()
					EndWhile
					debug.notification("The house looks dirty..")
				EndIf
			EndIf
		elseif dirtTimer >= 24
			Actor Slave = HomeSlaves.GetSlaveAssignedToTask("Clean")
			If Slave
				SlaveCleanHouse(Slave, currTime)
			Else
				dirtLastClean.SetValue(currTime / 24.0)
				Fav.ModStat(Msg = "The house is dirty for too long. Father is angry with me", Favour = Menu.BaseFavourLoss,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
			EndIf
		endIf
		
		; Cum Pools
		Int PoolCount = CumPools.GetCumPoolCount()
		If PoolCount >= 6
			If GameDaysPassed - StorageUtil.GetFloatValue(None, "pchsWtCumPoolTimestamp", -1.0) >= 0.5
				StorageUtil.SetFloatValue(None, "pchsWtCumPoolTimestamp", GameDaysPassed)
				Fav.ModStat(Msg = "The floor is too messy with cum for too long", Favour = Menu.BaseFavourLoss,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
			Else
				Debug.Notification("The floor is starting to get really messy with cum")
			EndIf
		ElseIf PoolCount >= 3
			Debug.Notification("The floor is starting to get really messy with cum")
		EndIf
		
		; Clutter
		Int UntidyCount = IsTidy.GetUntidyCount()
		If UntidyCount >= 8
			If GameDaysPassed - StorageUtil.GetFloatValue(None, "pchsWtHomeTidyTimestamp", -1.0) >= 0.5
				StorageUtil.SetFloatValue(None, "pchsWtHomeTidyTimestamp", GameDaysPassed)
				Fav.ModStat(Msg = "The house is too untidy", Favour = Menu.BaseFavourLoss,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
			Else
				Debug.Notification("The house is becoming a bit untidy")
			EndIf
			
		ElseIf UntidyCount >= 4
			Debug.Notification("The house is becoming a bit untidy")
		EndIf

		; father appreciates PC wearing collar
		float likeCollarTimer = Math.Ceiling(currTime -(likeCollarTimestamp.GetValue() * 24))
		if likeCollarTimer >= 12
			likeCollar.SetValue(0)
		endIf

		; father appreciates PC wearing heels
		float likeHeelsTimer = Math.Ceiling(currTime -(likeHeelsTimestamp.GetValue() * 24))
		if likeHeelsTimer >= 12
			likeHeels.SetValue(0)
		endIf

		; father appreciates PC being naked
		float likeNakedTimer = Math.Ceiling(currTime -(likeNakedTimestamp.GetValue() * 24))
		if likeNakedTimer >= 12
			likeNaked.SetValue(0)
		endIf

		; father appreciates PC wearing Maid clothes
		float likeMaidClothesTimer = Math.Ceiling(currTime -(likeMaidClothesTimestamp.GetValue() * 24))
		if likeMaidClothesTimer >= 12
			likeMaidClothes.SetValue(0)
		endIf
		
		; father appreciates PC fashion
		float likeFashionTimer = Math.Ceiling(currTime -(pchsFatherLikeFashionTimestamp.GetValue() * 24))
		if likeFashionTimer >= 12
			pchsFatherLikeFashion.SetValue(0)
		endIf
		
		; father appreciates filth
		float likeDirtTimer = Math.Ceiling(currTime -(pchsFatherLikeDirtTimestamp.GetValue() * 24))
		if likeDirtTimer >= 12
			pchsFatherLikeDirt.SetValue(0)
		endIf
		
		; father appreciates piercings
		float likePiercingsTimer = Math.Ceiling(currTime -(pchsFatherLikePiercingsTimestamp.GetValue() * 24))
		if likePiercingsTimer >= 24
			pchsFatherLikePiercings.SetValue(0)
		endIf
		
		; father appreciates hair colour
		float likeHairColourTimer = Math.Ceiling(currTime -(pchsFatherLikeHairColourTimestamp.GetValue() * 24))
		if likeHairColourTimer >= 24
			pchsFatherLikeHairColour.SetValue(0)
		endIf
		
		; father appreciates bondage
		float likeBondageTimer = Math.Ceiling(currTime -(pchsFatherLikeBondageTimestamp.GetValue() * 24))
		if likeBondageTimer >= 12
			pchsFatherLikeBondage.SetValue(0)
		endIf

		; mother health timer
		if currTime >= motherHealthTimestampGlobal.GetValue() && motherHealthGlobal.GetValue() > 0 && MotherCaged.GetValue() == 0
			motherHealthGlobal.Mod(-1)
			motherHealthTimestampGlobal.SetValue(Math.Ceiling(currTime + 24))
			if motherHealthGlobal.GetValue() == 0
				motherHealthGlobal.SetValue(-1)
				motherHealthTimestampGlobal.SetValue(0)
				MotherREF.Kill()
				Debug.MessageBox("The time paid for your mother's health care has run off. As you were unable to provide for her, she was kicked out the healing house to die as a filthy human garbage..")
			
			elseif	motherHealthGlobal.GetValue() > 0 && motherHealthGlobal.GetValue() <= 3
				Debug.MessageBox("Another day has passed, one less day left for your mother to be taken care of.. she has only "+motherHealthGlobal.GetValueInt()+" days left..")
			
			else
				Debug.notification("Another day has passed, one less day left for your mother to be taken care of.. she has "+motherHealthGlobal.GetValueInt()+" days left..")
			endIf
		endIf

		; caged mother health timer
		if currTime >= motherHealthTimestampGlobal.GetValue() && MotherCaged.GetValue() == 3 && motherHealthCaged.GetValue() > 0
			motherHealthCaged.Mod(-1)
			motherHealthTimestampGlobal.SetValue(Math.Ceiling(currTime + 24))
			if motherHealthCaged.GetValue() == 0
				motherHealthCaged.SetValue(-1)
				MotherREF.Kill()
				motherHealthTimestampGlobal.SetValue(0)
				MotherREF.Kill()
				Debug.MessageBox("Mother has just died of malnoutrishment..")	
			
			elseif motherHealthCaged.GetValue() > 0 && motherHealthCaged.GetValue() <= 3
				Debug.MessageBox("Another day has passed, mother just became more hungry. She will last about "+motherHealthCaged.GetValueInt()+" more days only..")
			
			else
				Debug.MessageBox("Another day has passed, mother just became more hungry. She will last about "+motherHealthCaged.GetValueInt()+" more days.")

			endIf
		endIf
		
		; Mother's Healing costs
		If pchsAmpInstalled.GetValue() && GameDaysPassed as Int > StorageUtil.GetFloatValue(None, "pchsWtMothersHealingCostTime") as Int
			StorageUtil.SetFloatValue(None, "pchsWtMothersHealingCostTime", GameDaysPassed)
			pchsMHealCost.SetValueInt(PapyrusUtil.ClampInt(pchsMHealCost.GetValueInt() + 20, 100, 500))
			ThisQuest.UpdateCurrentInstanceGlobal(pchsMHealCost)
		EndIf

		; MME milk timer
		If pchsPCMilkCow.GetValueInt()
			float MilkTimer = Math.Ceiling(currTime - (pchsFatherMilkTimestamp.GetValue() * 24))
			;Debug.MessageBox("Milk Timer: " + MilkTimer + "\n\ncurrTime: " + currTime + "\npchsFatherMilkTimestamp: " + pchsFatherMilkTimestamp.GetValue())
			if MilkTimer >= 16 && MilkTimer < 24
				If IsTooLate && pchsFatherMilk.GetValue() != 0
					pchsFatherMilkTimestamp.Mod(((1.0 / 24.0) * HoursTilTasksBegin) + 0.05)
				Else
					pchsFatherMilk.SetValue(0)
					debug.notification("Father is expecting my milk (" + ((Menu.MilkQuotaPerLevel * (StorageUtil.GetFloatValue(PlayerRef, "MME.MilkMaid.Level") + 1)) as Int) + " units)")
				EndIf
			elseif MilkTimer >= 24
				;fatherSexTimestamp.Mod(8 * 24)
				pchsFatherMilkTimestamp.SetValue(currTime / 24.0)
				pchsFatherMilk.SetValue(-1)
				pchsGiftedMilkCount.SetValueInt(0)
				If pchsGiftedMilkCount.GetValueInt() >= Math.Ceiling(Menu.MilkQuotaPerLevel * (StorageUtil.GetFloatValue(PlayerRef, "MME.MilkMaid.Level") + 1.0) / 2.0) ; If you've at least met half your quota
					debug.notification("Father is placated with the milk I've brought him (Favor +0")
				Else
					;FatherVoluntaryServeRel.Mod(Menu.BaseFavourLoss)
					;debug.notification("Father has waited too long for my milk (Favour " + (Menu.BaseFavourLoss as Int) + ")")
					Fav.ModStat(Msg = "Father has waited too long for my milk", Favour = Menu.BaseFavourLoss,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
				EndIf
			endIf
		EndIf
		
		; Cum slut timer
		If pchsPcCumSlut.GetValueInt()
			float CumSlutTimer = Math.Ceiling(currTime - (pchsFatherCumSlutTimestamp.GetValue() * 24))
			;Debug.MessageBox("Milk Timer: " + MilkTimer + "\n\ncurrTime: " + currTime + "\npchsFatherMilkTimestamp: " + pchsFatherMilkTimestamp.GetValue())
			if CumSlutTimer >= 16 && CumSlutTimer < 24
				If IsTooLate && pchsFatherCumSlut.GetValue() != 0
					pchsFatherCumSlutTimestamp.Mod(((1.0 / 24.0) * HoursTilTasksBegin) + 0.04)
				Else
					pchsFatherCumSlut.SetValue(0)
					debug.notification("Father is expecting a filled cumtainer")
				EndIf
			elseif CumSlutTimer >= 24
				;fatherSexTimestamp.Mod(8 * 24)
				pchsFatherCumSlutTimestamp.SetValue(currTime / 24.0)
				pchsFatherCumSlut.SetValue(-1)
				pchsGiftedCumCount.SetValueInt(0)
				pchsMetCumQuota.SetValueInt(0)
				;FatherVoluntaryServeRel.Mod(Menu.BaseFavourLoss)
				;debug.notification("Father has waited too long for a filled cumtainer")
				Fav.ModStat(Msg = "Father has waited too long for a filled cumtainer", Favour = Menu.BaseFavourLoss,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
			endIf
		EndIf

		; timer for Father's forcegreet
		float FatherForcegreetTimer = Math.Ceiling(currTime - FatherForcegreetGlobalTimestamp.GetValue())
		if FatherForcegreetTimer >= 4
			;pchsPcIsWearingCollar.SetValueInt(Util.GetIsPlayerWearingCollar()) ; Not necessary any more as status is updated in PlayerEquip immediately
			;pchsPcIsWearingHeels.SetValueInt(Util.GetIsPlayerWearingSlaveHeels()) ; Not necessary any more as status is updated in PlayerEquip immediately
			If Fav.pchsApologyFailCount.GetValue()
				Devious.GetNumFreeSlots(PlayerRef)
			EndIf
			FatherForcegreetGlobal.SetValue(1)
		endIf
		
		If GameDaysPassed > (StorageUtil.GetFloatValue(None, "pchsWtFatherDrunkTimeStamp", Missing = -1.0) + 0.5) && (TheHour >= 21.5 || TheHour < 1.0)
			StorageUtil.SetFloatValue(None, "pchsWtFatherDrunkTimeStamp", GameDaysPassed)
			If 50.0 > Utility.RandomFloat(0.0, 100.0)
				(Game.GetFormFromFile(0x451119, "pchsWartimes.esp") as Quest).Start() ; pchsFatherDrunkQuest
			;Else
			;	Debug.MessageBox("Father won't be drunk today")
			EndIf			
		EndIf

		; timer for Party Guests forcegreet
		float GuestForcegreetTimer = Math.Ceiling(currTime - GuestForcegreetGlobalTimestamp.GetValue())
		if GuestForcegreetTimer >= 0.25
			GuestForcegreetGlobal.SetValue(1)
		endIf
		
		; Decrease DD remove cost
		If Menu.pchsDdRemCost.GetValue() > Menu.DdRemCostBase
			Menu.pchsDdRemCost.Mod(-(HoursSinceLastUpdate * 0.5))
			ThisQuest.UpdateCurrentInstanceGlobal(Menu.pchsDdRemCost)
		EndIf
		
		; Reset tasks have resumed flag
		If StorageUtil.GetIntValue(None, "pchsWartimesTasksWereSuspended", Missing = 0)
			StorageUtil.UnSetIntValue(None, "pchsWartimesTasksWereSuspended")
		EndIf

	Else
		If StorageUtil.FormListCount(None, "pchsWartimesTasksSuspendForms") > 0
			Debug.Trace("pchs: Tasks blocked. GameHour: " + GameHour.GetValue() + ". Forms: " + StorageUtil.FormListToArray(None, "pchsWartimesTasksSuspendForms"))
		EndIf
	EndIf
	RegisterForSingleUpdateGameTime(1.0)
EndEvent

; ---- PLUGS ----

Function UnequipEffect()
	PlugOutSound.Play(PlayerREF)
	PlayerREF.SetExpressionOverride(9, 100)
	Utility.Wait(5.0)
	PlayerREF.ClearExpressionOverride()
EndFunction

Function EquipEffect()
	PlugInSound.Play(PlayerREF)
	PlayerREF.SetExpressionOverride(9, 100)
	Utility.Wait(5.0)
	PlayerREF.ClearExpressionOverride()
EndFunction

Event OnObjectUnEquipped(Form akBaseObject, ObjectReference akReference)

	if akBaseObject == MeadPlugBottomIn || akBaseObject == MeadPlugTopIn || akBaseObject == CarrotPlug || akBaseObject == FlutePlugShallow || akBaseObject == FlutePlugDeep
		if PlugType.GetValue() == 1
			PlayerREF.AddItem(MeadBottle, 1, false)
		elseif PlugType.GetValue() == 2
			PlayerREF.AddItem(Mead, 1, false)
		elseif PlugType.GetValue() == 3
			PlayerREF.AddItem(MeadHB, 1, false)
		elseif PlugType.GetValue() == 4
			PlayerREF.AddItem(MeadBB, 1, false)
		elseif PlugType.GetValue() == 5
			PlayerREF.AddItem(MeadBBR, 1, false)
		elseif PlugType.GetValue() == 6
			PlayerREF.AddItem(Carrot, 1, false)
		elseif PlugType.GetValue() == 7
			PlayerREF.AddItem(Flute, 1, false)
		elseif PlugType.GetValue() == 8
			PlayerREF.AddItem(Flute1, 1, false)
		endif
	endif

	if akBaseObject == MeadPlugBottomIn	
		PlayerREF.RemoveItem(MeadPlugBottomIn, 1, false)
		UnequipEffect()
	elseif akBaseObject == MeadPlugTopIn
		PlayerREF.RemoveItem(MeadPlugTopIn, 1, false)
		UnequipEffect()
	elseif akBaseObject == CarrotPlug
		PlayerREF.RemoveItem(CarrotPlug, 1, false)	
		UnequipEffect()
	elseif akBaseObject == FlutePlugShallow
		PlayerREF.RemoveItem(FlutePlugShallow, 1, false)	
		UnequipEffect()
	elseif akBaseObject == FlutePlugDeep
		PlayerREF.RemoveItem(FlutePlugDeep, 1, false)	
		UnequipEffect()
	endIf

endEvent

Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
	if akBaseObject == MeadPlugBottomIn || akBaseObject == MeadPlugTopIn || akBaseObject == CarrotPlug || akBaseObject == FlutePlugShallow || akBaseObject == FlutePlugDeep
		EquipEffect()
	endIf
EndEvent

; =======================================================================================

Bool FatherRape = false

Int FatherOrgasmCount = 0
Int FatherOrgasmCountAttempt = 0
Int MilkPlacated = 0

Function FatherSexBegin(Bool IsRape = false, Float Favour, Float Depravity, Float Submission, GlobalVariable PcGaveSexType)
	SexSceneFavour = Favour
	SexSceneDepravity = Depravity
	SexSceneSubmission = Submission
	FatherRape = IsRape
	RegisterForModEvent("_SLS_PlayerSwallowedCum", "On_SLS_PlayerSwallowedCum")
	StorageUtil.SetFormValue(None, "pchsWtPcGaveSexType", PcGaveSexType)
	
	RegisterForModEvent("SexLabOrgasmSeparate", "OnSexLabOrgasmSeparate")
	RegisterForModEvent("HookAnimationEnd", "OnAnimationEnd")
	If !Util.pchsSlsoInstalled.GetValue()
		
		SatisfiedFather()
	Else
		DoMinimumArousal(FatherRef)
	EndIf
EndFunction

Event On_SLS_PlayerSwallowedCum(Form akSource, Bool DidSwallow, Float CumAmount, Float LoadSizeBase, Bool IsCumPotion)
	If akSource == FatherRef && DidSwallow
		;FatherVoluntaryServeRel.Mod(1)
		;debug.notification("Father looks pleased that I drank his cum (favor +1)")
		Fav.ModStat(Msg = "Father looks pleased that I drank his cum", Favour = 1.0,  Depravity = 1.0, Submission = 1.0, Sender = ThisQuest)
		
		If StorageUtil.GetIntValue(None, "pchsWtCumSlutIntro") == 1
			StorageUtil.SetIntValue(None, "pchsWtCumSlutIntro" , 2)
		EndIf
	EndIf
EndEvent

Function SatisfiedFather()
	FatherOrgasmCount += 1
	fatherSex.SetValue(1)
	fatherSexTimestamp.SetValue(Utility.GetCurrentGameTime())
	pchsFatherSexCount.Mod(1)
	GlobalVariable PcGaveSexType = StorageUtil.GetFormValue(None, "pchsWtPcGaveSexType") as GlobalVariable
	If PcGaveSexType
		;PcGaveSexType.Mod(1)
		Apol.PushFatherBoundary(PcGaveSexType, false)
	Else
	EndIf
	If !FatherRape
		Fav.ModStat(Msg = "Father is pleased I made him cum", Favour = SexSceneFavour,  Depravity = SexSceneDepravity, Submission = SexSceneSubmission, Sender = ThisQuest)
	Else
		Fav.ModStat(Msg = "Father is pissed I didn't offer my body to him freely", Favour = Menu.BaseFavourLoss,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
	EndIf
EndFunction

Event OnSexLabOrgasmSeparate(Form ActorRef, Int tid)
	If ActorRef == FatherRef
		SatisfiedFather()
	ElseIf ActorRef == PlayerRef
		;/
		PCDepravity.Mod(1)
		PCSubmission.Mod(1)
		FatherVoluntaryServeRel.Mod(1)
		Debug.Notification("Depravity, submisssion & favor has increased by 1")
		/;
		Fav.ModStat(Msg = "Father looks pleased I came on his cock", Favour = 1.0,  Depravity = 1.0, Submission = 1.0, Sender = ThisQuest)
	EndIf
EndEvent

Event OnAnimationEnd(int tid, bool HasPlayer)
	If HasPlayer
		If FatherOrgasmCount <= 0
			FatherOrgasmCountAttempt += 1
			;FatherVoluntaryServeRel.Mod(Menu.BaseFavourLoss * (FatherOrgasmCountAttempt))
			;Debug.Notification("Father's favor decreased by " + ((Menu.BaseFavourLoss as Int) * FatherOrgasmCountAttempt))
			Fav.ModStat(Msg = "I failed to get Father off", Favour = (Menu.BaseFavourLoss * FatherOrgasmCountAttempt),  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
			If FatherOrgasmCountAttempt >= 2 && (Game.GetFormFromFile(0x186EB8, "pchsWartimes.esp") as GlobalVariable).GetValueInt() == 0 ; pchsGotSkooma
				Utility.Wait(3.0)
				Debug.Messagebox("Father: 'I'm very disappointed in you. Here, try this!'\n\nHe grabs you and forces you to drink something from a bottle. You don't know what it is but it makes you feel... good!\n\nYou can now ask father for skooma")
				Form akSkooma = Game.GetFormFromFile(0x57A7A, "Skyrim.esm")
				PlayerRef.AddItem(akSkooma, 1, false)
				PlayerRef.EquipItem(akSkooma)
				(Game.GetFormFromFile(0x186EB8, "pchsWartimes.esp") as GlobalVariable).SetValueInt(1) ; pchsGotSkooma
			EndIf
			Util.IncArousal(FatherRef, 20)

		Else
			FatherOrgasmCountAttempt = 0
		EndIf
		FatherOrgasmCount = 0
		UnRegForSexEvents()
		
		TryCumSlutApproach()
	EndIf
EndEvent

Function UnRegForSexEvents()
	UnRegisterForModEvent("_SLS_PlayerSwallowedCum")
	UnRegisterForModEvent("SexLabOrgasmSeparate")
	UnRegisterForModEvent("HookAnimationEnd")
EndFunction

Function TryCumSlutApproach()
	If Menu.pchsJobCumSlut.GetValue() && StorageUtil.GetIntValue(None, "pchsWtCumSlutIntro") == 2
		StorageUtil.UnSetIntValue(None, "pchsWtCumSlutIntro")
		Utility.Wait(2.0)
		(Game.GetFormFromFile(0x1F140F, "pchsWartimes.esp") as Quest).Start() ; pchsCumSlutQuest
		FatherRef.EvaluatePackage()
	EndIf
EndFunction

Function DoMinimumArousal(Actor akActor)
	If Game.GetModByName("SexLabAroused.esm") != 255
		Float Arousal = akActor.GetFactionRank(Game.GetFormFromFile(0x03FC36, "SexLabAroused.esm") as Faction)
		;Float Amount = (Utility.RandomFloat(Menu.SeedArousalMin, Menu.SeedArousalMax) - Arousal) / StorageUtil.GetFloatValue(akActor, "SLAroused.ExposureRate", Missing = 2.0)
		If Arousal < Menu.SeedArousalMin
			Util.ModArousal(akActor, (Utility.RandomFloat(Menu.SeedArousalMin, Menu.SeedArousalMax) - Arousal) / StorageUtil.GetFloatValue(akActor, "SLAroused.ExposureRate", Missing = 2.0))
		EndIf
	EndIf
EndFunction

Function GiftedMilk(Form akBaseItem, Int aiItemCount)
	pchsGiftedMilkCount.Mod(aiItemCount)
	FatherRef.RemoveItem(akBaseItem, aiItemCount)
	;Debug.MessageBox("GiftCount: " + pchsGiftedMilkCount.GetValueInt() + "\nMilkQuotaPerLevel: " + MilkQuotaPerLevel + "\nLevel: " + StorageUtil.GetFloatValue(PlayerRef, "MME.MilkMaid.Level"))
	
	If MilkPlacated == 0 && pchsGiftedMilkCount.GetValueInt() >= Math.Ceiling((Menu.MilkQuotaPerLevel * (StorageUtil.GetFloatValue(PlayerRef, "MME.MilkMaid.Level") + 1)) / 2.0)
		MilkPlacated = 1
		Debug.Notification("Father has been placated with the milk I've brought him (Favor +0)")
	EndIf
	If MilkPlacated == 1 && pchsGiftedMilkCount.GetValueInt() >= (Menu.MilkQuotaPerLevel * (StorageUtil.GetFloatValue(PlayerRef, "MME.MilkMaid.Level") + 1))
		MilkPlacated = 2
		Debug.Notification("Father is pleased with my progress (Favor +1)")
	EndIf
EndFunction

Function CloseMilkGiftMenu()
	If MilkPlacated == 2
		Fav.ModStat(Msg = "", Favour = 1.0,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
		;FatherVoluntaryServeRel.Mod(1)
	ElseIf MilkPlacated == 0
		Fav.ModStat(Msg = "Father is displeased with my milking progress", Favour = Menu.BaseFavourLoss,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
		;FatherVoluntaryServeRel.Mod(Menu.BaseFavourLoss)
		;Debug.Notification("Father is displeased with my progress (Favor " + (Menu.BaseFavourLoss as Int) + ")")
	EndIf
	MilkPlacated = 0
	pchsGiftedMilkCount.SetValueInt(0)
	pchsFatherMilkTimestamp.SetValue(Utility.GetCurrentGameTime())
	pchsFatherMilk.SetValue(-1)
EndFunction

Bool Function IsMeetingYpsExpectations(Bool DryRun = false, Bool DoReward = false)
	Int Reward
	Bool Result = true
	If pchsBathingForbidden.GetValue() == 0.0
		If pchsFashionNeeded.GetValueInt() >= 1
			; Lipstick
			If StorageUtil.GetIntValue(None, "yps_LipstickSmudged") == 1
				If !PlayerRef.WornHasKeyWord(Devious.zad_DeviousGag)
					If !DryRun
						;Fav.ModStat(Msg = "Father is disappointed I've smudged my lipstick", Favour = -1.0,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
						Debug.Notification("Father is disappointed I've smudged my lipstick")
					EndIf
					Result = false
				EndIf
			ElseIf StorageUtil.GetStringValue(None, "yps_LipstickColor") == ""
				If !PlayerRef.WornHasKeyWord(Devious.zad_DeviousGag)
					If !DryRun
						;Fav.ModStat(Msg = "Father is disappointed I'm not wearing lipstick", Favour = -1.0,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
						Debug.Notification("Father is disappointed I'm not wearing lipstick")
					EndIf
					Result = false
				EndIf
			Else
				Reward += 30
			EndIf
			
			; Eyeshadow
			If StorageUtil.GetIntValue(None, "yps_EyeShadowSmudged") == 1
				If !PlayerRef.WornHasKeyWord(Devious.zad_DeviousBlindfold)
					If !DryRun
						;Fav.ModStat(Msg = "Father is disappointed I've smudged my eyeshadow", Favour = -1.0,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
						Debug.Notification("Father is disappointed I've smudged my eyeshadow")
					EndIf
					Result = false
				EndIf
			ElseIf StorageUtil.GetStringValue(None, "yps_EyeShadowColor") == ""
				If !PlayerRef.WornHasKeyWord(Devious.zad_DeviousBlindfold)
					If !DryRun
						;Fav.ModStat(Msg = "Father is disappointed I'm not wearing eyeshadow", Favour = -1.0,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
						Debug.Notification("Father is disappointed I'm not wearing eyeshadow")
					EndIf
					Result = false
				EndIf
			Else
				Reward += 30
			EndIf
		EndIf
		
		If pchsFashionNeeded.GetValueInt() >= 2
			; Finger nails
			If StorageUtil.GetIntValue(None, "yps_FingerNailPolishStage") == 30
				If !PlayerRef.WornHasKeyWord(Devious.zad_DeviousGloves)
					If !DryRun
						;Fav.ModStat(Msg = "Father is disappointed I've smudged my finger nails", Favour = -1.0,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
						Debug.Notification("Father is disappointed I've smudged my finger nails")
					EndIf
					Result = false
				EndIf
			ElseIf StorageUtil.GetIntValue(None, "yps_FingerNailPolishStage") >= 60
				If !PlayerRef.WornHasKeyWord(Devious.zad_DeviousGloves)
					If !DryRun
						;Fav.ModStat(Msg = "Father is disappointed I've smudged my finger nails", Favour = -1.0,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
						Debug.Notification("Father is disappointed my finger nail polish is chipped")
					EndIf
					Result = false
				EndIf
			ElseIf StorageUtil.GetStringValue(None, "yps_FingerNailPolishColor") == ""
				If !PlayerRef.WornHasKeyWord(Devious.zad_DeviousGloves)
					If !DryRun
						;Fav.ModStat(Msg = "Father is disappointed my finger nails aren't painted", Favour = -1.0,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
						Debug.Notification("Father is disappointed my finger nails aren't painted")
					EndIf
					Result = false
				EndIf
			Else
				Reward += 25
			EndIf
			
			; Toe nails
			Bool ToeNailPolishBlocked = IsToeNailPolishBlocked()
			If StorageUtil.GetIntValue(None, "yps_ToeNailPolishStage") == 30
				If !ToeNailPolishBlocked
					If !DryRun
						;Fav.ModStat(Msg = "Father is disappointed I've smudged my toe nails", Favour = -1.0,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
						Debug.Notification("Father is disappointed I've smudged my toe nails")
					EndIf
					Result = false
				EndIf
			ElseIf StorageUtil.GetIntValue(None, "yps_ToeNailPolishStage") >= 60
				If !ToeNailPolishBlocked
					If !DryRun
						;Fav.ModStat(Msg = "Father is disappointed I've smudged my toe nails", Favour = -1.0,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
						Debug.Notification("Father is disappointed toe nail polish is chipped")
					EndIf
					Result = false
				EndIf
			
			ElseIf StorageUtil.GetStringValue(None, "yps_ToeNailPolishColor") == ""
				If !ToeNailPolishBlocked
					If !DryRun
						;Fav.ModStat(Msg = "Father is disappointed my toe nails aren't painted", Favour = -1.0,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
						Debug.Notification("Father is disappointed my toe nails aren't painted")
					EndIf
					Result = false
				EndIf
			Else
				Reward += 25
			EndIf
		EndIf
		
		If pchsFashionNeeded.GetValueInt() >= 3
			; Pubic hair
			If !(PCBreeder.GetValue() == 1 && Devious.GetIsInterfaceActive()) && StorageUtil.GetIntValue(None, "yps_PubicHairStage") > 2 ; More than a small bush
				If !PlayerRef.WornHasKeyWord(Devious.zad_DeviousBelt) && !PlayerRef.WornHasKeyWord(Devious.zad_DeviousHarness) && !PlayerRef.WornHasKeyWord(Devious.zad_DeviousSuit)
					If !DryRun
						;Fav.ModStat(Msg = "Father is disappointed my pubic hair has grown wild", Favour = -1.0,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
						Debug.Notification("Father is disappointed my pubic hair has grown wild")
					EndIf
					Result = false
				EndIf
			Else
				Reward += 5
			EndIf
			
			; Stockings
			Form akStockings = StorageUtil.GetFormValue(None, "yps_Stockings")
			If Menu.RequireStockings && (!akStockings || StorageUtil.FormListFind(None, "pchsWtBoringStockings", StorageUtil.GetFormValue(None, "yps_Stockings")) > -1)
				If !PlayerRef.WornHasKeyWord(Devious.zad_DeviousBoots) && !PlayerRef.WornHasKeyWord(Devious.zad_DeviousLegCuffs)
					If !DryRun
						;Fav.ModStat(Msg = "Father is disappointed I'm not wearing stockings", Favour = -1.0,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
						If StorageUtil.GetFormValue(None, "yps_Stockings") == None
							Debug.Notification("Father is disappointed I'm not wearing stockings")
						Else
							Debug.Notification("Father is bored of my stockings")
						EndIf
					EndIf
					Result = false
				EndIf
			Else
				Reward += 5
			EndIf
			
			; Stocking boredom
			If akStockings
				If StorageUtil.GetIntValue(akStockings, "pchsWtStockingsBoredomCount", Missing = -1) == -1 ; New stockings
					; New stockings - Set boredom
					StorageUtil.SetIntValue(akStockings, "pchsWtStockingsBoredomCount", Utility.RandomInt(2, 4))
					pchsBoringStockings.SetValue(0.0)
					;Debug.MessageBox("New stockings boredom for: " + akStockings.GetName() + ": " + StorageUtil.GetIntValue(akStockings, "pchsWtStockingsBoredomCount"))
				Else ; Increase boredom
					StorageUtil.AdjustIntValue(akStockings, "pchsWtStockingsBoredomCount", -1)
					If StorageUtil.GetIntValue(akStockings, "pchsWtStockingsBoredomCount") <= 0 ; Boring stockings
						pchsBoringStockings.SetValue(1.0)
					EndIf
					;Debug.MessageBox("Increased boredom for: " + akStockings.GetName() + ": " + StorageUtil.GetIntValue(akStockings, "pchsWtStockingsBoredomCount"))
				EndIf
			EndIf

			; Heels
			If Menu.RequireStockings && !Util.IsWearingHeels(PlayerRef)
				If !DryRun
					;Fav.ModStat(Msg = "Father is disappointed I'm not wearing stockings", Favour = -1.0,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
					Debug.Notification("Father is disappointed I'm not wearing heels")
				EndIf
				Result = false
			Else
				Reward += 5
			EndIf
		EndIf
		
		If !Result
			Fav.ModStat(Msg = "Father is disappointed with my appearance", Favour = Menu.BaseFavourLoss,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
		Else
		; Reward
			If DoReward && !DryRun;/ && Result /;&& pchsFashionNeeded.GetValueInt() >= 1 
			
				if pchsFatherLikeFashion.GetValue() == 0
					pchsFatherLikeFashion.SetValue(1)
					pchsFatherLikeFashionTimestamp.SetValue(Utility.GetCurrentGameTime())
				EndIf

				;Fav.ModStat(Msg = "Father seems pleased with my appearance", Favour = 1.0,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
				PlayerRef.AddItem(Game.GetFormFromFile(0xf, "Skyrim.esm"), (Reward * StorageUtil.GetFloatValue(None, "pchsWtFashionSupplement", Missing = 1.0)) as Int)
			EndIf
		EndIf
		Return Result
	
	Else
		Return true
	EndIf
EndFunction

Function ForbidBathing()
	pchsBathingForbidden.SetValue(Math.Ceiling(Utility.GetCurrentGameTime()))
	SetCumSlutData()
	CumSlutData[0] = 0
	RegisterForModEvent("Bis_BatheEvent", "OnBis_BatheEvent")
EndFunction

Function BathingPermissionFail()
	pchsBathingForbidden.SetValue(Math.Ceiling(Utility.GetCurrentGameTime()))
	SetCumSlutData()
EndFunction

Function BathingPermissionSuccess()
	pchsBathingCooloff.SetValue(Math.Ceiling(Utility.GetCurrentGameTime()) + Utility.RandomFloat(2.0, 10.0))
	pchsBathingForbidden.SetValue(0.0)
	CumSlutData = new Float[7]
EndFunction

Event OnBis_BatheEvent(Form akTarget)
	CumSlutData[0] = 1
EndEvent

Function SetCumSlutData()
	If Game.GetModByName("Bathing in Skyrim - Main.esp") != 255
		CumSlutData[1] = (Game.GetFormFromFile(0x000DA8, "Bathing in Skyrim - Main.esp") as GlobalVariable).GetValue() ; mzinDirtinessPercentage
	Else
		CumSlutData[1] = 0.0
	EndIf
	CumSlutData[2] = Sexlab.CountCumOral(PlayerRef)
	CumSlutData[3] = Sexlab.CountCumVaginal(PlayerRef)
	CumSlutData[4] = Sexlab.CountCumAnal(PlayerRef)
	
	CumSlutData[5] = StorageUtil.GetFloatValue(PlayerRef, "sr.inflater.cum.vaginal", missing = 0.0)
	CumSlutData[6] = StorageUtil.GetFloatValue(PlayerRef, "sr.inflater.cum.anal", missing = 0.0)
EndFunction

Int Function IsGoodCumSlut()
	Int FavorLoss
	String StrResult = "Father is disappointed:"
	If CumSlutData[0] == 1
		FavorLoss -= 1
		StrResult += "\nBathed without permission (Favor -1)"
		CumSlutData[0] = 0
	ElseIf Game.GetModByName("Bathing in Skyrim - Main.esp") != 255
		If (Game.GetFormFromFile(0x000DA8, "Bathing in Skyrim - Main.esp") as GlobalVariable).GetValue() < CumSlutData[1] ; mzinDirtinessPercentage
			FavorLoss -= 1
			StrResult += "\nbathed without permission (Favor -1)"
		EndIf
	EndIf
	If Sexlab.CountCumOral(PlayerRef) < CumSlutData[2]
		FavorLoss -= 1
		StrResult += "\nCum missing from my face (Favor -1)"
	EndIf
	If Sexlab.CountCumVaginal(PlayerRef) < CumSlutData[3]
		FavorLoss -= 1
		StrResult += "\nCum missing from my pussy (Favor -1)"
	EndIf
	If Sexlab.CountCumAnal(PlayerRef) < CumSlutData[4]
		FavorLoss -= 1
		StrResult += "\nCum missing from my ass (Favor -1)"
	EndIf
	If !PlayerRef.WornHasKeyWord(Devious.zad_DeviousBelt) && !PlayerRef.WornHasKeyWord(Devious.zad_DeviousHarness)
		If StorageUtil.GetFloatValue(PlayerRef, "sr.inflater.cum.vaginal", missing = 0.0) < CumSlutData[5]
			FavorLoss -= 1
			StrResult += "\nCum has leaked from my pussy (Favor -1)"
		EndIf
		If StorageUtil.GetFloatValue(PlayerRef, "sr.inflater.cum.anal", missing = 0.0) < CumSlutData[6]
			FavorLoss -= 1
			StrResult += "\nCum has leaked from my ass (Favor -1)"
		EndIf
	EndIf
	If FavorLoss
		;FatherVoluntaryServeRel.Mod(FavorLoss)
		Fav.ModStat(Msg = "", Favour = FavorLoss,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
		StrResult += "\n\nFavor: " + FavorLoss
		Debug.MessageBox(StrResult)
	EndIf
	Return FavorLoss
EndFunction

Float Function GetCumSlutDirtiness()
	Float DirtySlutVal
	DirtySlutVal += (CumSlutData[1] * 0.2) ; Dirt
	DirtySlutVal += ((CumSlutData[2] / 2.0) * 0.2) ; Cum on face
	DirtySlutVal += ((CumSlutData[3] / 2.0) * 0.1) ; Cum on pussy
	DirtySlutVal += ((CumSlutData[4] / 2.0) * 0.1) ; Cum on ass
	
	DirtySlutVal += ((CumSlutData[5] / 6.0) * 0.2) ; FHU cum in pussy
	DirtySlutVal += ((CumSlutData[6] / 6.0) * 0.2) ; FHU cum in ass
	
	Return DirtySlutVal
EndFunction

Function GiftedCum(Form akBaseItem, Int aiItemCount)
	pchsGiftedCumCount.Mod(aiItemCount)
	FatherRef.RemoveItem(akBaseItem, aiItemCount, true, (Game.GetFormFromFile(0x1F1437, "pchsWartimes.esp") as ObjectReference)) ; pchsCumTempContainerRef
	If pchsFatherCumSlut.GetValueInt() == 0
		If RequiredCum && akBaseItem == RequiredCum
			pchsMetCumQuota.Mod(1)
			RequiredCum = None
			;FatherVoluntaryServeRel.Mod(1)
			;Debug.Notification("Father is pleased I got the specific cum he requested (Favor +1)")
			Fav.ModStat(Msg = "Father is pleased I got the specific cum he requested", Favour = 1.0,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
		EndIf
		If pchsGiftedCumCount.GetValueInt() >= pchsRequiredCumCount.GetValueInt()
			pchsMetCumQuota.Mod(1)
			;FatherVoluntaryServeRel.Mod(1)
			;Debug.Notification("Father is pleased I got all the cum he requested (Favor +1)")
			Fav.ModStat(Msg = "Father is pleased I got all the cum he requested", Favour = 1.0,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
			If !RequiredCum
				pchsFatherCumSlut.SetValueInt(-1)
			EndIf
		EndIf
	EndIf
EndFunction

Function CloseCumGiftMenu()
	RequiredCum = None
	;pchsGiftedCumCount.SetValueInt(0)
	pchsFatherCumSlutTimestamp.SetValue(Utility.GetCurrentGameTime())
	pchsFatherCumSlut.SetValue(-1)
EndFunction

Function DrinkCum()
	ObjectReference CumChest = (Game.GetFormFromFile(0x1F1437, "pchsWartimes.esp") as ObjectReference)
	Int i = CumChest.GetNumItems()
	Form CumPotion
	While i > 0
		i -= 1
		CumPotion = CumChest.GetNthForm(i)
		Int j = CumChest.GetItemCount(CumPotion)
		While j > 0
			j -= 1
			CumChest.RemoveItem(CumPotion, 1, true, PlayerRef)
			PlayerRef.EquipItem(CumPotion)
			Utility.Wait(2.0)
		EndWhile
	EndWhile
	pchsGiftedCumCount.SetValueInt(0)
	pchsMetCumQuota.SetValueInt(0)
	pchsFatherCumSlutTimestamp.SetValue(Utility.GetCurrentGameTime())
	pchsFatherCumSlut.SetValue(-1)
	IncCumSlutRank()
	SetCumSlutData()
EndFunction

Function IncCumSlutRank()
	If pchsPcCumSlut.GetValueInt() < 3
		If 40.0 > Utility.RandomFloat(0.0, 100.0)
			pchsPcCumSlut.Mod(1)
		EndIf
	EndIf
EndFunction

Function GetSlsLicence(Int LicType)
	Int FavorLoss = -(Menu.pchsSlsLicenceCost.GetValueInt())
	If LicType == 4
		FavorLoss = -(Menu.pchsSlsLicenceCostClothes.GetValueInt())
	EndIf
	Debug.Notification("Favor: " + FavorLoss)
	FatherVoluntaryServeRel.Mod(FavorLoss)
	
	;On_SLS_IssueLicence(Int LicenceType, Int TermDuration, Form Issuer, Form GiveLicTo, Bool DeductGold, Form Sender)
	Int GetLic = ModEvent.Create("_SLS_IssueLicence")
	If (GetLic)
		ModEvent.PushInt(GetLic, LicType)
		ModEvent.PushInt(GetLic, 0)
		ModEvent.PushForm(GetLic, StorageUtil.FormListGet(None, "_SLS_LicenceQuartermastersList", 0))
		ModEvent.PushForm(GetLic, PlayerRef)
		ModEvent.PushBool(GetLic, false)
		ModEvent.PushForm(GetLic, FatherRef)
		ModEvent.Send(GetLic)
	EndIf
EndFunction

Function ExcludeMotherFromSlac()
	If Game.GetModByName("SexLab Aroused Creatures.esp") != 255
		Faction slac_ExcludeFaction = Game.GetFormFromFile(0x08D7E9, "SexLab Aroused Creatures.esp") as Faction
		If slac_ExcludeFaction
			Apol.AldoRef.AddToFaction(slac_ExcludeFaction)			
		EndIf
	EndIf
EndFunction

Function SetBelethorsDog()
	If Game.GetModByName("Slaverun_Reloaded.esp") != 255
		(Self.GetOwningQuest().GetNthAlias(19) as ReferenceAlias).ForceRefTo(Game.GetFormFromFile(0x01FC4B, "Slaverun_Reloaded.esp") as Actor)
		(Game.GetFormFromFile(0x609A4B, "pchsWartimes.esp") as Actor).Disable() ; Bart
	Else
		(Game.GetFormFromFile(0x609A4B, "pchsWartimes.esp") as Actor).Enable()
		(Self.GetOwningQuest().GetNthAlias(19) as ReferenceAlias).ForceRefTo(Game.GetFormFromFile(0x609A4B, "pchsWartimes.esp") as Actor)
	EndIf
EndFunction

Function MakeFatherSlsAsshole()
	If StorageUtil.GetIntValue(None, "pchsWtMakeFatherSlsAsshole", Missing = -1) == 1 && Game.GetModByName("SL Survival.esp") != 255
		StorageUtil.UnSetIntValue(None, "pchsWtMakeFatherSlsAsshole")
		FatherRef.RemoveFromFaction(Game.GetFormFromFile(0x105AA6, "SL Survival.esp") as Faction)
	EndIf
EndFunction

Bool Function IsToeNailPolishBlocked()
	If PlayerRef.WornHasKeyWord(Devious.zad_DeviousBoots) || (PlayerRef.WornHasKeyWord(Devious.zad_DeviousLegCuffs) && StorageUtil.GetFormValue(None, "yps_Stockings"))
		Return true
	EndIf
	Return false
EndFunction

Function SlaveFatherFirewood(Actor Slave)
	If HomeSlaves.PassHomeTask(Slave) ; Slave completes task on player's behalf
		pchsFirewoodPileRef.AddItem(Firewood01, Utility.RandomInt(1, 2))
		HomeSlaves.TaskSuccess(Slave, 0)
	Else
		HomeSlaves.TaskFail(Slave, 0)
	EndIf
EndFunction

Function SlaveFatherFood(Actor Slave, Float currTime)
	If HomeSlaves.PassHomeTask(Slave) ; Slave completes task on player's behalf
		fatherHunger.SetValue(1)
		fatherHungerLastMeal.SetValue(Utility.GetCurrentGameTime())
		HomeSlaves.TaskSuccess(Slave, 0)
		Fav.ModStat(Msg = Slave.GetDisplayName() + " fed Father", Favour = 1.0,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
	Else
		HomeSlaves.TaskFail(Slave, 0)
		fatherHungerLastMeal.SetValue(currTime / 24.0)
		Fav.ModStat(Msg = Slave.GetDisplayName() + " messed up Father's meal", Favour = Menu.BaseFavourLoss,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
	EndIf
EndFunction

Function SlaveFatherDrink(Actor Slave, Float currTime)
	If HomeSlaves.PassHomeTask(Slave) ; Slave completes task on player's behalf
		fatherThirst.SetValue(1)
		fatherThirstLastDrink.SetValue(Utility.GetCurrentGameTime())
		HomeSlaves.TaskSuccess(Slave, 0)
		Fav.ModStat(Msg = Slave.GetDisplayName() + " got Father a drink", Favour = 1.0,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
	Else
		HomeSlaves.TaskFail(Slave, 0)
		fatherThirstLastDrink.SetValue(currTime / 24.0)
		Fav.ModStat(Msg = Slave.GetDisplayName() + " messed up Father's drink", Favour = Menu.BaseFavourLoss,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
	EndIf
EndFunction

Function SlaveFatherSex(Actor Slave, Float currTime)
	If PlayerRef.GetCurrentLocation() == Util.pchsWartimesHomeLocation
		Menu.HomeSex.FatherFucksTarget(Slave, AggChance = 50.0, Bed = Menu.HomeSex.GetRandomBed(Slave, CanFuckInOpen = true), AllowBed = true, FastStart = false)
	EndIf
	
	If HomeSlaves.PassHomeSexTask(Slave) ; Slave completes task on player's behalf
		fatherSex.SetValue(1)
		fatherSexTimestamp.SetValue(Utility.GetCurrentGameTime())
		HomeSlaves.TaskSuccess(Slave, 1)
		Fav.ModStat(Msg = Slave.GetDisplayName() + " sated Father's arousal", Favour = 1.0,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
	Else
		HomeSlaves.TaskFail(Slave, 1)
		fatherSexTimestamp.SetValue(currTime / 24.0)
		Fav.ModStat(Msg = Slave.GetDisplayName() + " messed up fucking Father", Favour = Menu.BaseFavourLoss,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
	EndIf
EndFunction

Function SlaveAldoSex(Actor Slave, Float currTime)
	If PlayerRef.GetCurrentLocation() == Util.pchsWartimesHomeLocation
		Menu.HomeSex.DogFucksSlaveTarget(Slave, AggChance = 50.0, Bed = Menu.HomeSex.GetRandomBed(Slave, CanFuckInOpen = true), AllowBed = true, FastStart = false)
	EndIf
	
	If HomeSlaves.PassHomeSexTask(Slave) ; Slave completes task on player's behalf
		pchsAldoSex.SetValue(0.0)
		pchsAldoSexTimestamp.SetValue(Utility.GetCurrentGameTime())
		HomeSlaves.TaskSuccess(Slave, 1)
		Fav.ModStat(Msg = Slave.GetDisplayName() + " sated Aldo's arousal", Favour = 1.0,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
	Else
		HomeSlaves.TaskFail(Slave, 1)
		pchsAldoSexTimestamp.SetValue(currTime / 24.0)
		Fav.ModStat(Msg = Slave.GetDisplayName() + " messed up fucking Aldo", Favour = Menu.BaseFavourLoss,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
	EndIf
EndFunction

Function SlaveBrutusSex(Actor Slave)
	If HomeSlaves.PassHomeSexTask(Slave) ; Slave completes task on player's behalf
		pchsHorseMilkTaskActive.SetValue(0)
		Util.HorseMilk.SetNextDeadline(DaysMin = 1, DaysMax = 1)
		HomeSlaves.TaskSuccess(Slave, 1)
		Fav.ModStat(Msg = Slave.GetDisplayName() + " milked Brutus' balls dry", Favour = 1.0,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
	Else
		HomeSlaves.TaskFail(Slave, 1)
		Util.HorseMilk.SetNextDeadline(DaysMin = 1, DaysMax = 1)
		pchsHorseMilkTaskActive.SetValueInt(0)
		Fav.ModStat(Msg = Slave.GetDisplayName() + " messed up milking Brutus", Favour = Menu.BaseFavourLoss,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
	EndIf
EndFunction

Function SlaveSupplyRun(Actor Slave)
	If HomeSlaves.PassHomeTask(Slave) ; Slave completes task on player's behalf
		SupplyRun.CompleteSupplyRun()
		Debug.Notification(Slave.GetDisplayName() + " completed the supply run")
	Else
		SupplyRun.FailSupplyRun()
		Debug.Notification(Slave.GetDisplayName() + " messed up the supply run")
	EndIf
EndFunction

Function SlaveCleanHouse(Actor Slave, Float currTime)
	If HomeSlaves.PassHomeTask(Slave) ; Slave completes task on player's behalf
		Int i = 0
		While i < dirtObjects.Length
			dirtObjects[i].Disable()
			i += 1
		EndWhile
		dirtLastClean.SetValue(Utility.GetCurrentGameTime())
		HomeSlaves.TaskSuccess(Slave, 0)
		Fav.ModStat(Msg = Slave.GetDisplayName() + " cleaned the house", Favour = 1.0,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
	Else
		HomeSlaves.TaskFail(Slave, 0)
		dirtLastClean.SetValue(currTime / 24.0)
		Fav.ModStat(Msg = Slave.GetDisplayName() + " failed cleaning the house", Favour = Menu.BaseFavourLoss,  Depravity = 0.0, Submission = 0.0, Sender = ThisQuest)
	EndIf
EndFunction

GlobalVariable Property pchsBoringStockings Auto
GlobalVariable Property pchsFatherIntimacyApproach Auto
GlobalVariable Property GameHour Auto
GlobalVariable Property pchsBeastiality Auto
GlobalVariable Property WTtimerStartGlobal auto

GlobalVariable Property pchsBathingCooloff Auto
GlobalVariable Property pchsBathingForbidden Auto

GlobalVariable Property pchsPCMilkCow auto
GlobalVariable Property pchsFatherMilkTimestamp auto
GlobalVariable Property pchsFatherMilk Auto
GlobalVariable Property pchsGiftedMilkCount Auto

Float[] Property CumSlutData Auto Hidden
GlobalVariable Property pchsMetCumQuota Auto
GlobalVariable Property pchsRequiredCumQuota Auto
GlobalVariable Property pchsRequiredCumCount Auto
GlobalVariable Property pchsGiftedCumCount Auto
GlobalVariable Property pchsFatherCumSlutTimestamp Auto
GlobalVariable Property pchsFatherCumSlut Auto
GlobalVariable Property pchsPcCumSlut Auto
Form Property RequiredCum Auto Hidden
Form Property Firewood01 Auto

GlobalVariable Property fatherHunger auto
GlobalVariable Property fatherHungerLastMeal auto
GlobalVariable Property fatherHungerGlobal auto

GlobalVariable Property fatherThirst auto
GlobalVariable Property fatherThirstLastDrink auto
GlobalVariable Property fatherThirstGlobal auto

GlobalVariable Property FatherVoluntaryServeRel Auto

GlobalVariable Property fatherSex auto
GlobalVariable Property fatherSexTimestamp auto
GlobalVariable Property pchsFatherSexCount Auto

GlobalVariable Property pchsHorseMilkDeadline Auto
GlobalVariable Property pchsHorseMilkTaskActive Auto

GlobalVariable Property pchsAldoSex auto
GlobalVariable Property pchsAldoSexTimestamp auto

GlobalVariable Property motherHealthGlobal auto
GlobalVariable Property motherHealthTimestampGlobal auto
GlobalVariable Property pchsMHealCost Auto

GlobalVariable Property MotherCaged Auto
GlobalVariable Property motherHealthCaged Auto

GlobalVariable Property taskHorse auto
GlobalVariable Property taskHorseCount auto
GlobalVariable Property taskHorseTimestamp auto

GlobalVariable Property taskOldman auto
GlobalVariable Property taskOldmanCount auto
GlobalVariable Property taskOldmanTimestamp auto

GlobalVariable Property taskSoldiers auto
GlobalVariable Property taskSoldiersCount auto
GlobalVariable Property taskSoldiersTimestamp auto

GlobalVariable Property taskDogs auto
GlobalVariable Property taskDogsCount auto
GlobalVariable Property taskDogsTimestamp auto

GlobalVariable Property taskParty auto
GlobalVariable Property taskPartyCount auto
GlobalVariable Property taskPartyTimestamp auto

GlobalVariable Property likeCollar Auto
GlobalVariable Property likeCollarTimestamp Auto

GlobalVariable Property likeHeels Auto
GlobalVariable Property likeHeelsTimestamp Auto

GlobalVariable Property likeNaked Auto
GlobalVariable Property likeNakedTimestamp Auto

GlobalVariable Property likeMaidClothes Auto
GlobalVariable Property likeMaidClothesTimestamp Auto

GlobalVariable Property pchsFatherLikeBondage Auto
GlobalVariable Property pchsFatherLikeBondageTimestamp Auto

GlobalVariable Property pchsFatherLikePiercings Auto
GlobalVariable Property pchsFatherLikePiercingsTimestamp Auto

GlobalVariable Property pchsFatherLikeHairColour Auto
GlobalVariable Property pchsFatherLikeHairColourTimestamp Auto

GlobalVariable Property pchsFatherLikeFashion Auto
GlobalVariable Property pchsFatherLikeFashionTimestamp Auto
GlobalVariable Property pchsFashionNeeded Auto

GlobalVariable Property pchsFatherLikeDirt Auto
GlobalVariable Property pchsFatherLikeDirtTimestamp Auto

GlobalVariable Property FatherForcegreetGlobal Auto
GlobalVariable Property FatherForcegreetGlobalTimestamp Auto

GlobalVariable Property GuestForcegreetGlobal Auto
GlobalVariable Property GuestForcegreetGlobalTimestamp Auto

GlobalVariable Property dirtLastClean auto
ObjectReference[] Property dirtObjects auto

GlobalVariable Property wartimesQuestStatus auto

GlobalVariable Property pchsPcIsWearingCollar Auto
GlobalVariable Property pchsPcIsWearingHeels Auto

GlobalVariable Property pchsSupplyRuns Auto
GlobalVariable Property pchsSupplyRunNext Auto

GlobalVariable Property pchsTaskFirewood Auto

GlobalVariable Property pchsAmpInstalled Auto

GlobalVariable Property PCPregnant Auto
GlobalVariable Property PCBreeder Auto
GlobalVariable Property PCDepravity Auto
GlobalVariable Property PCSubmission Auto

GlobalVariable Property pchsMmeInstalled Auto
GlobalVariable Property pchsSlsInstalled Auto

Actor Property PlayerREF Auto
Actor Property MotherREF Auto
Actor Property FatherRef Auto
Actor Property AldoRef Auto

ObjectReference Property pchsFirewoodPileRef Auto

Idle Property CarryPot Auto
Idle Property CarryDrinks Auto
GlobalVariable Property OffersFood auto
GlobalVariable Property OffersDrink auto

GlobalVariable Property PlugType Auto

Armor Property MeadPlugBottomIn Auto
Armor Property MeadPlugTopIn Auto
Armor Property CarrotPlug Auto
Armor Property FlutePlugShallow Auto
Armor Property FlutePlugDeep Auto

Potion Property Mead Auto
Potion Property MeadBB Auto
Potion Property MeadBBR Auto
Potion Property MeadHB Auto
Potion Property Carrot Auto

miscobject Property MeadBottle Auto
miscobject Property Flute Auto
miscobject Property Flute1 Auto

Sound Property PlugOutSound Auto
Sound Property PlugInSound Auto

Quest Property ThisQuest Auto

Float SexSceneFavour
Float SexSceneDepravity
Float SexSceneSubmission

pchsWtClutterIsTidy Property IsTidy Auto
pchsCumPools Property CumPools Auto
pchsWtHomeSlaves Property HomeSlaves Auto
SexlabFramework Property Sexlab Auto
pchsWartimesMCM Property Menu Auto
pchsWtPregnancy Property Preg Auto
pchsWtFavour Property Fav Auto
pchsWtApology Property Apol Auto
pchsSupplyRun Property SupplyRun Auto
pchsWtUtil Property Util Auto
pchsTossOut Property TossOut Auto
pchsWtInterfaceDevious Property Devious Auto
