Scriptname pchsWtClutterTidy extends Quest  

; GetEditorLocation() is fairly useless. At some point it becomes the cell it's currently placed in. MoveToMyEditorLocation is reliable though

Event OnInit()
	If IsRunning()
		Int i = 0
		ObjectReference ClutterRef
		Location CurLoc = PlayerRef.GetCurrentLocation()
		If CurLoc
			While i < GetNumAliases()
				ClutterRef = (GetNthAlias(i) as ReferenceAlias).GetReference()
				If ClutterRef
					TidyObject(ClutterRef, CurLoc)
				Else
					IsTidy.GetUntidyCount()
					Return
				EndIf
				i += 1
			EndWhile
			IsTidy.GetUntidyCount()
		Else
			Debug.Notification("I can't tidy out here")
		EndIf
	EndIf
EndEvent

Function TidyObject(ObjectReference ClutterRef, Location CurLoc)
	pchsClutterMarkerRef.MoveTo(ClutterRef) ; Store position temporarily in case we need to roll back
	Debug.Trace("pchs: Clutter: " + ClutterRef + " - " + ClutterRef.GetDisplayName() + " - " + CurLoc + " - Clutter Editor Loc: " + ClutterRef.GetEditorLocation())

	If IsDynamicForm(ClutterRef) ; If dynamic then it's editor location is the same cell it was placed in. So use stored position
		StoredPos = StorageUtil.FloatListToArray(ClutterRef, "pchsWtOriginalPos")
		If StoredPos.Length == 6 ; Clutter has a new stored position
			MoveToStoredPos(ClutterRef, StoredPos)
			
		Else
			Debug.Trace("pchs: ClutterTidy(): " + ClutterRef.GetDisplayName() + " - " + ClutterRef + ". Does not belong in this cell and has no stored position. CurLoc: " + CurLoc + ". Orig Loc: " + ClutterRef.GetEditorLocation() + ". Dyamanic: " + IsDynamicForm(ClutterRef))
		EndIf
	
	Else
		ClutterRef.MoveToMyEditorLocation()
		If CurLoc != ClutterRef.GetCurrentLocation() ; Move back
			;Debug.Messagebox("Hello")
			StoredPos = StorageUtil.FloatListToArray(ClutterRef, "pchsWtOriginalPos")
			If StoredPos.Length == 6 ; Clutter has a new stored position
				MoveToStoredPos(ClutterRef, StoredPos)
			Else
				Debug.Trace("pchs: ClutterTidy(): " + ClutterRef.GetDisplayName() + " - " + ClutterRef + ". Does not belong in this cell and has no stored position. CurLoc: " + CurLoc + ". Orig Loc: " + ClutterRef.GetEditorLocation() + ". Dyamanic: " + IsDynamicForm(ClutterRef))
				ClutterRef.MoveTo(pchsClutterMarkerRef)
				Utility.Wait(0.05)
				ClutterRef.ApplyHavokImpulse(0.0, 0.0, 1.0, 1.0)
			EndIf
		EndIf
	EndIf
EndFunction

Bool Function IsDynamicForm(ObjectReference ObjRef)
	Int Id = ObjRef.GetFormID()
	If Math.LogicalAnd(Id, 0xFF000000) == 0xFF000000
		Return true
	EndIf
	Return false
EndFunction

Function MoveToStoredPos(ObjectReference ClutterRef, Float[] StoredPos)
	ClutterRef.MoveTo(pchsClutterMarkerRef) ; Position is set within the cell it's currently in. Move back to current cell first
	
	pchsClutterMarkerRef.SetPosition(StoredPos[0], StoredPos[1], StoredPos[2])
	pchsClutterMarkerRef.SetAngle(StoredPos[3], StoredPos[4], StoredPos[5])
	
	ClutterRef.MoveTo(pchsClutterMarkerRef)
	
	Utility.Wait(0.1)
	ClutterRef.ApplyHavokImpulse(0.0, 0.0, 1.0, 1.0)
	
EndFunction

Float[] StoredPos

ObjectReference Property pchsClutterMarkerRef Auto

Actor Property PlayerRef Auto

pchsWtClutterIsTidy Property IsTidy Auto
