Scriptname pchsWtFavour extends Quest

Event OnInit()
	If Self.IsRunning()
		;SetupSexTags()
		Setup()
		StorageUtil.SetIntValue(Self, "pchsApologyFirstTimeHelp", 1)
	EndIf
EndEvent

Function Setup()
	;BuildPunishmentVars()
	RegisterForModEvent("pchsWtModStat", "On_pchsWtModStat")
	RegisterForModEvent("pchsWtIncTasksDone", "On_pchsWtIncTasksDone")
	RegisterForModEvent("pchsWtBeganDialogApology", "On_pchsWtBeganDialogApology")
	RegisterForModEvent("pchsWtApologySuccess", "On_pchsWtApologySuccess")
	RegisterForModEvent("pchsWtApologyFail", "On_pchsWtApologyFail")
	RegisterForModEvent("pchsWtApologyPunishment", "On_pchsWtApologyPunishment")
	RegisterForModEvent("pchsWtPunishBegin", "On_pchsWtPunishBegin")
EndFunction

; Mod Events ==============================================================================================
Event On_pchsWtModStat(string Msg, float Favour, Float Depravity, Float Submission, Form Sender)
	ModStat(Msg, Favour, Depravity, Submission, Sender)
EndEvent

Event On_pchsWtIncTasksDone(string eventName, string strArg, float numArg, Form Sender)
	IncTasksDone()
EndEvent

Event On_pchsWtBeganDialogApology(string eventName, string strArg, float numArg, Form Sender)
	; SendModEvent("pchsWtBeganDialogApology")
	BeganDialogApology()
EndEvent

Event On_pchsWtApologySuccess(string eventName, string strArg, float numArg, Form Sender)
	; SendModEvent("pchsWtApologySuccess", "")
	
	Debug.Trace("pchs: On_pchsWtApologySuccess(): ApolPun: " + ApolPun + ". strArg: " + strArg)
	ApologySuccess(strArg)
EndEvent

Event On_pchsWtApologyFail(string eventName, string strArg, float numArg, Form Sender)
	; SendModEvent("pchsWtApologyFail")
	
	Debug.Trace("pchs: On_pchsWtApologyFail(): ApolPun: " + ApolPun)
	ApologyFail()
EndEvent

Event On_pchsWtApologyPunishment(string eventName, string strArg, float numArg, Form Sender)
	; SendModEvent("pchsWtApologyPunishment", "")
	
	; FatherMassage - 10
	; FatherHandjob - 20
	
	Debug.Trace("pchs: On_pchsWtApologyPunishment(): strArg: " + strArg)
	ApolPun = strArg
	pchsPunishSelect.SetValue(StorageUtil.GetIntValue(Self, "strArg"))
EndEvent

Event On_pchsWtPunishBegin(string eventName, string strArg, float numArg, Form Sender)
	; SendModEvent("pchsWtPunishBegin")
	
	Debug.Trace("pchs: On_pchsWtPunishBegin(): ApolPun: " + ApolPun)
	Apology.BeginPunish(ApolPun)
EndEvent

; ===========================================================================================================

Event OnUpdate()
	;Debug.Messagebox("Update")
	UnRegisterForUpdateGameTime()
	ApologyFail()
EndEvent

Event OnUpdateGameTime()
	;Debug.Messagebox("UpdateGameTime")
	UnRegisterForUpdate()
	ApologyFail()
EndEvent

Function BeganDialogApology()
	UnRegisterForUpdate()
	UnRegisterForUpdateGameTime()
	pchsApologyDialogEn.SetValue(0)
EndFunction

Function ModStat(string Msg, float Favour, Float Depravity, Float Submission, Form Sender)
	;	(Game.GetFormFromFile(0x23316F, "pchsWartimes.esp") as pchsWtFavour).ModStat(Msg = "", Favour = .0,  Depravity = .0, Submission = .0, Sender = Self)
	;	Favour.ModStat(Msg = "", Favour = .0,  Depravity = .0, Submission = .0, Sender = Self)
	
	Float FavourFinal = GetFavourFinal(Favour)
	Debug.Trace("pchs: ModStat(): Favour: " + Favour + ". FavLossFinal: " + FavourFinal + ". Depravity: " + Depravity + ". Submission: " + Submission + ". Str: " + Msg + ". Sender: " + Sender)
	If Msg
		Debug.Notification(Msg + GetAddonString(FavourFinal, Depravity, Submission))
	Else
		If FavourFinal > 0.0
			Debug.Notification("Father looks pleased" + GetAddonString(FavourFinal, Depravity, Submission))
		ElseIf FavourFinal < 0.0
			Debug.Notification("Father is unhappy with me" + GetAddonString(FavourFinal, Depravity, Submission))
		EndIf
	EndIf
	pchsFatherVoluntaryServeRep.Mod(FavourFinal)
	
	pchsPCDepravity.SetValue(PapyrusUtil.ClampFloat(pchsPCDepravity.GetValue() + Depravity, 0.0, 100.0))
	pchsPCSubmission.SetValue(PapyrusUtil.ClampFloat(pchsPCSubmission.GetValue() + Submission, 0.0, 100.0))
	
	;/
	Float Value = pchsPCDepravity.GetValue()	
	If Value + Depravity > 0.0
		pchsPCDepravity.Mod(Depravity)
	Else
		pchsPCDepravity.SetValue(0.0)
	EndIf
	
	Value = pchsPCSubmission.GetValue()
	If Value + Submission > 0.0
		pchsPCSubmission.Mod(Submission)
	Else
		pchsPCSubmission.SetValue(0.0)
	EndIf
/;
	If Favour > 0
		IncTasksDone()
		If pchsFatherVoluntaryServeRep.GetValue() > 100.0
			pchsFatherVoluntaryServeRep.SetValue(100.0)
		EndIf
	Else
		CheckBed()
		;If pchsFatherVoluntaryServeRep.GetValue() <= -10.0
		;	TossOut.BeginTossOut()
		;EndIf
	EndIf
EndFunction

Function IncTasksDone()
	Debug.Trace("pchs: IncTasksDone(): ")
	pchsFatherTasksDone.Mod(1.0)
	If pchsFatherTasksDone.GetValue() > TasksTilMaxLoss
		pchsFatherTasksDone.SetValue(TasksTilMaxLoss)
	EndIf
	FavorLossMult = (1.0 + ((pchsFatherTasksDone.GetValue() / TasksTilMaxLoss) * (FavorLossAtMax - 1.0))) as Int
EndFunction

Float Function GetFavourFinal(Float Favour)
	Float FavourFinal = Favour
	If Favour < 0.0
		FavourFinal = (FavorLossMult * Favour) as Int
		If pchsFatherVoluntaryServeRep.GetValue() + FavourFinal < CurMaxDisfavour
			FavourFinal = 0
			If pchsFatherVoluntaryServeRep.GetValue() > 0.0
				FavourFinal = -(pchsFatherVoluntaryServeRep.GetValue()) + CurMaxDisfavour
			Else
				FavourFinal = CurMaxDisfavour - pchsFatherVoluntaryServeRep.GetValue()
			EndIf
			Debug.Notification("Father looks really angry with me!")
		EndIf
		SaveFavourLoss(FavourFinal, Favour < 0.0)
	EndIf
	Return FavourFinal
EndFunction

Function SaveFavourLoss(Float Favour, Bool IsFavourLoss)
	If Favour < 0.0 || IsFavourLoss
		StorageUtil.FloatListInsert(Self, "FavourLossHistory", 0, Favour)
		StorageUtil.FloatListInsert(Self, "FavourLossTimes", 0, GameDaysPassed.GetValue())
		CleanFavourLossHistory()
	EndIf
EndFunction

Function CleanFavourLossHistory()
	Float LastHour = GameDaysPassed.GetValue() - (1.0 / 24.0)
	Int i = StorageUtil.FloatListCount(Self, "FavourLossTimes")
	While i > 0
		i -= 1
		If StorageUtil.FloatListGet(Self, "FavourLossTimes", i) < LastHour
			StorageUtil.FloatListRemoveAt(Self, "FavourLossTimes", i)
			StorageUtil.FloatListRemoveAt(Self, "FavourLossHistory", i)
		EndIf
	EndWhile

	If CanApologise()
		;Debug.Messagebox("can apologise")
		pchsApologyQuest.Start()
		pchsApologyDialogEn.SetValue(1)
		If StorageUtil.GetIntValue(Self, "pchsApologyFirstTimeHelp", Missing = -1) == 1
			StorageUtil.UnSetIntValue(Self, "pchsApologyFirstTimeHelp")
			Debug.Messagebox("I've upset Father. Maybe I should apologize to him if I want to stay on his good side...")
		EndIf
		RegisterForSingleUpdate(120.0)
		RegisterForSingleUpdateGameTime(0.99)
	Else
		pchsApologyDialogEn.SetValue(0)
	EndIf
EndFunction

Bool Function CanApologise()
	; Getting into situations where toss out isn't firing because apologies aren't triggered because favour regain would be less than 1.0
	
	If pchsFatherVoluntaryServeRep.GetValue() <= -10
		ShouldTossOut = true
		Return true
	EndIf
	
	Float Favour
	Int i = StorageUtil.FloatListCount(Self, "FavourLossHistory")
	;Debug.Messagebox(StorageUtil.FloatListToArray(Self, "FavourLossHistory"))
	While i > 0
		i -= 1
		Favour += StorageUtil.FloatListGet(Self, "FavourLossHistory", i)
		If (Favour * ApologyFavRegainRate) <= -1.0 ; Can't apologise if favour gain would be less than 1.0
			Return true
		EndIf
	EndWhile
	Return false
	
	;/
	If StorageUtil.FloatListCount(Self, "FavourLossHistory") > 0
		Return true
	EndIf
	Return false
	/;
EndFunction

Function ApologySuccess(String Msg = "")
	Float FavourRegain
	Int i = 0
	While i < StorageUtil.FloatListCount(Self, "FavourLossHistory")
		FavourRegain += StorageUtil.FloatListGet(Self, "FavourLossHistory", i)
		i += 1
	EndWhile
	;Debug.Messagebox("FavourRegain: " + FavourRegain + "\nFinal: " + FavourRegain * ApologyFavRegainRate + "\nAbs: " + Math.Abs(FavourRegain * ApologyFavRegainRate))
	FavourRegain = (Math.Abs(FavourRegain * ApologyFavRegainRate)) as Int
	If !Msg
		Msg = "Father is satisfied with my apology"
	EndIf
	ModStat(Msg, Favour = FavourRegain, Depravity = 0.0, Submission = 0.0, Sender = Self)

	StorageUtil.FloatListClear(Self, "FavourLossHistory")
	StorageUtil.FloatListClear(Self, "FavourLossTimes")
	pchsApologyDialogEn.SetValue(0)
	;CurMaxDisfavour = -5 ; Getting stuck at -5 for some reason.....................................
	pchsApologyCount.Mod(1)
	ShouldTossOut = false
	pchsApologyFailCount.SetValueInt(0)
EndFunction

Function ApologyFail()
	;Debug.Messagebox("Fail")
	Debug.Trace("pchs: ApologyFail()")
	StorageUtil.FloatListClear(Self, "FavourLossHistory")
	StorageUtil.FloatListClear(Self, "FavourLossTimes")
	pchsApologyDialogEn.SetValue(0)
	
	If ShouldTossOut
		ShouldTossOut = false
		TossOut.BeginTossOut()
	Else
		pchsApologyFailCount.Mod(1)
	EndIf
	;CurMaxDisfavour = -10
EndFunction

String Function GetAddonString(Float Favour, Float Depravity, Float Submission)
	String FavSign
	If Favour >= 0.0
		FavSign = "+"
	EndIf
	String DepSign
	If Depravity >= 0.0
		DepSign = "+"
	EndIf
	String SubSign
	If Submission >= 0.0
		SubSign = "+"
	EndIf

	If Favour
		If Depravity && Submission
			Return " (Fav " + FavSign + (Favour as Int) + ", Dep " + DepSign + (Depravity as Int) + ", Sub " + SubSign + (Submission as Int) + ")"
		ElseIf Depravity
			Return " (Fav " + FavSign + (Favour as Int) + ", Dep " + DepSign + (Depravity as Int) + ")"
		ElseIf Submission
			Return " (Fav " + FavSign + (Favour as Int) + ", Sub " + SubSign + (Submission as Int) + ")"
		Else
			Return " (Favour " + FavSign + (Favour as Int) + ")"
		EndIf
	
	ElseIf Depravity
		If Submission
			Return " (Dep " + DepSign + (Depravity as Int) + ", Sub " + SubSign + (Submission as Int) + ")"
		Else
			Return " (Depravity " + DepSign + (Depravity as Int) + ")"
		EndIf
		
	ElseIf Submission
		Return " (Submission " + SubSign + (Submission as Int) + ")"
	EndIf
	Return ""
EndFunction

String Function GetTagsForSex(String SexType, String CreatureType = "")
	;/
		SexType: handjob, blowjob, vaginal, anal
		CreatureType: "" = human, "dog", "horse"
	/;
	
	;Debug.Trace("pchs: Sex Tags: " + JsonUtil.GetStringValue("Wartimes/SexTags.json", CreatureType + "_" + SexType))
	String Tags = JsonUtil.GetStringValue("Wartimes/SexTags.json", CreatureType + "_" + SexType)
	Debug.Trace("pchs: GetTagsForSex(): SexType: " + SexType + ".  CreatureType: " + CreatureType + " - " + Tags)
	Return Tags
EndFunction

String Function GetSupTagsForSex(String SexType, String CreatureType = "")
	;/
		SexType: handjob, blowjob, vaginal, anal
		CreatureType: "" = human, "dog", "horse"
	/;
	
	;Debug.Trace("pchs: Supress Sex Tags: " + JsonUtil.GetStringValue("Wartimes/SexTags.json", CreatureType + "_" + SexType + "_sup"))
	String SupTags = JsonUtil.GetStringValue("Wartimes/SexTags.json", CreatureType + "_" + SexType + "_sup")
	Debug.Trace("pchs: GetSupTagsForSex(): SexType: " + SexType + ".  CreatureType: " + CreatureType + " - " + SupTags)
	Return SupTags
EndFunction

Int Function GetSkoomaJunkieLevel(Actor akTarget, Bool IsWithdrawing)
	; IsWithdrawing: true - Withdrawal effect must be active. False - Don't care
	
	; Addiction Levels
	; -1 - Not installed
	; 0 - Not addicted
	; 1 - Experimentation
	; 2 - Regular Use
	; 3 - Risky Use
	; 4 - Dependence
	; 5 - Addiction
	
	If Game.GetModByName("SexLabSkoomaWhore.esp") != 255
		Int AddictionLevel = (Game.GetFormFromFile(0x01441D, "SexLabSkoomaWhore.esp") as GlobalVariable).GetValueInt()
		If IsWithdrawing 
			If akTarget.HasMagicEffect(Game.GetFormFromFile(0x0012CB, "SexLabSkoomaWhore.esp") as MagicEffect)
				Return AddictionLevel
			Else
				Return 0
			EndIf
		Else
			Return AddictionLevel
		EndIf
	EndIf
	Return -1
EndFunction

Function SetSkoomaFavourCost()
	Int Addiction = GetSkoomaJunkieLevel(PlayerRef, false)
	If Addiction == -1
		pchsSkoomaFav.SetValue(-1.0)
	ElseIf Addiction == 0
		pchsSkoomaFav.SetValue(2.0)
	ElseIf Addiction <= 2
		pchsSkoomaFav.SetValue(1.0)
	ElseIf Addiction == 3
		pchsSkoomaFav.SetValue(-1.0)
	Else
		pchsSkoomaFav.SetValue(-2.0)
	EndIf
	PchsPlayer.ThisQuest.UpdateCurrentInstanceGlobal(pchsSkoomaFav)
EndFunction

Function GetSkooma()
	String Msg = "Father is happy to help me"
	ModStat(Msg, Favour = pchsSkoomaFav.GetValue(), Depravity = 0.0, Submission = 0.0, Sender = Self)
	Form Skooma = Game.GetFormFromFile(0x57A7A, "Skyrim.esm")
	PlayerRef.AddItem(Skooma, 1, true)
	PlayerRef.EquipItem(Skooma, 1, true)
	pchsSkoomaAvailToday.Mod(-1)
EndFunction

Function CheckBed()
	If pchsFatherVoluntaryServeRep.GetValue() < 0.0 
		If (Game.GetFormFromFile(0x005963, "pchsWartimes.esp") as ObjectReference).IsEnabled() ; Bed
			EnableSlaveBed()
		EndIf
		If (Game.GetFormFromFile(0x4CFAC3, "pchsWartimes.esp") as ObjectReference).IsEnabled() ; Alchemy table
			Util.ToggleAlchemyTable(EnableIt = false)
		EndIf
	EndIf
EndFunction

Function EnableSlaveBed()
	(Game.GetFormFromFile(0x005963, "pchsWartimes.esp") as ObjectReference).Disable() ; Good Bed
	(Game.GetFormFromFile(0x03D7D7, "pchsWartimes.esp") as ObjectReference).Enable() ; Bedroll
	(Game.GetFormFromFile(0x00FC24, "pchsWartimes.esp") as ObjectReference).Enable() ; Frame
EndFunction

Function EnableGoodBed()
	(Game.GetFormFromFile(0x03D7D7, "pchsWartimes.esp") as ObjectReference).Disable() ; Bedroll
	(Game.GetFormFromFile(0x00FC24, "pchsWartimes.esp") as ObjectReference).Disable() ; Frame
	(Game.GetFormFromFile(0x005963, "pchsWartimes.esp") as ObjectReference).Enable() ; Good Bed
EndFunction

Function AskForRapeTat()
	pchsRapeTatAvailToday.Mod(-1)
	SendModEvent("RapeTattoos_addTattoo")
	ModStat("Father is pleased with my submissiveness", 1.0, Depravity = 0.0, Submission = 1.0, Sender = Self)
EndFunction

pchsWartimesMCM Property Menu Auto
pchsTossOut Property TossOut Auto
pchsWtApology Property Apology Auto
pchsWartimesPlayerScript Property PchsPlayer Auto
pchsWtUtil Property Util Auto

Bool Property ShouldTossOut = false Auto Hidden

Float Property FavorLossMult = 1.0 Auto Hidden
Float Property FavorLossAtMax = 10.0 Auto Hidden
Float Property CurMaxDisfavour = -10.0 Auto Hidden
Float Property ApologyFavRegainRate = 0.8 Auto Hidden
Float Property TasksTilMaxLoss = 100.0 Auto Hidden

String Property ApolPun Auto Hidden

Actor Property PlayerRef Auto

Quest Property pchsApologyQuest Auto


GlobalVariable Property pchsApologyFailCount Auto
GlobalVariable Property pchsSkoomaFav Auto
GlobalVariable Property pchsSkoomaAvailToday Auto
GlobalVariable Property pchsRapeTatAvailToday Auto
GlobalVariable Property pchsFatherTasksDone Auto
GlobalVariable Property pchsFatherVoluntaryServeRep Auto
GlobalVariable Property pchsPCSubmission Auto
GlobalVariable Property pchsPCDepravity Auto
GlobalVariable Property pchsApologyDialogEn Auto
GlobalVariable Property pchsPunishSelect Auto
GlobalVariable Property pchsApologyCount Auto
GlobalVariable Property GameDaysPassed Auto

GlobalVariable Property pchsBoundaryBeast Auto
; 0 - Mundane - Cook/clean
; 10 - Massage
; 20 - Handjob
; 30 - Blowjob
; 40 - Blowjob Swallowing
; 50 - Anal
; 60 - Cum bottle drinking/collecting
; 70 - Lock in cellar
; 80 - Spanking
; 90 - Whipping
; 100 - Bondage funiture
; 110 - Public anonymous sex
; 120 - Mother sex
; 130 - Dog Handjob ; Public anonymous +5
; 140 - Horse handjob ; Public anonymous +5
; 150 - Any creature handjob ; Public anonymous +5
; 160 - Dog blowjob ; Public anonymous +5
; 170 - Horse blowjob ; Public anonymous +5
; 180 - Any creature blowjob ; Public anonymous +5
; 190 - Dog vaginal ; Public anonymous +5
; 200 - Horse vaginal ; Public anonymous +5
; 210 - Any creature vaginal ; Public anonymous +5
; 220 - Dog anal ; Public anonymous +5
; 230 - Horse anal ; Public anonymous +5
; 240 - Any creature anal ; Public anonymous +5


