Scriptname pchsWtInterfaceDevious extends Quest Conditional

Quest libsQuest

Event OnInit()
	RegisterForModEvent("_pchs_Int_PlayerLoadsGame", "On_pchs_Int_PlayerLoadsGame")
	StorageUtil.SetIntValue(None, "pchsWtFatherBeltIntro", 1)
EndEvent

Event On_pchs_Int_PlayerLoadsGame(string eventName, string strArg, float numArg, Form sender)
	PlayerLoadsGame()
EndEvent

Function PlayerLoadsGame()
	If Game.GetModByName("Devious Devices - Expansion.esm") != 255
		If GetState() != "Installed"
			GoToState("Installed")
		EndIf
		DeviousSupplyRunHood = JsonUtil.GetFormValue("Wartimes/Settings.json", "devioussupplyrunhood")
		If !DeviousSupplyRunHood
			DeviousSupplyRunHood = Game.GetFormFromFile(0x01E69B, "Devious Devices - Expansion.esm")
			Debug.Messagebox("Wartimes error getting custom supply run mask. Form not found. Check your FormId/mod name in settings.json\n\nHood must be a working devious device and have keyword zad_DeviousHood to work correctly in game")
		EndIf
	
	Else
		If GetState() != ""
			GoToState("")
		EndIf
	EndIf
EndFunction

Event OnEndState()
	Utility.Wait(5.0) ; Wait before entering active state to help avoid making function calls to scripts that may not have initialized yet.
	
	libsQuest = Game.GetFormFromFile(0x00F624,"Devious Devices - Integration.esm") as Quest
	zad_DeviousPlugVaginal = Game.GetFormFromFile(0x01DD7C, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousPlugAnal = Game.GetFormFromFile(0x01DD7D, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousBelt = Game.GetFormFromFile(0x003330, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousHood = Game.GetFormFromFile(0x02AFA2, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousBlindfold = Game.GetFormFromFile(0x011B1A, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousBra = Game.GetFormFromFile(0x003DFA, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousGag = Game.GetFormFromFile(0x007EB8, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousHeavyBondage = Game.GetFormFromFile(0x05226C, "Devious Devices - Integration.esm") as Keyword
	zad_DeviousSuit = Game.GetFormFromFile(0x02AFA3, "Devious Devices - Assets.esm") as Keyword
	zad_Lockable = Game.GetFormFromFile(0x003894, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousHarness = Game.GetFormFromFile(0x017C43, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousBoots = Game.GetFormFromFile(0x027F29, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousGloves = Game.GetFormFromFile(0x02AFA1, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousArmCuffs = Game.GetFormFromFile(0x003DF9, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousLegCuffs = Game.GetFormFromFile(0x003DF8, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousPiercingsVaginal = Game.GetFormFromFile(0x023E70, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousPiercingsNipple = Game.GetFormFromFile(0x00CA39, "Devious Devices - Assets.esm") as Keyword
	zad_PermitOral = Game.GetFormFromFile(0x00FAC9, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousCorset = Game.GetFormFromFile(0x003330, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousCollar = Game.GetFormFromFile(0x027F28, "Devious Devices - Assets.esm") as Keyword
	
	DeviceKwds = New Keyword[14]
	DeviceKwds[0] = zad_DeviousBelt
	DeviceKwds[1] = zad_DeviousHood
	DeviceKwds[2] = zad_DeviousBlindfold
	DeviceKwds[3] = zad_DeviousBra
	DeviceKwds[4] = zad_DeviousGag
	DeviceKwds[5] = zad_DeviousHeavyBondage
	DeviceKwds[6] = zad_DeviousSuit
	DeviceKwds[7] = zad_DeviousHarness
	DeviceKwds[8] = zad_DeviousBoots
	DeviceKwds[9] = zad_DeviousGloves
	DeviceKwds[10] = zad_DeviousArmCuffs
	DeviceKwds[11] = zad_DeviousLegCuffs
	DeviceKwds[12] = zad_DeviousCorset
	DeviceKwds[13] = zad_DeviousCollar
EndEvent

Bool Function GetIsInterfaceActive()
	Return GetState() == "Installed"
EndFunction

Function RestartInterface()
	Self.GoToState("")
	Utility.Wait(3.0)
	PlayerLoadsGame()
EndFunction

Function AdjustDeviceRemovalCost(Float Multiplier = 1.0)
	pchsDdRemCost.Mod((Multiplier * JsonUtil.GetIntValue("Wartimes/Settings.json", "ddreminc", missing = 10)) as Int)
	If pchsDdRemCost.GetValue() > JsonUtil.GetIntValue("Wartimes/Settings.json", "ddremmax", missing = 50)
		pchsDdRemCost.SetValueInt(JsonUtil.GetIntValue("Wartimes/Settings.json", "ddremmax", missing = 50))
	EndIf
	Fav.pchsPlayer.ThisQuest.UpdateCurrentInstanceGlobal(pchsDdRemCost)
EndFunction

State Installed
	Event OnEndState()
		pchsDdIsBelted.SetValue(0)
		pchsDdIsBlindfolded.SetValue(0)
		pchsDdIsBraed.SetValue(0)
		pchsDdIsGagged.SetValue(0)
		pchsDdIsHeavilyBound.SetValue(0)
		pchsDdIsSuited.SetValue(0)
		pchsDdIsWearingAnyDevice.SetValue(0)
		pchsDdIsHarnessed.SetValue(0)
	EndEvent
	
	Function SetDeviceGlobs()
		Bool IsDeviced = IsWearingAnyDevice(PlayerRef)
		pchsDdIsWearingAnyDevice.SetValue(IsDeviced as Float)
		If IsDeviced
			pchsDdIsBelted.SetValue(PlayerRef.WornHasKeyword(zad_DeviousBelt) as Float)
			pchsDdIsBlindfolded.SetValue(PlayerRef.WornHasKeyword(zad_DeviousBlindfold) as Float)
			pchsDdIsBraed.SetValue(PlayerRef.WornHasKeyword(zad_DeviousBra) as Float)
			pchsDdIsGagged.SetValue(PlayerRef.WornHasKeyword(zad_DeviousGag) as Float)
			pchsDdIsHeavilyBound.SetValue(PlayerRef.WornHasKeyword(zad_DeviousHeavyBondage) as Float)
			pchsDdIsSuited.SetValue(PlayerRef.WornHasKeyword(zad_DeviousSuit) as Float)
			pchsDdIsHooded.SetValue(PlayerRef.WornHasKeyword(zad_DeviousHood) as Float)
			pchsDdIsHarnessed.SetValue(PlayerRef.WornHasKeyword(zad_DeviousHarness) as Float)
			pchsDdIsBooted.SetValue(PlayerRef.WornHasKeyword(zad_DeviousBoots) as Float)
			pchsDdIsGloved.SetValue(PlayerRef.WornHasKeyword(zad_DeviousGloves) as Float)
		EndIf
	EndFunction
	
	Function DialogRemoveDeviceByInt(Actor akActor, Int DeviceInt)
		;Fav.ModStat(Msg = "", Favour = -(pchsDdRemCost.GetValue()), Depravity = 0.0, Submission = 0.0, Sender = Self)
		Form DeviceInventory = GetWornDeviceByKeyword(akActor, DeviceKwds[DeviceInt])
		If DeviceInventory
			pchsFatherVoluntaryServeRep.Mod(-(Math.Floor(pchsDdRemCost.GetValue())))
			AdjustDeviceRemovalCost()
			RemoveDevice(akActor, deviceInventory = GetWornDeviceByKeyword(akActor, DeviceKwds[DeviceInt]))
			akActor.AddItem(DeviceInventory)
		EndIf
		SetDeviceGlobs()
	EndFunction
	
	Function RebeltPlayerAfterSex()
		RegisterForModEvent("HookAnimationEnd", "OnAnimationEnd")
	EndFunction
	
	Event OnAnimationEnd(int tid, bool HasPlayer)
		If HasPlayer
			If StorageUtil.GetIntValue(None, "pchsWtFatherBeltIntro") != 1
				PlugActor(PlayerRef)
				Int Timeout = 10
				While !PlayerRef.WornHasKeyword(zad_DeviousPlugVaginal) && Timeout > 0
					Timeout -= 1
					Utility.Wait(0.3)
				EndWhile
				BeltActor(PlayerRef)
				UnRegisterForModEvent("HookAnimationEnd")
			Else
				Utility.Wait(2.0)
				(Game.GetFormFromFile(0x1DD003, "pchsWartimes.esp") as Quest).Start() ; pchsBreederBeltQuest
				(Game.GetFormFromFile(0x005A12, "pchsWartimes.esp") as Actor).EvaluatePackage()
			EndIf
		EndIf
	EndEvent
	
	Bool Function PlugActor(Actor akActor)
		If !akActor.WornHasKeyword(zad_DeviousPlugVaginal)
			Form PrimVagPlug = StorageUtil.GetFormValue(akActor, "pchsFathersPlug")
			If !PrimVagPlug
				PrimVagPlug = Game.GetFormFromFile(0x031C68, "Devious Devices - Integration.esm")
			EndIf
			If akActor.GetItemCount(PrimVagPlug) == 0
				akActor.AddItem(PrimVagPlug)
			EndIf
			EquipDevice(akActor, PrimVagPlug as Armor)
			StorageUtil.UnSetFormValue(akActor, "pchsFathersPlug")
		EndIf
		Return true		
	EndFunction
	
	Bool Function UnPlugActor(Actor akActor)
		If akActor.WornHasKeyword(zad_DeviousPlugVaginal)
			Form Plug = GetWornDeviceByKeyword(akActor, zad_DeviousPlugVaginal)
			If Plug
				StorageUtil.SetFormValue(akActor, "pchsFathersPlug", Plug)
				RemoveDevice(akActor, Plug as Armor)
			EndIf
		EndIf
		Return true
	EndFunction
	
	Bool Function BeltActor(Actor akActor)
		If !akActor.WornHasKeyword(zad_DeviousBelt)
			Form Belt = StorageUtil.GetFormValue(akActor, "pchsFathersBelt")
			If !Belt
				;Belt = Game.GetFormFromFile(0x00D4CF, "Devious Devices - Expansion.esm")
				Belt = JsonUtil.GetFormValue("Wartimes/Devices.json", "fhuharness")
			EndIf
			If akActor.GetItemCount(Belt) == 0
				akActor.AddItem(Belt)
			EndIf
			EquipDevice(akActor, Belt as Armor)
			StorageUtil.UnSetFormValue(akActor, "pchsFathersBelt")
		EndIf
		Return true
	EndFunction
	
	Bool Function UnBeltActor(Actor akActor)
		If akActor.WornHasKeyword(zad_DeviousBelt)
			Form Belt = GetWornDeviceByKeyword(akActor, zad_DeviousBelt)
			If Belt
				StorageUtil.SetFormValue(akActor, "pchsFathersBelt", Belt)
				RemoveDevice(akActor, Belt as Armor)
			EndIf
		EndIf
		Return true
	EndFunction
	
	Function CumSlutSexBegin()
		If !PlayerRef.WornHasKeyword(zad_DeviousBelt)
			Armor Plug
			Bool DidRemove = false
			If PlayerRef.WornHasKeyword(zad_DeviousPlugVaginal)
				Plug = GetWornDeviceByKeyword(PlayerRef, zad_DeviousPlugVaginal)
				StorageUtil.SetFormValue(Self, "pchsCumSlutPlugVag", Plug)
				RemoveDevice(PlayerRef, Plug)
				DidRemove = true
			EndIf
			If PlayerRef.WornHasKeyword(zad_DeviousPlugAnal)
				Plug = GetWornDeviceByKeyword(PlayerRef, zad_DeviousPlugAnal)
				StorageUtil.SetFormValue(Self, "pchsCumSlutPlugAnal", Plug)
				RemoveDevice(PlayerRef, Plug)
				DidRemove = true
			EndIf
			
			If DidRemove
				Debug.Notification("They remove the plugs from my holes")
			EndIf
		EndIf
	EndFunction
	
	Function CumSlutSexEnd()
		Bool DidAdd = false
		Armor Plug = StorageUtil.GetFormValue(Self, "pchsCumSlutPlugVag") as Armor
		If Plug
			EquipDevice(PlayerRef, Plug)
			StorageUtil.UnSetFormValue(Self, "pchsCumSlutPlugVag")
			DidAdd = true
		EndIf
		Plug = StorageUtil.GetFormValue(Self, "pchsCumSlutPlugAnal") as Armor
		If Plug
			EquipDevice(PlayerRef, Plug)
			StorageUtil.UnSetFormValue(Self, "pchsCumSlutPlugAnal")
			DidAdd = true
		EndIf
		
		If DidAdd
			Debug.Notification("They return the plugs to my holes")
		EndIf
	EndFunction
	
	Function IncBondageLevel(Int Level, Bool GiveDevices = true)
		If Level == 1 ; Arm & leg cuffs
			PlayerRef.AddItem(JsonUtil.GetFormValue("Wartimes/Devices.json", "cuffslegs"))
			PlayerRef.AddItem(JsonUtil.GetFormValue("Wartimes/Devices.json", "cuffsarms"))
			pchsBondageSubRequired.SetValueInt(15)
			Debug.Messagebox("Father now expects me to wear arm & leg cuffs at all times")
		ElseIf Level == 2
			PlayerRef.AddItem(JsonUtil.GetFormValue("Wartimes/Devices.json", "gloves"))
			PlayerRef.AddItem(JsonUtil.GetFormValue("Wartimes/Devices.json", "boots"))
			pchsBondageSubRequired.SetValueInt(30)
			Debug.Messagebox("Father now expects me to wear devious boots & gloves at all times")
		ElseIf Level == 3
			PlayerRef.AddItem(JsonUtil.GetFormValue("Wartimes/Devices.json", "nipples"))
			PlayerRef.AddItem(JsonUtil.GetFormValue("Wartimes/Devices.json", "clit"))
			pchsBondageSubRequired.SetValueInt(999)
			Debug.Messagebox("Father now expects me to wear nipple & clit piercings at all times")
		EndIf
		pchsBoundaryBondage.SetValue(Level)
	EndFunction
	
	Bool Function CheckBondageConformity()
		If pchsBoundaryBondage.GetValue() >= 1
			If !PlayerRef.WornHasKeyword(zad_DeviousLegCuffs) || !PlayerRef.WornHasKeyword(zad_DeviousArmCuffs)
				Return false
			EndIf
		EndIf
		If pchsBoundaryBondage.GetValue() >= 2
			If !PlayerRef.WornHasKeyword(zad_DeviousBoots) || !PlayerRef.WornHasKeyword(zad_DeviousGloves)
				Return false
			EndIf
		EndIf
		If pchsBoundaryBondage.GetValue() >= 3
			If (!PlayerRef.WornHasKeyword(zad_DeviousPiercingsVaginal) && !Piercings.IsWearingClitPiercing()) || (!PlayerRef.WornHasKeyword(zad_DeviousPiercingsNipple) && !Piercings.IsWearingNipPiercings())
				Return false
			EndIf
		EndIf
		Return true
	EndFunction
	
	Armor Function GetRenderedDevice(Armor Device)
		Return pchsWtIntDevious.GetRenderedDevice(Device, libsQuest)
	EndFunction
	
	Function EquipDevice(Actor akActor, Armor deviceInventory)
		pchsWtIntDevious.EquipDevice(akActor, deviceInventory, libsQuest)
	EndFunction
	
	Function RemoveDevice(Actor akActor, Armor deviceInventory)
		pchsWtIntDevious.RemoveDevice(akActor, deviceInventory, libsQuest)
	EndFunction
	
	Armor Function GetWornDeviceByKeyword(Actor akActor, Keyword kw)
		Return _SLS_IntDevious.GetWornDeviceByKeyword(akActor, kw, libsQuest)
	EndFunction
	
	Bool Function IsHooded(Actor akActor)
		Return akActor.WornHasKeyword(zad_DeviousHood)
	EndFunction
	
	Function RemoveHood(Actor akActor)
		RemoveDevice(akActor, GetWornDeviceByKeyword(akActor, zad_DeviousHood))
	EndFunction
	
	Bool Function IsWearingNipPiercings(Actor akActor)
		Return akActor.WornHasKeyword(zad_DeviousPiercingsNipple)
	EndFunction
	
	Bool Function IsWearingClitPiercing(Actor akActor)
		Return akActor.WornHasKeyword(zad_DeviousPiercingsVaginal)
	EndFunction
	
	Bool Function IsWearingAnyDevice(Actor akActor)
		If akActor.WornHasKeyword(zad_Lockable) ; Npcs don't actually equip the inventory device so....
			Return true
		EndIf
		Return false	
	EndFunction
	
	Bool Function CanLickCumFromFloor(Actor akActor)
		If akActor.WornHasKeyword(zad_PermitOral) || (!akActor.WornHasKeyword(zad_DeviousGag) && !akActor.WornHasKeyword(zad_DeviousHood))
			Return true
		EndIf
		Return false
	EndFunction
	
	Bool Function AreHandsAvailable(Actor akActor)
		If akActor.WornHasKeyword(zad_DeviousHeavyBondage)
			Return false
		EndIf
		Return true
	EndFunction
	
	Function EquipRandomDds(Actor akActor, Int Quantity)
		String[] FreeSlots = new String[20]
		Int i = 0
		While i < Quantity
			Int Index = 0
			If !akActor.WornHasKeyword(zad_DeviousBoots)
				FreeSlots[Index] = "Boots"
				Index += 1
			EndIf
			If !akActor.WornHasKeyword(zad_DeviousCollar); && !akActor.WornHasKeyword(zad_DeviousHarness)
				FreeSlots[Index] = "Collars"
				Index += 1
			EndIf
			If !akActor.WornHasKeyword(zad_DeviousCorset) && !akActor.WornHasKeyword(zad_DeviousHarness) ; Occupies the same slots
				FreeSlots[Index] = "Corsets"
				Index += 1
			EndIf
			If !akActor.WornHasKeyword(zad_DeviousArmCuffs)
				FreeSlots[Index] = "CuffsArms"
				Index += 1
			EndIf
			If !akActor.WornHasKeyword(zad_DeviousLegCuffs)
				FreeSlots[Index] = "CuffsLegs"
				Index += 1
			EndIf
			If !akActor.WornHasKeyword(zad_DeviousGag)
				FreeSlots[Index] = "Gags"
				Index += 1
			EndIf
			If !akActor.WornHasKeyword(zad_DeviousGloves)
				FreeSlots[Index] = "Gloves"
				Index += 1
			EndIf
			If !akActor.WornHasKeyword(zad_DeviousHarness) && !akActor.WornHasKeyword(zad_DeviousCollar) && !akActor.WornHasKeyword(zad_DeviousCorset)
				FreeSlots[Index] = "Harnesses"
				Index += 1
			EndIf
			If !akActor.WornHasKeyword(zad_DeviousPiercingsNipple)
				FreeSlots[Index] = "PiercingsNipples"
				Index += 1
			EndIf
			If !akActor.WornHasKeyword(zad_DeviousPiercingsVaginal)
				FreeSlots[Index] = "PiercingsVagina"
				Index += 1
			EndIf
			If Index > 0
				String DeviceType = FreeSlots[Utility.RandomInt(0, (Index - 1))]
				Int RanDeviceIndex = Utility.RandomInt(0, (JsonUtil.FormListCount("Wartimes/DeviceList.json", DeviceType) - 1))
				Armor DdSelect = JsonUtil.FormListGet("Wartimes/DeviceList.json", DeviceType, RanDeviceIndex) as Armor
				EquipDevice(akActor, DdSelect)
				Debug.Trace("pchs: EquipRandomDds: " + i + ") Selected: " + DeviceType + " is " + DdSelect.GetName())
			Else
				Debug.Trace("pchs: EquipRandomDds: No device slots left")
			EndIf
			i += 1
			If i < Quantity
				Utility.Wait(0.2)
			EndIf
		EndWhile
		;/
		If akActor == PlayerRef
			Init.FreeDeviceSlots = GetNumFreeSlots(akActor)
			Debug.Trace("SLS_: EquipRandomDds: Free slots: " + Init.FreeDeviceSlots)
		EndIf
		/;
	EndFunction

	Int Function GetNumFreeSlots(Actor akActor)
		Int NumFreeSlots = 0
		If !akActor.WornHasKeyword(zad_DeviousBoots)
			NumFreeSlots += 1
		EndIf
		If !akActor.WornHasKeyword(zad_DeviousCollar) ; Collar keyword is included with harness render devices
			NumFreeSlots += 1
		EndIf
		If !akActor.WornHasKeyword(zad_DeviousCorset) && !akActor.WornHasKeyword(zad_DeviousHarness) ; Occupies the same slots
			NumFreeSlots += 1
		EndIf
		If !akActor.WornHasKeyword(zad_DeviousArmCuffs)
			NumFreeSlots += 1
		EndIf
		If !akActor.WornHasKeyword(zad_DeviousLegCuffs)
			NumFreeSlots += 1
		EndIf
		If !akActor.WornHasKeyword(zad_DeviousGag)
			NumFreeSlots += 1
		EndIf
		If !akActor.WornHasKeyword(zad_DeviousGloves)
			NumFreeSlots += 1
		EndIf
		;If !akActor.WornHasKeyword(zad_DeviousHarness) && (!akActor.WornHasKeyword(zad_DeviousCollar) || !akActor.WornHasKeyword(zad_DeviousCorset))
		;	NumFreeSlots += 1
		;EndIf
		If !akActor.WornHasKeyword(zad_DeviousPiercingsNipple)
			NumFreeSlots += 1
		EndIf
		If !akActor.WornHasKeyword(zad_DeviousPiercingsVaginal)
			NumFreeSlots += 1
		EndIf
		
		If akActor == PlayerRef
			FreeDeviceSlots = NumFreeSlots
		EndIf
		
		Debug.Trace("pchs: GetNumFreeSlots: Freeslots: " + NumFreeSlots + ". Actor: " + akActor)
		Return NumFreeSlots
	EndFunction
EndState

Function SetDeviceGlobs()
EndFunction

Function DialogRemoveDeviceByInt(Actor akActor, Int DeviceInt)
EndFunction

Function RebeltPlayerAfterSex()
EndFunction

Event OnAnimationEnd(int tid, bool HasPlayer)
EndEvent

Bool Function PlugActor(Actor akActor)
EndFunction

Bool Function UnPlugActor(Actor akActor)
EndFunction

Bool Function BeltActor(Actor akActor)
EndFunction

Bool Function UnBeltActor(Actor akActor)
EndFunction

Function CumSlutSexBegin()
EndFunction

Function CumSlutSexEnd()
EndFunction

Function IncBondageLevel(Int Level, Bool GiveDevices = true)
EndFunction

Bool Function CheckBondageConformity()
	Return true
EndFunction

Armor Function GetRenderedDevice(Armor Device)
	Return None
EndFunction

Function EquipDevice(Actor akActor, Armor deviceInventory)
EndFunction

Function RemoveDevice(Actor akActor, Armor deviceInventory)
EndFunction

Armor Function GetWornDeviceByKeyword(Actor akActor, Keyword kw)
	Return None
EndFunction

Bool Function IsHooded(Actor akActor)
	Return false
EndFunction

Function RemoveHood(Actor akActor)
EndFunction

Bool Function IsWearingNipPiercings(Actor akActor)
	Return false
EndFunction

Bool Function IsWearingClitPiercing(Actor akActor)
	Return false
EndFunction

Bool Function IsWearingAnyDevice(Actor akActor)
	Return false	
EndFunction

Bool Function CanLickCumFromFloor(Actor akActor)
	Return true
EndFunction

Bool Function AreHandsAvailable(Actor akActor)
	Return true
EndFunction

Function EquipRandomDds(Actor akActor, Int Quantity)
EndFunction

Int Function GetNumFreeSlots(Actor akActor)
	FreeDeviceSlots = 0
	Return 0
EndFunction

Int Property FreeDeviceSlots = 0 Auto Hidden Conditional

GlobalVariable Property pchsFatherVoluntaryServeRep Auto
GlobalVariable Property pchsDdRemCost Auto
GlobalVariable Property pchsDdIsBelted Auto
GlobalVariable Property pchsDdIsBlindfolded Auto
GlobalVariable Property pchsDdIsBraed Auto
GlobalVariable Property pchsDdIsGagged Auto
GlobalVariable Property pchsDdIsHeavilyBound Auto
GlobalVariable Property pchsDdIsSuited Auto
GlobalVariable Property pchsDdIsHooded Auto
GlobalVariable Property pchsDdIsHarnessed Auto
GlobalVariable Property pchsDdIsBooted Auto
GlobalVariable Property pchsDdIsGloved Auto
GlobalVariable Property pchsDdIsWearingAnyDevice Auto
GlobalVariable Property pchsBoundaryBondage Auto
GlobalVariable Property pchsBondageSubRequired Auto

Keyword Property zad_Lockable Auto Hidden
Keyword Property zad_DeviousCollar Auto Hidden
Keyword Property zad_DeviousCorset Auto Hidden
Keyword Property zad_DeviousHood Auto Hidden
Keyword Property zad_DeviousBelt Auto Hidden
Keyword Property zad_DeviousBlindfold Auto Hidden
Keyword Property zad_DeviousBra Auto Hidden
Keyword Property zad_DeviousGag Auto Hidden
Keyword Property zad_DeviousHeavyBondage Auto Hidden
Keyword Property zad_DeviousSuit Auto Hidden
Keyword Property zad_DeviousHarness Auto Hidden
Keyword Property zad_DeviousBoots Auto Hidden
Keyword Property zad_DeviousGloves Auto Hidden
Keyword Property zad_DeviousArmCuffs Auto Hidden
Keyword Property zad_DeviousLegCuffs Auto Hidden
Keyword Property zad_DeviousPlugVaginal Auto Hidden
Keyword Property zad_DeviousPlugAnal Auto Hidden
Keyword Property zad_DeviousPiercingsVaginal Auto Hidden
Keyword Property zad_DeviousPiercingsNipple Auto Hidden
Keyword Property zad_PermitOral Auto Hidden

Keyword[] DeviceKwds

Form Property DeviousSupplyRunHood Auto Hidden

Actor Property PlayerRef Auto

pchsWtFavour Property Fav Auto
pchsPiercings Property Piercings Auto
