Scriptname pchsWtInterfaceFashion extends Quest  

Event OnInit()
	RegisterForModEvent("_pchs_Int_PlayerLoadsGame", "On_pchs_Int_PlayerLoadsGame")
EndEvent

Event On_pchs_Int_PlayerLoadsGame(string eventName, string strArg, float numArg, Form sender)
	PlayerLoadsGame()
EndEvent

Function PlayerLoadsGame()
	If Game.GetModByName("yps-ImmersivePiercing.esp") != 255 && StorageUtil.GetFloatValue(None, "yps_TweakVersion", Missing = -1.0) >= 1.8
		If GetState() != "Installed"
			GoToState("Installed")
		EndIf
	
	Else
		If GetState() != ""
			GoToState("")
		EndIf
	EndIf
EndFunction

Event OnEndState()
	Utility.Wait(5.0) ; Wait before entering active state to help avoid making function calls to scripts that may not have initialized yet.
	PTickQuest = Game.GetFormFromFile(0x0073BC, "yps-ImmersivePiercing.esp") as Quest
	
	PiercingNames = new String[16]
	PiercingNames[0] = "Unused"
	PiercingNames[1] = "Earlobes"
	PiercingNames[2] = "Left Nostril"
	PiercingNames[3] = "Septum"
	PiercingNames[4] = "Snake Bites"
	PiercingNames[5] = "Right Labret"
	PiercingNames[6] = "Labret"
	PiercingNames[7] = "Right Eyebrow"
	PiercingNames[8] = "Nose Bridge"
	PiercingNames[9] = "Navel"
	PiercingNames[10] = "Nipples"
	PiercingNames[11] = "Clitoris"
	PiercingNames[12] = "Labia"
	PiercingNames[13] = "Not implemented"
	PiercingNames[14] = "Not implemented"
	PiercingNames[15] = "Not implemented"
	
	NailPolishStages = new String[8]
	NailPolishStages[0] = "No Polish"
	NailPolishStages[1] = "Applying Nail Polish"
	NailPolishStages[2] = "Applied And Drying"
	NailPolishStages[3] = "Smudged"
	NailPolishStages[4] = "OK"
	NailPolishStages[5] = "Manicured"
	NailPolishStages[6] = "Chipping Off"
	NailPolishStages[7] = "Mostly Gone"
EndEvent

Bool Function GetIsInterfaceActive()
	If GetState() == "Installed"
		Return true
	EndIf
	Return false
EndFunction

State Installed
	Int Function GetPiercingCost()
		Return pchsWtIntFashion.GetPiercingCost(PTickQuest)
	EndFunction

	Function PierceMe(Int PSlot, Actor akActor, int PiercingType)
		;/
			PSlot:
			"earlobes" : 1,
			"left nostril" : 2,
			"septum" : 3,
			"snake bites" : 4,
			"right labret" : 5,
			"labret" : 6,
			"right eyebrow" : 7,
			"nose bridge" : 8,
			"navel" : 9,
			"nipples" : 10,
			"clitoris" : 11,
			"labia" : 12
			
			akActor - Actor performing the piercing - notification descriptions
			
			PiercingType - 1 for builtin yps piercings. Other values for piercings from other mods...
		/;
		
		pchsWtIntFashion.PierceMe(PTickQuest, PSlot, akActor, PiercingType)
	EndFunction
	
	Function WeldMe(Int PSlot, Actor akActor)
		pchsWtIntFashion.WeldMe(PTickQuest, PSlot, akActor)
	EndFunction
	
	Function Mirror()
		UIListMenu ListMenu = UIExtensions.GetMenu("UIListMenu") as UIListMenu
		String[] FashionStatement = GetFashionStatement()
		Int i = 0
		While i < FashionStatement.Length
			ListMenu.AddEntryItem(FashionStatement[i])
			i += 1
		EndWhile
		ListMenu.OpenMenu()
	EndFunction
	
	String[] Function GetFashionStatement()
		StorageUtil.StringListClear(Self, "FashionStatus")
		
		StorageUtil.StringListAdd(Self, "FashionStatus", " === Hair === ")
		StorageUtil.StringListAdd(Self, "FashionStatus", "Hair Length: " + StorageUtil.SetIntValue(None, "pchsWtRecordedHairLenght", StorageUtil.GetIntValue(None, "YpsCurrentHairLengthStage")))
		StorageUtil.StringListAdd(Self, "FashionStatus", "Hair Colour: " + GetHairColour())
		StorageUtil.StringListAdd(Self, "FashionStatus", CanChangeHairColour())
		StorageUtil.StringListAdd(Self, "FashionStatus", CanRedyeHairColour())
		StorageUtil.StringListAdd(Self, "FashionStatus", ShouldRedyeHairColour())
		
		StorageUtil.StringListAdd(Self, "FashionStatus", " === Makeup === ")
		StorageUtil.StringListAdd(Self, "FashionStatus", "Lipstick: " + StorageUtil.GetStringValue(None, "yps_LipstickColor") + " " + GetSmudged(StorageUtil.GetIntValue(None, "yps_LipstickSmudged", Missing = 0)))
		StorageUtil.StringListAdd(Self, "FashionStatus", "Eyeshadow: " + StorageUtil.GetStringValue(None, "yps_EyeShadowColor") + " " + GetSmudged(StorageUtil.GetIntValue(None, "yps_EyeShadowSmudged", Missing = 0)))
		StorageUtil.StringListAdd(Self, "FashionStatus", "Finger Nails: " + StorageUtil.GetStringValue(None, "yps_FingerNailPolishColor") + " " + GetPolishState(StorageUtil.GetIntValue(None, "yps_FingerNailPolishStage", Missing = 0)))
		StorageUtil.StringListAdd(Self, "FashionStatus", "Toe Nails: " + StorageUtil.GetStringValue(None, "yps_ToeNailPolishColor") + " " + GetPolishState(StorageUtil.GetIntValue(None, "yps_ToeNailPolishStage", Missing = 0)))
		StorageUtil.StringListAdd(Self, "FashionStatus", "Stockings: " + GetStockingsName())
		StorageUtil.StringListAdd(Self, "FashionStatus", GetHeelsStatus())
		
		If pchsRequiredOutfitLevel.GetValueInt() > -1
			Form akOutfit = PlayerRef.GetWornForm(0x00000004)
			StorageUtil.StringListAdd(Self, "FashionStatus", " === Outfit === ")
			If pchsRequiredOutfitLevel.GetValueInt() == 100
				StorageUtil.StringListAdd(Self, "FashionStatus", GetNakedStatus())
			Else
				StorageUtil.StringListAdd(Self, "FashionStatus", GetOutfitStatus(akOutfit))
			EndIf
			
			If Util.HasAccessories(akOutfit)
				StorageUtil.StringListAdd(Self, "FashionStatus", " === Accessories === ")
				AddAccessories(akOutfit)
			EndIf
			
			If JsonUtil.FormListCount("Wartimes/Outfits.json", "outfits_" + pchsRequiredOutfitLevel.GetValueInt()) > 1
				StorageUtil.StringListAdd(Self, "FashionStatus", " === Alternative Outfits === ")
				AddAlternativeOutfits(akOutfit)
			EndIf
			
			If StorageUtil.FormListCount(None, "pchsWtBoringStockings") > 0
				StorageUtil.StringListAdd(Self, "FashionStatus", " === Boring Stockings === ")
				AddBoringStockings()
			EndIf
		EndIf
		
		StorageUtil.StringListAdd(Self, "FashionStatus", " === Piercings === ")
		Int i = 1
		While i < 13
			If StorageUtil.IntListGet(None, "yps_PiercingsStatus", i) == 1
				StorageUtil.StringListAdd(Self, "FashionStatus", PiercingNames[i])
			EndIf
			i += 1
		EndWhile
		
		Return StorageUtil.StringListToArray(Self, "FashionStatus")
	EndFunction
EndState

Int Function GetPiercingCost()
	Return 0
EndFunction

Function PierceMe(int PSlot, Actor akActor, int PiercingType)
EndFunction

Function WeldMe(Int PSlot, Actor akActor)
EndFunction

Function Mirror()
EndFunction

String[] Function GetFashionStatement()
EndFunction

String Function GetSmudged(Int IsSmudged)
	If IsSmudged
		Return "(Smudged)"
	EndIf
	Return ""
EndFunction

String Function GetPolishState(Int PolishState)	
	; 0 = no polish, 10 = in process of applying, 20 = applied and drying, 
	; 30 = smudged, 40 = nail polish dried, 50 = manicured, 60 = starts chipping, 
	; 70 = only some remains left
	
	Return "(" + NailPolishStages[PolishState/10] + ")"
EndFunction

String Function GetStockingsName()
	String Name
	If StorageUtil.GetFormValue(None, "yps_Stockings")
		Name = (StorageUtil.GetFormValue(None, "yps_Stockings")).GetName()
	EndIf
	Return Name
EndFunction

String Function GetHairColour()
	String Colour = "Natural"
	If StorageUtil.GetStringValue(None, "yps_HairDyeColourName") != ""
		Colour = StorageUtil.GetStringValue(None, "yps_HairDyeColourName")
	EndIf
	Return Colour
EndFunction

String Function CanChangeHairColour()
	If StorageUtil.GetIntValue(None, "yps_CanChangeHairColour") == 1
		Return "Can Change Hair Colour: Yes"
	EndIf
	Return "Can Change Hair Colour: No"
EndFunction

String Function CanRedyeHairColour()
	If StorageUtil.GetIntValue(None, "yps_CanRedyeHair") == 1
		Return "Can Redye Hair: Yes"
	EndIf
	Return "Can Redye Hair: No"
EndFunction

String Function ShouldRedyeHairColour()
	If StorageUtil.GetIntValue(None, "yps_ShouldRedyeHair") == 1
		Return "Should Redye Hair: Yes"
	EndIf
	Return "Should Redye Hair: No"
EndFunction

String Function GetHeelsStatus()
	String Status = "Heels: "
	If Util.IsWearingNioHeels(PlayerRef, 0.1)
		Status += "Yes (NiO " + SnipToDecimalPlaces(GetHeelHeight(PlayerRef), Places = 1) + ")"
	ElseIf Util.IsWearingHdtHeels(PlayerRef)
		Status += "Yes (Hdt)"
	ElseIf Util.IsWearingKillerHeels(PlayerRef)
		Status += "Yes (Killer Heels)"
	Else
		Status += "No"
	EndIf
	Return Status
EndFunction

Float Function GetHeelHeight(Actor akTarget)
	Int IsFemale = akTarget.GetLeveledActorBase().GetSex()
	If NiOverride.HasNodeTransformPosition(akTarget, False, IsFemale, "NPC", "internal")
		;Float[] Pos = NiOverride.GetNodeTransformPosition(akTarget, false, IsFemale, "NPC", "internal")
		Return NiOverride.GetNodeTransformPosition(akTarget, false, IsFemale, "NPC", "internal")[2]
	EndIf
	Return 0.0
EndFunction

String Function GetNakedStatus()
	If pchsPcIsWearingOutfit.GetValueInt() == 100
		Return "Naked: Yes"
	Else
		Return "Naked: No"
	EndIf
EndFunction

String Function GetOutfitStatus(Form akOutfit)
	If pchsPcIsWearingOutfit.GetValueInt() == 100
		Return "Naked: Not Acceptable"
	ElseIf pchsPcIsWearingOutfit.GetValueInt() == -1
		If StorageUtil.GetIntValue(akOutfit, "pchsWtOutfitLevel", Missing = -1) == pchsRequiredOutfitLevel.GetValueInt()
			Return akOutfit.GetName() + ": Missing Accessory"
		Else
			Return akOutfit.GetName() + ": Not Acceptable"
		EndIf
	Else
		Return akOutfit.GetName() + ": Acceptable"
	EndIf
EndFunction

Function AddAccessories(Form akOutfit)
	Form[] AccList = Util.GetAccessoriesForOutfit(akOutfit)
	Int i = 0
	While i < AccList.Length
		StorageUtil.StringListAdd(Self, "FashionStatus", IsWorn(AccList[i]))
		i += 1
	EndWhile
EndFunction

Function AddAlternativeOutfits(Form akOutfit)
	Int i = 0
	Form akForm
	While i < JsonUtil.FormListCount("Wartimes/Outfits.json", "outfits_" + pchsRequiredOutfitLevel.GetValueInt())
		akForm = JsonUtil.FormListGet("Wartimes/Outfits.json", "outfits_" + pchsRequiredOutfitLevel.GetValueInt(), i)
		If akForm != akOutfit
			StorageUtil.StringListAdd(Self, "FashionStatus", akForm.GetName())
		EndIf
		i += 1
	EndWhile
EndFunction

Function AddBoringStockings()
	Int i = 0
	While i < StorageUtil.FormListCount(None, "pchsWtBoringStockings")
		StorageUtil.StringListAdd(Self, "FashionStatus", StorageUtil.FormListGet(None, "pchsWtBoringStockings", i).GetName())
		i += 1
	EndWhile
EndFunction

String Function IsWorn(Form akForm)
	If PlayerRef.IsEquipped(akForm)
		Return akForm.GetName() + ": Yes"
	EndIf
	Return akForm.GetName() + ": No"
EndFunction

Function ToggleMirror(Bool EnableIt)
	If EnableIt
		(Game.GetFormFromFile(0x395A68, "pchsWartimes.esp") as ObjectReference).Enable() ; Stand
		(Game.GetFormFromFile(0x395A6A, "pchsWartimes.esp") as ObjectReference).Enable() ; Plate
	Else
		(Game.GetFormFromFile(0x395A68, "pchsWartimes.esp") as ObjectReference).Disable() ; Stand
		(Game.GetFormFromFile(0x395A6A, "pchsWartimes.esp") as ObjectReference).Disable() ; Plate
	EndIf
EndFunction

String Function SnipToDecimalPlaces(String StrInput, Int Places)
	Return StringUtil.Substring(StrInput, startIndex = 0, len =  Places + 1 + StringUtil.Find(StrInput, ".", startIndex = 0))
EndFunction

String[] PiercingNames
String[] NailPolishStages

Quest PTickQuest

Actor Property PlayerRef Auto

GlobalVariable Property pchsPcIsWearingOutfit Auto
GlobalVariable Property pchsRequiredOutfitLevel Auto

pchsWartimesPlayerScript Property pchsPlayer Auto
pchsWtUtil Property Util Auto
