Scriptname pchsWtUtil extends Quest

Event OnInit()
	If Self.IsRunning()
		UpdateModifiedOutfitsJson()
		BuildArrays()
	EndIf
EndEvent

Function BuildArrays()
	SlotMasks = new Int[32]
	SlotMasks[0] = 1 ; kSlotMask30
	SlotMasks[1] = 2 ; kSlotMask31
	SlotMasks[2] = 4 ; kSlotMask32
	SlotMasks[3] = 8 ; kSlotMask33
	SlotMasks[4] = 16 ; kSlotMask34
	SlotMasks[5] = 32 ; kSlotMask35
	SlotMasks[6] = 64 ; kSlotMask36
	SlotMasks[7] = 128 ; kSlotMask37
	SlotMasks[8] = 256 ; kSlotMask38
	SlotMasks[9] = 512 ; kSlotMask39
	SlotMasks[10] = 1024 ; kSlotMask40
	SlotMasks[11] = 2048 ; kSlotMask41
	SlotMasks[12] = 4096 ; kSlotMask42
	SlotMasks[13] = 8192 ; kSlotMask43
	SlotMasks[14] = 16384 ; kSlotMask44
	SlotMasks[15] = 32768 ; kSlotMask45
	SlotMasks[16] = 65536 ; kSlotMask46
	SlotMasks[17] = 131072 ; kSlotMask47
	SlotMasks[18] = 262144 ; kSlotMask48
	SlotMasks[19] = 524288 ; kSlotMask49
	SlotMasks[20] = 1048576 ; kSlotMask50
	SlotMasks[21] = 2097152 ; kSlotMask51
	SlotMasks[22] = 4194304 ; kSlotMask52
	SlotMasks[23] = 8388608 ; kSlotMask53
	SlotMasks[24] = 16777216 ; kSlotMask54
	SlotMasks[25] = 33554432 ; kSlotMask55
	SlotMasks[26] = 67108864 ; kSlotMask56
	SlotMasks[27] = 134217728 ; kSlotMask57
	SlotMasks[28] = 268435456 ; kSlotMask58
	SlotMasks[29] = 536870912 ; kSlotMask59
	SlotMasks[30] = 1073741824 ; kSlotMask60
	SlotMasks[31] = 0x80000000 ; kSlotMask61 - Use hex otherwise number ends up being 1 short....?
EndFunction

Function ShutdownWartimes()
	; (Game.GetFormFromFile(0x5A17, "pchsWartimes.esp") as pchsWtUtil).ShutdownWartimes()

	;pchsWartimesPlayerScript pchsPlayer = UiKey.pchsPlayer
	
	UiKey.HomeSlaves.RemoveAllSlaves()
	UiKey.HomeSlaves.Stop()
	Menu.HairColour.Shutdown()
	Menu.HairColour.Stop()
	(Game.GetFormFromFile(0x61DE6E, "pchsWartimes.esp") as pchsForbiddenItems).Stop() ; pchsForbiddenItemsQuest
	
	pchsHorseBorrow HorseBorrow = Game.GetFormFromFile(0x3449E1, "pchsWartimes.esp") as pchsHorseBorrow
	HorseBorrow.pchsHorseTethered.SetValue(0)
	HorseBorrow.Stop()
	If pchsPlayer.SupplyRun.IsRunning()
		pchsPlayer.SupplyRun.CompleteSupplyRun()
	EndIf
	pchsPlayer.TossOut.Stop()
	pchsPlayer.Apol.Stop()
	pchsPlayer.Fav.Stop()
	HorseMilk.Cellar.Stop()
	UiKey.Stop()
	(Game.GetFormFromFile(0x595276, "pchsWartimes.esp") as Quest).Stop() ; pchsPlayerModestyQuest
	
	ObjectReference TheDoor = Game.GetFormFromFile(0x5A0D, "pchsWartimes.esp") as ObjectReference
	TheDoor.Lock()
	TheDoor.SetLockLevel(255)
	
	Int BlockEvent = ModEvent.Create("_SLS_BlockLicenceBuy")
	If (BlockEvent)
		ModEvent.PushForm(BlockEvent, self)
		ModEvent.PushBool(BlockEvent, false)
		ModEvent.Send(BlockEvent)
	EndIf
	
	;CompleteAllObjectives()
	
	PlayerRef.RemovePerk(Game.GetFormFromFile(0x335681, "pchsWartimes.esp") as Perk) ; pchsBrutusPerk
	
	If PlayerRef.GetCurrentLocation() == pchsWartimesHomeLocation
		TheDoor = Game.GetFormFromFile(0x593C, "pchsWartimes.esp") as ObjectReference
		TheDoor.Activate(PlayerRef)
	EndIf

	Self.Stop() ; pchsWartimes quest
EndFunction 

Function PlayerLoadsGame()
	pchsYpsInstalled.SetValueInt((StorageUtil.GetFloatValue(None, "yps_TweakVersion", Missing = -1.0) >= 1.5) as Int)
	pchsRapeTatsInstalled.SetValueInt((Game.GetModByName("RapeTattoos.esp") != 255) as Int)
	pchsSlsoInstalled.SetValueInt((Game.GetModByName("SLSO.esp") != 255) as Int)
	pchsSdInstalled.SetValueInt((Game.GetModByName("sanguinesDebauchery.esp") != 255) as Int)
	pchsDdsInstalled.SetValueInt((Game.GetModByName("Devious Devices - Expansion.esm") != 255) as Int)
	If pchsDdsInstalled.GetValue()
		zad_DeviousCollar = Game.GetFormFromFile(0x003DF7, "Devious Devices - Assets.esm") as Keyword
		zad_DeviousBoots = Game.GetFormFromFile(0x027F29, "Devious Devices - Assets.esm") as Keyword
	Else
		zad_DeviousCollar = pchsDummyNeverUsedKw
		zad_DeviousBoots = pchsDummyNeverUsedKw
	EndIf
	
	pchsPahInstalled.SetValueInt((Game.GetModByName("paradise_halls.esm") != 255) as Int)
	If pchsPahInstalled.GetValue()
		PAHSubmission = Game.GetFormFromFile(0x0047EB, "paradise_halls.esm") as Faction
		PAHTrainSex = Game.GetFormFromFile(0x004067, "paradise_halls_SLExtension.esp") as Faction
		PAHRestraintLeash = Game.GetFormFromFile(0x04BE3C, "paradise_halls.esm") as Keyword
	Else
		PAHSubmission = pchsDummyNeverUsedFact
		PAHTrainSex = pchsDummyNeverUsedFact
	EndIf
	
	pchsPiercingsMaxLevel.SetValueInt(JsonUtil.GetIntValue("Wartimes/Piercings.json", "maxlevel"))
	pchsAnimsHorseHandjob.SetValueInt((Sexlab.GetCreatureAnimationsByRaceTags(2, HorseRace, "Handjob", "", RequireAll = true).Length > 0) as Int)
	pchsAnimsDogHandjob.SetValueInt((Sexlab.GetCreatureAnimationsByRaceTags(2, DogRace, "Handjob", "", RequireAll = true).Length > 0) as Int)
	pchsAnimsSpanking.SetValueInt(((Sexlab.GetAnimationsByTags(2, "Spanking", "Oral,Anal,Vaginal", RequireAll = true)).Length > 0) as Int)
EndFunction

Function SetMilkdKeyword(Keyword Kwd)
	If Kwd
		MME_Milk = Kwd
	Else
		MME_Milk = pchsDummyNeverUsedKw
	EndIf
EndFunction

Function SendCumSwallowEvent(Actor CumSource, Bool TopUp = true)
	If TopUp
		StorageUtil.SetFloatValue(CumSource, "_SLS_LastOrgasmTime", -7.0)
	EndIf
	int DrinkCum = ModEvent.Create("_SLS_SwallowCum")
	If (DrinkCum)
		ModEvent.PushForm(DrinkCum, CumSource)
		ModEvent.PushFloat(DrinkCum, -1.0)
		ModEvent.PushBool(DrinkCum, true)
		ModEvent.PushInt(DrinkCum, 1)
		ModEvent.Send(DrinkCum)
	EndIf
EndFunction

Function SuspendTasks()
	Int TasksSuspend = ModEvent.Create("pchsWartimesTasksSuspend")
	If (TasksSuspend)
		ModEvent.PushForm(TasksSuspend, self)
		ModEvent.Send(TasksSuspend)
	EndIf
EndFunction

Function ResumeTasks()
	Int TasksResume = ModEvent.Create("pchsWartimesTasksResume")
	If (TasksResume)
		ModEvent.PushForm(TasksResume, self)
		ModEvent.Send(TasksResume)
	EndIf
EndFunction

Bool Function IsPahSlave(Actor akActor)
	Return akActor.GetFactionRank(PAHSubmission) >= 0
EndFunction

Bool Function IsSubmissivePahSlave(Actor akActor)
	Return akActor.GetFactionRank(PAHSubmission) >= 90
EndFunction

Form[] Function GetPahSlavesInArea()
	StorageUtil.FormListClear(Self, "PahSlaveScanTemp")
	pchsPahSlaveScan.Stop()
	pchsPahSlaveScan.Start()
	Int i = 0
	Actor akActor
	While i < pchsPahSlaveScan.GetNumAliases()
		akActor = (pchsPahSlaveScan.GetNthAlias(i) as ReferenceAlias).GetReference() as Actor
		If akActor && akActor.GetFactionRank(PAHSubmission) >= 0
			StorageUtil.FormListAdd(Self, "PahSlaveScanTemp", akActor, AllowDuplicate = false)
		EndIf
		i += 1
	EndWhile
	Return StorageUtil.FormListToArray(Self, "PahSlaveScanTemp")
EndFunction

Form[] Function GetSubmissivePahSlaves(Int Submission)
	StorageUtil.FormListClear(Self, "PahSubSlavesTemp")
	Form[] PahSlaves = GetPahSlavesInArea()
	Int i = 0
	While i < PahSlaves.Length
		If (PahSlaves[i] as Actor).GetFactionRank(PAHSubmission) >= Submission
			StorageUtil.FormListAdd(Self, "PahSubSlavesTemp", PahSlaves[i], AllowDuplicate = false)
		EndIf
		i += 1
	EndWhile
	Return StorageUtil.FormListToArray(Self, "PahSubSlavesTemp")
EndFunction

Int Function CountPahSubsInArea(Int Submission)
	Return GetSubmissivePahSlaves(Submission).Length
EndFunction

Function SetSelectedPahSlave(Int Submission)
	Actor akActor = SelectPahSubInArea(Submission)
	If akActor
		SelectedPahSlave = akActor
		SetPahSlaveStats(SelectedPahSlave)
	Else
		SelectedPahSlave = None
	EndIf
EndFunction

Function SetSelectedHomeSlave()
	Actor akActor = SelectHomeSlave()
	If akActor
		SelectedPahSlave = akActor
		SetPahSlaveStats(SelectedPahSlave)
	Else
		akActor = None
	EndIf
EndFunction

Actor Function SelectPahSubInArea(Int Submission)
	Form[] PahSubs = GetSubmissivePahSlaves(Submission)
	UIListMenu ListMenu = UIExtensions.GetMenu("UIListMenu") as UIListMenu
	Int i = 0
	While i < PahSubs.Length
		ListMenu.AddEntryItem((PahSubs[i] as Actor).GetDisplayName())
		i += 1
	EndWhile
	ListMenu.OpenMenu()
	Int Result = ListMenu.GetResultInt()
	If Result >= 0
		Return PahSubs[Result] as Actor
	EndIf
	Return None
EndFunction

Actor Function SelectHomeSlave()
	Form[] Slaves = StorageUtil.FormListToArray(None, "pchsWtHomeSlavesList")
	UIListMenu ListMenu = UIExtensions.GetMenu("UIListMenu") as UIListMenu
	Int i = 0
	While i < Slaves.Length
		ListMenu.AddEntryItem((Slaves[i] as Actor).GetDisplayName())
		i += 1
	EndWhile
	ListMenu.OpenMenu()
	Int Result = ListMenu.GetResultInt()
	If Result >= 0
		Return Slaves[Result] as Actor
	EndIf
	Return None
EndFunction

Function SetPahSlaveStats(Actor akActor)
	Float DaysToBoredom = 2.0
	pchsPahSlaveSubmission.SetValueInt(akActor.GetFactionRank(PAHSubmission))
	pchsPahSlaveSexTraining.SetValueInt(akActor.GetFactionRank(PAHTrainSex))
	pchsPahSlaveWeight.SetValue(akActor.GetLeveledActorBase().GetWeight())
	;pchsHomeSlaveUnassignBoredom.SetValue((Utility.GetCurrentGameTime() + DaysToBoredom > StorageUtil.GetFloatValue(akActor, "pchsWtHomeSlaveAssignTime")) as Int)
EndFunction

Function DisplayPahSlaveStats()
	If SelectedPahSlave
		UiKey.DisplaySlaveStatsActor(SelectedPahSlave)
	Else
		Debug.Notification("No slave selected")
	EndIf
EndFunction

Bool Function IsLeashedSlave(Actor akActor)
	If akActor.WornHasKeyword(PAHRestraintLeash)
		Return true
	EndIf
	Return false
EndFunction

Bool Function PlayerBurnedDinner()
	If pchsPCGaveMassage.GetValueInt() >= 1
		Float PassChance
		If Menu.CookingSkill > 0.0
			PassChance = PapyrusUtil.ClampFloat(PlayerRef.GetAv("Alchemy"), 0.0, Menu.CookingSkill) / Menu.CookingSkill ; 0.0 -> 1.0 based on alchemy skill
			PassChance = PapyrusUtil.ClampFloat(PassChance, 0.33, 1.0 - (Menu.CookingFailChanceMin / 100.0)) ; minimum chance: 33%. Max chance: CookingFailChanceMin
		Else
			PassChance = 1.0 - (Menu.CookingFailChanceMin / 100.0)
		EndIf
		If Utility.RandomFloat(0.0, 1.0) >= PassChance
			Return true
		EndIf
		Return false
	EndIf
	Return false
EndFunction
;/
Function BeatPlayer()
	(Game.GetFormFromFile(0x41951C, "pchsWartimes.esp") as pchsBeatPlayer).BeginBeating(pchsFather, "Whip")
EndFunction
/;
Function FatherHit()
	Debug.SendAnimationEvent(pchsFather, "attackStart")
	Utility.Wait(1.0)
	Game.ShakeCamera(akSource = None, afStrength = 0.5, afDuration = 1.0)
	Debug.SendAnimationEvent(PlayerRef, "StaggerStop")
	SendModEvent("_SLS_AddTraumaToPlayer", "DoSound", 0.0)
	Utility.Wait(0.75)
	If PlayerRef.GetAv("Health") > Menu.MinHealth
		PlayerRef.DamageAv("Health", 5.0)
	EndIf
EndFunction

Function FoundStolenBlade()
	ObjectReference SwordObjRef = (pchsWartimes.GetNthAlias(16) as ReferenceAlias).GetReference()
	ObjectReference DaggerObjRef = (pchsWartimes.GetNthAlias(17) as ReferenceAlias).GetReference()
	
	Form IronSword = Game.GetFormFromFile(0x012EB7, "Skyrim.esm")
	Form IronDagger = Game.GetFormFromFile(0x01397E, "Skyrim.esm")

	GlobalVariable pchsPlayerStoleSword = Game.GetFormFromFile(0x03D269E, "pchsWartimes.esp") as GlobalVariable
	GlobalVariable pchsPlayerStoleDagger = Game.GetFormFromFile(0x3D269F, "pchsWartimes.esp") as GlobalVariable
	
	If pchsPlayerStoleSword.GetValue()
		If !SwordObjRef
			ObjectReference ObjRef
			If PlayerRef.GetItemCount(IronSword) > 0
				ObjRef = PlayerRef.DropObject(IronSword)
			Else
				ObjRef = pchsPlayersLockerRef.DropObject(IronSword)
			EndIf
			(pchsWartimes.GetNthAlias(16) as ReferenceAlias).ForceRefTo(ObjRef)
			SwordObjRef = ObjRef
		EndIf
		SwordObjRef.MoveTo(PlayerRef, afXOffset = 0.0, afYOffset = 0.0, afZOffset = -100.0, abMatchRotation = true)
		SwordObjRef.MoveToMyEditorLocation()
		SwordObjRef.SetDisplayName("Father's Iron Sword")
		pchsPlayerStoleSword.SetValue(0.0)
	EndIf
	
	If pchsPlayerStoleDagger.GetValue()
		If !DaggerObjRef
			ObjectReference ObjRef
			If PlayerRef.GetItemCount(IronSword) > 0
				ObjRef = PlayerRef.DropObject(IronDagger)
			Else
				ObjRef = pchsPlayersLockerRef.DropObject(IronDagger)
			EndIf
			(pchsWartimes.GetNthAlias(17) as ReferenceAlias).ForceRefTo(ObjRef)
			DaggerObjRef = ObjRef
		EndIf
		DaggerObjRef.MoveTo(PlayerRef, afXOffset = 0.0, afYOffset = 0.0, afZOffset = -100.0, abMatchRotation = true)
		DaggerObjRef.MoveToMyEditorLocation()
		DaggerObjRef.SetDisplayName("Father's Iron Dagger")
		pchsPlayerStoleDagger.SetValue(0.0)
	EndIf
	
	SpankPlayer(Strip = false, Spanker = pchsFather)
EndFunction

Function SpankPlayer(Bool Strip = false, Actor Spanker)
	If !Strip
		pchsNoStripQuest.Start()
	EndIf
	
	Actor[] SexActors = new Actor[2]
	SexActors[0] = PlayerRef
	SexActors[1] = pchsFather
	sslBaseAnimation[] Anims = SexLab.GetAnimationsByTags(SexActors.Length, Fav.GetTagsForSex("spanking", ""), Fav.GetSupTagsForSex("spanking", ""), false)
	SexLab.StartSex(SexActors, Anims, None, None, false)
	Fav.ModStat("I haven't been spanked since I was a child. How humiliating", Favour = 0.0, Depravity = 0.0, Submission = 2.0, Sender = Self)
EndFunction

Function EatPussy(Actor Eater, Actor Eatee)
	Actor[] SexActors = new Actor[2]
	SexActors[0] = Eatee
	SexActors[1] = Eater
	sslBaseAnimation[] Anims = SexLab.GetAnimationsByTags(SexActors.Length, Fav.GetTagsForSex("Cunninglingus", ""), Fav.GetSupTagsForSex("Cunninglingus", ""), false)
	SexLab.StartSex(SexActors, Anims, None, None, false)
	If Eater == PlayerRef && Eatee == pchsMother
		PlayerRef.AddSpell(pchsAteMothersPussySpell)
	EndIf
EndFunction

Function UpdateModifiedOutfitsJson()
	SetOutfitLevels()
	SetUngiftedOutfitsThisLevelCount()
	SetOutfitVar()
EndFunction

Function OutfitGiftMenu()
	pchsOutfitDummyRef.RemoveAllItems()
	
	Form[] OutfitList
	If pchsRequiredOutfitLevel.GetValueInt() == 100
		OutfitList = GetOutfitsForLevel(pchsRequiredOutfitMaxLevel.GetValueInt())
	Else
		OutfitList = GetOutfitsThisLevel()
	EndIf
	
	If OutfitList.Length > 0
		Int i = 0
		While i < OutfitList.Length
			pchsOutfitDummyRef.AddItem(OutfitList[i])
			i += 1
		EndWhile
	Else
		Debug.Notification("No outfits for level " + pchsRequiredOutfitLevel.GetValueInt())
		Debug.Trace("pchs: OutfitGiftMenu(): No outfits for level " + pchsRequiredOutfitLevel.GetValueInt())
	EndIf
	pchsOutfitGiftQuest.Start()
	pchsOutfitDummyRef.ShowGiftMenu(false)
	
	
	;GiftAccessoriesForOutfit(akOutfit)
EndFunction

Function OutfitGiftTaken(Form akBaseObject)
	pchsOutfitGiftQuest.Stop()
	Input.TapKey(Input.GetMappedKey("Tween Menu", DeviceType = 0xFF))
	
	Fav.pchsFatherVoluntaryServeRep.Mod(-5)
	Debug.Notification("Favour -5")
	
	Form[] Accessories = GetAccessoriesForOutfit(akBaseObject)
	Int i = 0
	While i < Accessories.Length
		PlayerRef.AddItem(Accessories[i])
		i += 1
	EndWhile
EndFunction

Function AddOutfit(Form akOutfit, Int Level)
	Form[] AccList = GetWornAccessories(akOutfit)
	String AccListName
	If AccList && AccList.Length > 0
		AccListName = UiKey.GetAccessoryListName()
		If AccListName != ""
			If JsonUtil.StringListFind("Wartimes/Outfits.json", "accessorieslist", akOutfit) == -1
				JsonUtil.StringListAdd("Wartimes/Outfits.json", "accessorieslist", AccListName)
				JsonUtil.FormListAdd("Wartimes/Outfits.json", "hasaccessories", akOutfit)
				JsonUtil.FormListCopy("Wartimes/Outfits.json", AccListName, AccList)
				
			Else
				Debug.Notification(AccListName + " already exists in json")
				Return
			EndIf
		EndIf
	EndIf
	
	JsonUtil.FormListAdd("Wartimes/Outfits.json", "outfits_" + Level, akOutfit)
	JsonUtil.Save("Wartimes/Outfits.json")
	UpdateModifiedOutfitsJson()
	
	If AccListName != ""
		Debug.Messagebox("Added " + akOutfit.GetName() + " as outfit at level " + Level + " with accessory list " + AccListName + "\n\nAccessory Count: " + AccList.Length)
	Else
		Debug.Messagebox("Added " + akOutfit.GetName() + " as outfit at level " + Level)
	EndIf
EndFunction

Form[] Function GetWornAccessories(Form akOutfit)
	Form akForm
	Int i = 0
	While i < SlotMasks.Length
		If i != 2 ; Not body slot
			akForm = PlayerRef.GetWornForm(SlotMasks[i])
			If akForm != akOutfit && IsAccessoryForm(akForm)
				StorageUtil.FormListAdd(Self, "pchsAccessoryListTemp", akForm, AllowDuplicate = false)
			EndIf
		EndIf
		i += 1
	EndWhile
	Form[] AccList = StorageUtil.FormListToArray(Self, "pchsAccessoryListTemp")
	StorageUtil.FormListClear(Self, "pchsAccessoryListTemp")
	Return AccList
EndFunction

Bool Function IsAccessoryForm(Form akForm)
	If akForm && akForm.IsPlayable() && akForm.GetName() != "" && !akForm.HasKeyWord(zbfWornDevice) && !akForm.HasKeyWord(SexlabNoStrip)
		Return true
	EndIf
	Return false
EndFunction

Function RemoveOutfit(Form akOutfit)
	Int Level = GetOutfitLevel(akOutfit)
	If JsonUtil.FormListCount("Wartimes/Outfits.json", "outfits_" + Level) == 1 && JsonUtil.FormListCount("Wartimes/Outfits.json", "outfits_" + (Level + 1)) > 0
		Debug.Messagebox("This is the last outfit at level " + Level + " but there are still outfits in level " + (Level + 1) + "\n\nThere can not be empty outfit lists between levels - Aborting!")
		Return
	ElseIf Level == 0 && JsonUtil.FormListCount("Wartimes/Outfits.json", "outfits_0") == 1
		Debug.Messagebox("The mod requires at least one outfit at level 0. Add an outfit before removing the last outfit")
		Return
	EndIf
	
	Int AccessoryIndex = JsonUtil.FormListFind("Wartimes/Outfits.json", "hasaccessories", akOutfit)
	If AccessoryIndex > -1
		String AccList = JsonUtil.StringListGet("Wartimes/Outfits.json", "accessorieslist", AccessoryIndex)
		JsonUtil.FormListRemoveAt("Wartimes/Outfits.json", "hasaccessories", AccessoryIndex)
		JsonUtil.StringListRemoveAt("Wartimes/Outfits.json", "accessorieslist", AccessoryIndex)
		JsonUtil.FormListClear("Wartimes/Outfits.json", AccList)
	EndIf

	Int i = 0
	While JsonUtil.FormListCount("Wartimes/Outfits.json", "outfits_" + i) > 0
		Int j = 0
		JsonUtil.FormListRemove("Wartimes/Outfits.json", "outfits_" + i, akOutfit)
		i += 1
	EndWhile
	
	If JsonUtil.FormListCount("Wartimes/Outfits.json", "outfits_" + Level) == 0
		JsonUtil.FormListClear("Wartimes/Outfits.json", "outfits_" + Level)
	EndIf
	
	JsonUtil.Save("Wartimes/Outfits.json")
	
	UpdateModifiedOutfitsJson()
EndFunction

Int Function GetOutfitLevel(Form akBaseObject)
	Int i = 0
	While JsonUtil.FormListCount("Wartimes/Outfits.json", "outfits_" + i) > 0
		Int j = 0
		While j < JsonUtil.FormListCount("Wartimes/Outfits.json", "outfits_" + i)
			If JsonUtil.FormListFind("Wartimes/Outfits.json", "outfits_" + i, akBaseObject) > -1
				Return i
			EndIf
			j += 1
		EndWhile
		i += 1
	EndWhile
	Return -1
EndFunction

Function SetOutfitLevels()
	; Remove previous values
	Int i = 0
	While i < StorageUtil.FormListCount(None, "pchsWtOutfitListFull")
		StorageUtil.UnSetIntValue(StorageUtil.FormListGet(None, "pchsWtOutfitListFull", i), "pchsWtOutfitLevel")
		i += 1
	EndWhile
	StorageUtil.FormListClear(None, "pchsWtOutfitListFull")
	
	i = 0
	While i < StorageUtil.FormListCount(None, "pchsWtAccessoryListFull")
		StorageUtil.UnSetIntValue(StorageUtil.FormListGet(None, "pchsWtAccessoryListFull", i), "pchsWtAccessoryLevel")
		i += 1
	EndWhile
	
	; Set levels on outfits from json
	i = 0
	Form akOutfit
	While JsonUtil.FormListCount("Wartimes/Outfits.json", "outfits_" + i) > 0
		Int j = 0
		While j < JsonUtil.FormListCount("Wartimes/Outfits.json", "outfits_" + i)
			akOutfit = JsonUtil.FormListGet("Wartimes/Outfits.json", "outfits_" + i, j)
			StorageUtil.SetIntValue(akOutfit, "pchsWtOutfitLevel", i)
			If HasAccessories(akOutfit)
				SetAccessoryLevels(akOutfit, i)
			EndIf
			j += 1
		EndWhile
		i += 1 ; Next outfit group
	EndWhile
	
	; Set vars
	pchsRequiredOutfitMaxLevel.SetValueInt(i - 1)
	If pchsRequiredOutfitLevel.GetValueInt() != 100 && pchsRequiredOutfitLevel.GetValueInt() > pchsRequiredOutfitMaxLevel.GetValueInt()
		pchsRequiredOutfitLevel.SetValueInt(pchsRequiredOutfitMaxLevel.GetValueInt())
	EndIf
	
	SetOutfitVar()
EndFunction

Function SetAccessoryLevels(Form akOutfit, Int Level)
	Form[] AccList = GetAccessoriesForOutfit(akOutfit)
	Int i = 0
	While i < AccList.Length
		StorageUtil.SetIntValue(AccList[i], "pchsWtAccessoryLevel", Level)
		i += 1
	EndWhile
EndFunction

Function IncreaseOutfitReq()
	pchsPlayerEquipQuest.Start()
	If pchsRequiredOutfitLevel.GetValueInt() < pchsRequiredOutfitMaxLevel.GetValueInt()
		pchsRequiredOutfitLevel.Mod(1)
		If pchsRequiredOutfitLevel.GetValue() > 0
			Debug.Messagebox("This dress Father got me, if you could call it a dress, seems a lot... lighter than the last one.") 
		EndIf
		
		SetUngiftedOutfitsThisLevelCount()
		StorageUtil.FormListClear(Self, "pchsGiftedOutfitsThisLevel")
	Else
		Debug.Trace("pchs: IncreaseOutfitReq(): pchsRequiredOutfitLevel is equal or exceeds pchsRequiredOutfitMaxLevel: (" + pchsRequiredOutfitLevel.GetValueInt() + " / " + pchsRequiredOutfitMaxLevel.GetValueInt() + ")")
	EndIf
	If pchsRequiredOutfitLevel.GetValueInt() == pchsRequiredOutfitMaxLevel.GetValueInt()
		pchsOutfitChangeCooldown.SetValue(Utility.GetCurrentGameTime() + Utility.RandomFloat(1.0, 2.0))
	Else 
		pchsOutfitChangeCooldown.SetValue(Utility.GetCurrentGameTime() + (Utility.RandomFloat(3.0, 7.0) as Int))
	EndIf
EndFunction

Function SetOutfitVar()
	; pchsPcIsWearingOutfit: -1 - Not complying, >0 - Various levels of complying. 100 - Naked
	; pchsRequiredOutfitLevel 0 - No requirement, >0 - Various requirements, 100 - Naked
	
	Form akForm = PlayerRef.GetWornForm(0x00000004)
	If !akForm
		pchsPcIsWearingOutfit.SetValueInt(100)
	Else
		Int OutfitLevel = StorageUtil.GetIntValue(akForm, "pchsWtOutfitLevel", Missing = -1)
		;Debug.Messagebox("OutfitLevel: " + OutfitLevel)
		If OutfitLevel > -1
			If IsWearingAccessories(akForm)
				pchsPcIsWearingOutfit.SetValueInt(OutfitLevel)
			Else
				pchsPcIsWearingOutfit.SetValueInt(-1)
			EndIf
		Else
			pchsPcIsWearingOutfit.SetValueInt(-1)
		EndIf
	EndIf
EndFunction

Bool Function IsWearingAccessories(Form akForm)
	Form[] AccList = GetAccessoriesForOutfit(akForm)
	If AccList && AccList.Length > 0
		Int i = 0
		While i < AccList.Length
			If !PlayerRef.IsEquipped(AccList[i]) && !IsSlotBlocked(AccList[i] as Armor)
				Return false
			EndIf
			i += 1
		EndWhile
	EndIf
	Return true
EndFunction

Bool Function IsSlotBlocked(Armor akArmor)
	Form akForm = PlayerRef.GetWornForm(akArmor.GetSlotMask())
	If akForm && (akForm.HasKeyword(SexlabNoStrip) || akForm.HasKeyWord(zbfWornDevice))
		Return true
	EndIf
	Return false
EndFunction

Bool Function HasAccessories(Form akOutfit)
	Return JsonUtil.FormListFind("Wartimes/Outfits.json", "hasaccessories", akOutfit) > -1
EndFunction

Form[] Function GetAccessoriesForOutfit(Form akOutfit)
	Int Index = JsonUtil.FormListFind("Wartimes/Outfits.json", "hasaccessories", akOutfit)
	If Index > -1
		;Form[] AccList = JsonUtil.FormListToArray("Wartimes/Outfits.json", JsonUtil.StringListGet("Wartimes/Outfits.json", "accessorieslist", Index))
		;Debug.Messagebox("String: " + JsonUtil.StringListGet("Wartimes/Outfits.json", "accessorieslist", Index) + "\nIndex: " + Index + "\n\n" + AccList)
		;Return AccList
		Return JsonUtil.FormListToArray("Wartimes/Outfits.json", JsonUtil.StringListGet("Wartimes/Outfits.json", "accessorieslist", Index))
	EndIf
	Form[] Empty
	Return Empty
EndFunction

Function GiftRandomOutfit()
	Form[] OutfitList = GetUngiftedOutfitsThisLevel()
	Form akOutfit = OutfitList[Utility.RandomInt(0, OutfitList.Length - 1)]
	PlayerRef.AddItem(akOutfit)
	StorageUtil.FormListAdd(Self, "pchsGiftedOutfitsThisLevel", akOutfit)
	GiftAccessoriesForOutfit(akOutfit)
	SetUngiftedOutfitsThisLevelCount()
	SetOutfitVar()
EndFunction

Form[] Function GetOutfitsThisLevel()
	Return JsonUtil.FormListToArray("Wartimes/Outfits.json", "outfits_" + pchsRequiredOutfitLevel.GetValueInt())
EndFunction

Form[] Function GetOutfitsForLevel(Int Level)
	Return JsonUtil.FormListToArray("Wartimes/Outfits.json", "outfits_" + Level)
EndFunction

Form[] Function GetUngiftedOutfitsThisLevel()
	Form[] OutfitList = GetOutfitsThisLevel()
	StorageUtil.FormListCopy(Self, "pchsOutfitsListTemp", OutfitList)
	Int i = 0
	While i < StorageUtil.FormListCount(Self, "pchsGiftedOutfitsThisLevel")
		StorageUtil.FormListRemove(Self, "pchsOutfitsListTemp", StorageUtil.FormListGet(Self, "pchsGiftedOutfitsThisLevel", i))
		i += 1
	EndWhile
	Form[] Result = StorageUtil.FormListToArray(Self, "pchsOutfitsListTemp")
	StorageUtil.FormListClear(Self, "pchsOutfitsListTemp")
	Return Result
EndFunction

Int Function GetUngiftedOutfitsThisLevelCount()
	Return GetUngiftedOutfitsThisLevel().Length
EndFunction

Function SetUngiftedOutfitsThisLevelCount()
	pchsUngiftedOutfitsThisLevelCount.SetValueInt(GetUngiftedOutfitsThisLevelCount())
EndFunction

Function GiftAccessoriesForOutfit(Form akOutfit)
	Form[] AccList = GetAccessoriesForOutfit(akOutfit)
	If AccList && AccList.Length > 0
		Int i = 0
		While i < AccList.Length
			PlayerRef.AddItem(AccList[i])
			i += 1
		EndWhile
	EndIf
EndFunction

Function RemoveDuplicateFormsFromAccessories() ; Hopefully one time bug fix to deduplicate outfit parts
	Int i = 0
	Form akOutfit
	Form akAcc
	Int AccIndex
	While JsonUtil.FormListCount("Wartimes/Outfits.json", "outfits_" + i)
		Int j = 0
		While j < JsonUtil.FormListCount("Wartimes/Outfits.json", "outfits_" + i)
			akOutfit = JsonUtil.FormListGet("Wartimes/Outfits.json", "outfits_" + i, j)
			AccIndex = JsonUtil.FormListFind("Wartimes/Outfits.json", "hasaccessories", akOutfit)
			If AccIndex > -1 ; Has Accessories
				String AccListName = JsonUtil.StringListGet("Wartimes/Outfits.json", "accessorieslist", AccIndex)
				Int k = 0
				While k < JsonUtil.FormListCount("Wartimes/Outfits.json", AccListName)
					akAcc = JsonUtil.FormListGet("Wartimes/Outfits.json", AccListName, k)
					If akAcc != akOutfit
						StorageUtil.FormListAdd(Self, "pchsWtDuplicateOutfitFixList", akAcc, AllowDuplicate = false)
					EndIf
					k += 1
				EndWhile
				
				If StorageUtil.FormListCount(Self, "pchsWtDuplicateOutfitFixList") > 0 ; Rebuild list
					Form[] TempList = StorageUtil.FormListToArray(Self, "pchsWtDuplicateOutfitFixList")
					JsonUtil.FormListClear("Wartimes/Outfits.json", AccListName)
					JsonUtil.FormListCopy("Wartimes/Outfits.json", AccListName, TempList)
				Else ; Delete acc list
					JsonUtil.FormListRemoveAt("Wartimes/Outfits.json", "hasaccessories", AccIndex)
					JsonUtil.StringListRemoveAt("Wartimes/Outfits.json", "accessorieslist", AccIndex)
				EndIf				
				StorageUtil.FormListClear(Self, "pchsWtDuplicateOutfitFixList")
			EndIf
			j += 1
		EndWhile
		i += 1
	EndWhile
	JsonUtil.Save("Wartimes/Outfits.json")
EndFunction

Function SetCollarVar()
	pchsPcIsWearingCollar.SetValueInt(GetIsPlayerWearingCollar())
EndFunction

Function SetHeelsVar()
	pchsPcIsWearingHeels.SetValueInt(GetIsPlayerWearingSlaveHeels())
EndFunction

Int Function GetIsPlayerWearingCollar()
	If PlayerREF.WornHasKeyWord(zbfWornCollar) || PlayerREF.WornHasKeyWord(zad_DeviousCollar)
		Return 1
	EndIf
	Return 0
EndFunction

Int Function GetIsPlayerWearingSlaveHeels()
	Form Boots = PlayerRef.GetWornForm(0x00000080)
	If Boots && (Boots.HasKeyWord(zbfWornDevice) || PlayerRef.WornHasKeyWord(zad_DeviousBoots))
		pchsPreviousHeelsList.AddForm(Boots)
		Return 1
	ElseIf IsWearingHeels(PlayerRef)
		pchsPreviousHeelsList.AddForm(Boots)
		Return 1
	EndIf
	Return 0
EndFunction

Bool Function IsWearingHeels(Actor akTarget)
	If IsWearingHdtHeels(akTarget) || IsWearingNioHeels(akTarget, Menu.HeelHeight) || IsWearingKillerHeels(akTarget)
		Return true
	EndIf
	Return false
EndFunction

Bool Function IsWearingHdtHeels(Actor akTarget)
	If Game.GetModByName("hdtHighHeel.esm") != 255
		If akTarget.HasMagicEffect(Game.GetFormFromFile(0x000800, "hdtHighHeel.esm") as MagicEffect)
			Return true
		EndIf
	EndIf
	Return false
EndFunction

Bool Function IsWearingNioHeels(Actor akTarget, Float Height)
	Int IsFemale = akTarget.GetLeveledActorBase().GetSex()
	If NiOverride.HasNodeTransformPosition(akTarget, False, IsFemale, "NPC", "internal")
		;Float[] Pos = NiOverride.GetNodeTransformPosition(akTarget, false, IsFemale, "NPC", "internal")
		If NiOverride.GetNodeTransformPosition(akTarget, false, IsFemale, "NPC", "internal")[2] >= Height
			Return true
		EndIf
	EndIf
	Return false
EndFunction

Bool Function IsWearingKillerHeels(Actor akTarget)
	Form Boots = PlayerRef.GetWornForm(0x00000080)
	If Boots
		If StorageUtil.GetIntValue(Boots, "SLAroused.IsKillerHeels", Missing = -1) > 0
			Return true
		EndIf
	EndIf
	Return false
EndFunction

Function DrunkPunish()
	StorageUtil.StringListAdd(Self, "pchsPunishOptionsTemp", "Spank")
	StorageUtil.StringListAdd(Self, "pchsPunishOptionsTemp", "Prison")
	StorageUtil.StringListAdd(Self, "pchsPunishOptionsTemp", "Beat")
	StorageUtil.StringListAdd(Self, "pchsPunishOptionsTemp", "Whip")
	If !(Game.GetFormFromFile(0x24253, "pchsWartimes.esp") as ObjectReference).IsDisabled() ; Check is zaz furn enabled - Bondage rope over Father's bed
		StorageUtil.StringListAdd(Self, "pchsPunishOptionsTemp", "Zaz")
	EndIf
	If Devious.GetNumFreeSlots(PlayerRef) > 0
		StorageUtil.StringListAdd(Self, "pchsPunishOptionsTemp", "Devices")
	EndIf
	String Result = StorageUtil.StringListGet(Self, "pchsPunishOptionsTemp", Utility.RandomInt(0, StorageUtil.StringListCount(Self, "pchsPunishOptionsTemp") - 1))
	StorageUtil.StringListClear(Self, "pchsPunishOptionsTemp")
	
	If Result == "Spank"
		SpankPlayer(Strip = false, Spanker = pchsFather)
	ElseIf Result == "Prison"
		(Game.GetFormFromFile(0x33A793, "pchsWartimes.esp") as pchsCellarPrison).ApologyFailImprisonment()
	ElseIf Result == "Beat"
		(Game.GetFormFromFile(0x41951C, "pchsWartimes.esp") as pchsBeatPlayer).BeginBeating(Game.GetFormFromFile(0x5A12, "pchsWartimes.esp") as Actor, "Beat")
	ElseIf Result == "Whip"
		(Game.GetFormFromFile(0x41951C, "pchsWartimes.esp") as pchsBeatPlayer).BeginBeating(Game.GetFormFromFile(0x5A12, "pchsWartimes.esp") as Actor, "Whip")
	ElseIf Result == "Zaz"
		(Game.GetFormFromFile(0x3EBBCE, "pchsWartimes.esp") as pchsZazFurnPunish).PlayerZazFurnPunishBegin(Utility.RandomFloat(2.0, 3.0))
	ElseIf Result == "Devices"
		DevicePunishment()
	EndIf
	
;/
	Int RanInt
	If !(Game.GetFormFromFile(0x24253, "pchsWartimes.esp") as ObjectReference).IsDisabled() ; Check is zaz furn enabled - Bondage rope over Father's bed
		RanInt = Utility.RandomInt(0, 5)
	Else
		RanInt = Utility.RandomInt(0, 4)
	EndIf
	If RanInt == 0
		SpankPlayer(Strip = false, Spanker = pchsFather)
	ElseIf RanInt == 1
		(Game.GetFormFromFile(0x33A793, "pchsWartimes.esp") as pchsCellarPrison).ApologyFailImprisonment()
	ElseIf RanInt == 2
		(Game.GetFormFromFile(0x41951C, "pchsWartimes.esp") as pchsBeatPlayer).BeginBeating(Game.GetFormFromFile(0x5A12, "pchsWartimes.esp") as Actor, "Beat")
	ElseIf RanInt == 3
		(Game.GetFormFromFile(0x41951C, "pchsWartimes.esp") as pchsBeatPlayer).BeginBeating(Game.GetFormFromFile(0x5A12, "pchsWartimes.esp") as Actor, "Whip")
	ElseIf RanInt == 4
		
	ElseIf RanInt == 5
		(Game.GetFormFromFile(0x3EBBCE, "pchsWartimes.esp") as pchsZazFurnPunish).PlayerZazFurnPunishBegin(Utility.RandomFloat(2.0, 3.0))
	EndIf
	/;
EndFunction

Function DevicePunishment()
	Devious.EquipRandomDds(PlayerRef, Utility.RandomInt(3, 5))
	Devious.AdjustDeviceRemovalCost(Multiplier = 2.0)
EndFunction

Function IncArousal(Actor akActor, Float Value)
	Value = Value / StorageUtil.GetFloatValue(akActor, "SLAroused.ExposureRate", Missing = 2.0)
	ModArousal(akActor, Value)
EndFunction

Function ModArousal(Actor akActor, Float Amount)
	;Debug.MessageBox("ModArousal: " + Amount)
    Int ModArousalEvent = ModEvent.Create("slaUpdateExposure")
    ModEvent.PushForm(ModArousalEvent, akActor)
    ModEvent.PushFloat(ModArousalEvent, Amount)
    ModEvent.Send(ModArousalEvent)
EndFunction

Function DanceArousal()
	pchsDanceArousalSearchQuest.Stop()
	pchsDanceArousalSearchQuest.Start()
	Bool IsNaked = !PlayerRef.WornHasKeyWord(Menu.ClothingBody) && !PlayerRef.WornHasKeyWord(Menu.ArmorCuirass)
	Int i = 0
	Actor akActor
	While i < pchsDanceArousalSearchQuest.GetNumAliases()
		akActor = (pchsDanceArousalSearchQuest.GetNthAlias(i) as ReferenceAlias).GetReference() as Actor
		If akActor
			IncArousal(akActor, 1.0 + ((IsNaked as Float) * 1.0))
		Else
			Return
		EndIf
		i += 1
	EndWhile
EndFunction

Function SexGamePunishment()
	Int i = StorageUtil.GetIntValue(None, "pchsTimeOffSexGamePunishment")
	If i == 0
		(Game.GetFormFromFile(0x33A793, "pchsWartimes.esp") as pchsCellarPrison).ApologyFailImprisonment()
	ElseIf i == 1
		(Game.GetFormFromFile(0x41951C, "pchsWartimes.esp") as pchsBeatPlayer).BeginBeating(Game.GetFormFromFile(0x5A12, "pchsWartimes.esp") as Actor, "Beat")
	ElseIf i == 2
		(Game.GetFormFromFile(0x41951C, "pchsWartimes.esp") as pchsBeatPlayer).BeginBeating(Game.GetFormFromFile(0x5A12, "pchsWartimes.esp") as Actor, "Whip")
	ElseIf i == 3
		(Game.GetFormFromFile(0x3EBBCE, "pchsWartimes.esp") as pchsZazFurnPunish).PlayerZazFurnPunishBegin(Utility.RandomFloat(2.0, 3.0))
	EndIf	
	StorageUtil.UnSetIntValue(None, "pchsTimeOffSexGamePunishment")
EndFunction

Function ToggleAlchemyTable(Bool EnableIt)
	If EnableIt
		;(Game.GetFormFromFile(0x4CFAC4, "pchsWartimes.esp") as ObjectReference).Enable() ; Table
		(Game.GetFormFromFile(0x4CFAC3, "pchsWartimes.esp") as ObjectReference).Enable() ; Alchemy station
		(Game.GetFormFromFile(0x4CFAC4, "pchsWartimes.esp") as ObjectReference).MoveToMyEditorLocation()
		(Game.GetFormFromFile(0x4CFAC3, "pchsWartimes.esp") as ObjectReference).MoveToMyEditorLocation()
	Else
		;(Game.GetFormFromFile(0x4CFAC4, "pchsWartimes.esp") as ObjectReference).Disable() ; Table
		(Game.GetFormFromFile(0x4CFAC3, "pchsWartimes.esp") as ObjectReference).Disable() ; Alchemy station
	EndIf
EndFunction

Function TidyObject(ObjectReference ObjRef, Actor akActor)
	Location CurLoc = akActor.GetCurrentLocation()
	If CurLoc
		Debug.SendAnimationEvent(akActor, "IdleTake")
		Utility.Wait(0.5)
		Tidy.TidyObject(ObjRef, CurLoc)
		Utility.Wait(0.5)
		Debug.SendAnimationEvent(akActor, "IdleStop")
	Else
		Debug.Notification("I can't tidy out here")
	EndIf
EndFunction

Function AddSlsStashException(ObjectReference akContainer)
	Int AddExcep = ModEvent.Create("_SLS_AddStashException")
    If (AddExcep)
        ModEvent.PushForm(AddExcep, akContainer)
        ModEvent.Send(AddExcep)
    EndIf
EndFunction

Function ToggleCraftingEquipment(Bool EnableIt)
	Formlist BlacksmithStuff = Game.GetFormFromFile(0x55354B, "pchsWartimes.esp") as Formlist ; pchsBlacksmithStuff
	Int i = 0
	While i < BlacksmithStuff.GetSize()
		If EnableIt
			(BlacksmithStuff.GetAt(i) as ObjectReference).Enable()
		Else
			(BlacksmithStuff.GetAt(i) as ObjectReference).Disable()
		EndIf
		i += 1
	EndWhile
EndFunction

Function ToggleSmithGate(Bool LockIt)
	ObjectReference Gate = Game.GetFormFromFile(0x55350E, "pchsWartimes.esp") as ObjectReference ; blacksmith gate
	If LockIt
		Int OpenState = Gate.GetOpenState()
		If OpenState == 2 ; Opening
			While Gate.GetOpenState() == 2
				Utility.Wait(1.0)
			EndWhile
		EndIf
		If OpenState == 1 ; Open
			Gate.SetOpen(false)
		EndIf
		Gate.SetLockLevel(255)
		Gate.Lock(true, false)
	Else
		Gate.Lock(false, false)
	EndIf
EndFunction

Function ToggleCellarDoor(Bool EnableIt)
	ObjectReference CellarDoor = Game.GetFormFromFile(0x19FFC, "pchsWartimes.esp") as ObjectReference
	If EnableIt
		CellarDoor.Enable()
	Else
		CellarDoor.Disable()
	EndIf
EndFunction

Function DisableSLAC(Actor akActor)
	If Game.GetModByName("SexLab Aroused Creatures.esp") != 255
		Faction slac_ExcludeFaction = Game.GetFormFromFile(0x08D7E9, "SexLab Aroused Creatures.esp") as Faction
		If slac_ExcludeFaction
			akActor.AddToFaction(slac_ExcludeFaction)			
		EndIf
	EndIf
EndFunction

Function EnableSLAC(Actor akActor)
	If Game.GetModByName("SexLab Aroused Creatures.esp") != 255
		Faction slac_ExcludeFaction = Game.GetFormFromFile(0x08D7E9, "SexLab Aroused Creatures.esp") as Faction
		If slac_ExcludeFaction
			akActor.RemoveFromFaction(slac_ExcludeFaction)			
		EndIf
	EndIf
EndFunction

Function AddFoodConfiscationExceptions()
	; Why in the name of beelzebub's sphincter is everything using the VendorItemFood keyword for things that are clearly NOT food?!
	
	Formlist NoSwapForCumList = Game.GetFormFromFile(0x2A79A0, "pchsWartimes.esp") as Formlist ; pchsNoSwapForCumList
	If Game.GetModByName("SexLabSkoomaWhore.esp") != 255
		Formlist Drugs = Game.GetFormFromFile(0x020C71, "SexLabSkoomaWhore.esp") as Formlist; SLSW_DrugsWOcure [FLST:03020C71]
		Int i = 0
		While i < Drugs.GetSize()
			NoSwapForCumList.AddForm(Drugs.GetAt(i))
			i += 1
		EndWhile
	EndIf
	
	If Game.GetModByName("MilkModNEW.esp") != 255
		NoSwapForCumList.AddForm(Game.GetFormFromFile(0x0343F2, "MilkModNEW.esp")) ; MME_Lactacid "Lactacid" [ALCH:030343F2]
	EndIf
EndFunction

Function UpdateSlsCreatureCorruptionGlobal()
	pchsSlsCreatureCorruption.SetValue(StorageUtil.GetFloatValue(None, "_SLS_CreatureCorruption", Missing = 0.0))
EndFunction

Function SendSpanker(Actor akActor, Float Timeout = 5.0)
	Int SpankIt = ModEvent.Create("STA_DoNpcSpankSpecific")
	If (SpankIt)
		ModEvent.PushFloat(SpankIt, Timeout)
		ModEvent.PushForm(SpankIt, akActor)
		ModEvent.PushBool(SpankIt, false)
		ModEvent.PushFloat(SpankIt, -1.0)
		ModEvent.Send(SpankIt)
	EndIf
EndFunction

Bool Function FatherIsInRoomWithPlayer()
	Return ((pchsHomeLocPlayerLivingRoom.GetValue() && pchsHomeLocFatherLivingRoom.GetValue()) || (pchsHomeLocPlayerFathersRoom.GetValue() && pchsHomeLocFatherFathersRoom.GetValue()) || (pchsHomeLocPlayerPlayersRoom.GetValue() && pchsHomeLocFatherPlayersRoom.GetValue()) || (pchsHomeLocPlayerMothersRoom.GetValue() && pchsHomeLocFatherMothersRoom.GetValue()))
EndFunction

Bool Function FatherIsAwareOfPlayer()
	Return pchsFather.GetSleepState() == 0 && FatherIsInRoomWithPlayer()
EndFunction

Function RemoveAllInvItems(ObjectReference RemFrom, ObjectReference RemTo = None)
	Int i = RemFrom.GetNumItems()
	Form akForm
	While i > 0
		i -= 1
		akForm = RemFrom.GetNthForm(i)
		If akForm.GetName() && akForm.IsPlayable() && !akForm.HasKeyWord(SexlabNoStrip)
			RemFrom.RemoveItem(RemFrom, RemFrom.GetItemCount(akForm), RemTo)
		EndIf
	EndWhile
EndFunction

Function ToggleGagTalkFaction(Actor akActor, Bool DisableGagTalk)
	If Game.GetModByName("Devious Devices - Integration.esm") != 255
		If DisableGagTalk
			akActor.AddToFaction(Game.GetFormFromFile(0x04653B, "Devious Devices - Integration.esm") as Faction)
		Else
			akActor.RemoveFromFaction(Game.GetFormFromFile(0x04653B, "Devious Devices - Integration.esm") as Faction)
		EndIf
	EndIf
EndFunction

Function ToggleSlacOnActor(Actor akActor, Bool Exclude = true)
	If Game.GetModByName("SexLab Aroused Creatures.esp") != 255
		Faction slac_ExcludeFaction = Game.GetFormFromFile(0x08D7E9, "SexLab Aroused Creatures.esp") as Faction
		If slac_ExcludeFaction
			If Exclude
				akActor.AddToFaction(slac_ExcludeFaction)
			Else
				akActor.RemoveFromFaction(slac_ExcludeFaction)
			EndIf			
		EndIf
	EndIf
EndFunction

Bool Function GetAreSpanksAllowed(Actor akActor)
	; Need to write the functionality into STA/SLS
	Return true
EndFunction

Function ToggleSpanksOnActor(Actor akActor, Bool AllowSpanks)
	; Need to write the functionality into STA/SLS
	
EndFunction

Int[] Property SlotMasks Auto Hidden

Spell Property pchsBeatingSpell Auto
Spell Property pchsAteMothersPussySpell Auto

Location Property pchsWartimesHomeLocation Auto

Actor Property SelectedPahSlave Auto Hidden
Actor Property PlayerRef Auto
Actor Property pchsFather Auto
Actor Property pchsMother Auto
Actor Property pchsOutfitDummyRef Auto

ObjectReference Property pchsStolenBlades Auto
ObjectReference Property pchsPlayersLockerRef Auto

Faction Property PAHTrainSex Auto Hidden
Faction Property PAHSubmission Auto Hidden
Faction Property pchsDummyNeverUsedFact Auto

Keyword Property zad_DeviousBoots Auto Hidden
Keyword Property zad_DeviousCollar Auto Hidden
Keyword Property PAHRestraintLeash Auto Hidden
Keyword Property MME_Milk Auto Hidden
Keyword Property pchsDummyNeverUsedKw Auto
Keyword Property zbfWornDevice Auto
Keyword Property zbfWornCollar Auto
Keyword Property SexlabNoStrip Auto

GlobalVariable Property pchsPCGaveMassage Auto
GlobalVariable Property pchsPiercingsMaxLevel Auto
GlobalVariable Property pchsAnimsHorseHandjob Auto
GlobalVariable Property pchsAnimsDogHandjob Auto
GlobalVariable Property pchsAnimsSpanking Auto
GlobalVariable Property pchsSdInstalled Auto
GlobalVariable Property pchsSlsoInstalled Auto
GlobalVariable Property pchsYpsInstalled Auto
GlobalVariable Property pchsDdsInstalled Auto
GlobalVariable Property pchsPahInstalled Auto
GlobalVariable Property pchsRapeTatsInstalled Auto
GlobalVariable Property pchsPahSlaveSexTraining Auto
GlobalVariable Property pchsPahSlaveSubmission Auto
GlobalVariable Property pchsPahSlaveWeight Auto
GlobalVariable Property pchsPcIsWearingCollar Auto
GlobalVariable Property pchsPcIsWearingHeels Auto
GlobalVariable Property pchsBeatingLevel Auto
GlobalVariable Property pchsPcIsWearingOutfit Auto
GlobalVariable Property pchsRequiredOutfitLevel Auto
GlobalVariable Property pchsRequiredOutfitMaxLevel Auto
GlobalVariable Property pchsOutfitChangeCooldown Auto
GlobalVariable Property pchsUngiftedOutfitsThisLevelCount Auto
GlobalVariable Property pchsSlsCreatureCorruption Auto

GlobalVariable Property pchsHomeLocPlayerPlayersRoom Auto
GlobalVariable Property pchsHomeLocPlayerFathersRoom Auto
GlobalVariable Property pchsHomeLocPlayerLivingRoom Auto
GlobalVariable Property pchsHomeLocPlayerMothersRoom Auto

GlobalVariable Property pchsHomeLocFatherPlayersRoom Auto
GlobalVariable Property pchsHomeLocFatherFathersRoom Auto
GlobalVariable Property pchsHomeLocFatherLivingRoom Auto
GlobalVariable Property pchsHomeLocFatherMothersRoom Auto

Race Property HorseRace Auto
Race Property DogRace Auto

Quest Property pchsPahSlaveScan Auto
Quest Property pchsNoStripQuest Auto
Quest Property pchsWartimes Auto
Quest Property pchsPlayerEquipQuest Auto
Quest Property pchsOutfitGiftQuest Auto
Quest Property pchsDanceArousalSearchQuest Auto

Formlist Property pchsPreviousHeelsList Auto

pchsWtClutterTidy Property Tidy Auto
pchsWtFavour Property Fav Auto
pchsWtUiKey Property UiKey Auto
pchsWtHorseMilk Property HorseMilk Auto
SexlabFramework Property Sexlab Auto
pchsWartimesMCM Property Menu Auto
pchsWartimesPlayerScript Property pchsPlayer Auto
pchsWtInterfaceDevious Property Devious Auto
