Scriptname pchsWtWoodChopBlock extends ObjectReference  

Event OnActivate(ObjectReference akActionRef)
	If akActionRef == PlayerRef
		If akActionRef.GetItemCount(Axe01) > 0
			ChopCount = 0
			RegForEvents(akActionRef as Actor)
			Activate(akActionRef, true)
		Else
			Debug.Notification("I need an axe to chop wood")
		EndIf
	EndIf
EndEvent

Event OnLoad()
	BlockActivation(true)
EndEvent

Event OnUnload()
	; safety measure
	UnRegForEvents(PlayerRef)
EndEvent

Function RegForEvents(Actor akActor)
	RegisterForAnimationEvent(akActor, "AddToInventory")
	;RegisterForAnimationEvent(akActor, "SoundPlay.NPCHumanWoodChop")
	RegisterForAnimationEvent(akActor, "IdleFurnitureExit")
EndFunction

Function UnRegForEvents(Actor akActor)
	UnRegisterForAnimationEvent(akActor, "AddToInventory")
	;UnRegisterForAnimationEvent(akActor, "SoundPlay.NPCHumanWoodChop")
	UnRegisterForAnimationEvent(akActor, "IdleFurnitureExit")
EndFunction

Event OnAnimationEvent(ObjectReference akSource, string asEventName)
	;Debug.Messagebox("Event: " + asEventName)
	If asEventName == "AddToInventory"
		akSource.AddItem(Firewood01, 2)
		ChopCount += 1
		If ChopCount == 2
			Game.FadeOutGame(true, true, 0.0, 8.0)
			Utility.Wait(1.0)
		ElseIf ChopCount >= 3
			(akSource as Actor).PlayIdle(IdleWoodchopExit)
			GameHour.Mod(1.0)
			UnRegForEvents(akSource as Actor)
			Debug.Notification("I spend an hour cutting wood for the fire")
			PlayerRef.AddItem(Firewood01, Utility.RandomInt(12, 24))
		EndIf
	ElseIf asEventName == "IdleFurnitureExit"
		UnRegForEvents(akSource as Actor)
	EndIf
EndEvent

Int ChopCount

Actor Property PlayerRef Auto

Weapon Property Axe01 Auto

Form Property Firewood01 Auto

Idle Property IdleWoodchopExit  Auto  

GlobalVariable Property GameHour Auto

pchsWtUtil Property Util Auto
