Scriptname pchsZazFurnPunish extends Quest  

Event OnUpdateGameTime()
	PlayerZazFurnPunishEnd()
EndEvent

Function PlayerZazFurnPunishBegin(Float Duration, ObjectReference akFurniture = None)
	Self.Start()
	EggShellsOn = pchsEggShellsQuest.IsRunning()
	ToggleTasks(TasksOff = true)
	If !akFurniture
		akFurniture = GetRandomFurn()
	EndIf
	If akFurniture
		akFurniture.Activate(PlayerRef)
		Game.DisablePlayerControls()
		Game.SetPlayerAiDriven(true)
		PlayerRef.SetVehicle(pchsMotherSlaveDogSexMarker)
		RegisterForSingleUpdateGameTime(Duration)
		Debug.Messagebox("Father's tied me in place. All I can do is wait and hope he unbinds me soon...")
	Else
		Debug.Trace("pchs: PlayerZazFurnPunishBegin(): No furniture found")
		Debug.Notification("No furniture found")
		ToggleTasks(TasksOff = false)
		Self.Stop()
	EndIf
EndFunction

Function PlayerZazFurnPunishEnd()
	Game.EnablePlayerControls()
	Game.SetPlayerAiDriven(false)
	PlayerRef.SetVehicle(None)
	ToggleTasks(TasksOff = false)
	Debug.Messagebox("Father undoes my bindings and releases me. \n\nI'm sore all over.\nBut... it's nice...")
	If EggShellsOn
		Utility.Wait(6.0)
		pchsEggShellsQuest.Start()
	EndIf
	Self.Stop()
EndFunction

Function ToggleTasks(Bool TasksOff)
	If TasksOff
		Int TasksSuspend = ModEvent.Create("pchsWartimesTasksSuspend")
		If (TasksSuspend)
			ModEvent.PushForm(TasksSuspend, self)
			ModEvent.Send(TasksSuspend)
		EndIf

	Else
		Int TasksResume = ModEvent.Create("pchsWartimesTasksResume")
		If (TasksResume)
			ModEvent.PushForm(TasksResume, self)
			ModEvent.Send(TasksResume)
		EndIf
	EndIf
EndFunction

ObjectReference Function GetRandomFurn()
	pchsZazFurnScan.Stop()
	Utility.WaitMenuMode(0.1)
	pchsZazFurnScan.Start()
	Return (pchsZazFurnScan.GetNthAlias(0) as ReferenceAlias).GetReference()
EndFunction

Bool EggShellsOn

ObjectReference Property pchsMotherSlaveDogSexMarker Auto

Actor Property PlayerRef Auto

Quest Property pchsZazFurnScan Auto
Quest Property pchsEggShellsQuest Auto
